     Copyright (c) 2021, NVIDIA CORPORATION.  All rights reserved.

NVIDIA CORPORATION and its licensors retain all intellectual property
and proprietary rights in and to this software, related documentation
and any modifications thereto.  Any use, reproduction, disclosure or
distribution of this software and related documentation without an
express license agreement from NVIDIA CORPORATION is strictly
prohibited.


This directory contains all the example programs which are included in
the NVIDIA HPC SDK package.  The examples are organized by feature, with
examples for each feature contained in a seperate subdirectory.

Following is a list of the files in this directory:

  README             This file

  AutoPar            Directory containing auto parallelization examples

  CUDA-Fortran       Directory containing CUDA Fortran examples

  F2003              Directory containing Fortran 2003 examples

  MPI                Directory containing MPI examples

  OpenACC            Directory containing OpenACC examples

  OpenMP             Directory containing OpenMP examples


To build and run the examples within one of these subdirectories using
the 64-bit compilers on a specific <target> (i.e. Linux_x86_64,
Linux_ppc64le, Linux_aarch64, Windows_x86_64), for example, do the
following:

% cd /my/work/dir
% cp -r <path_to_nvhpc>/<target>/2021/examples/AutoPar .
% cd AutoPar

At this point make sure that the compilers are defined within your
path. This can be done using either your shell syntax or by using the
modulefiles included in this release.

% export PATH=<path_to_nvhpc>/<target>/2021/compilers/bin:$PATH
OR
% module load nvhpc/21.3

Now build/run all the tests within the AutoPar subdirectory using the
following command.

% make NTHREADS=4 all

To get further instructions about building/running the tests within one
of the subdirectories type "make" without any arguments.
Typing make will build and run all SDK examples. An individual SDK
example can be built and run by specifying it as the target to make.
For example to build and run just the vectorAdd SDK example, type:

% make vectorAdd

SPDX-FileCopyrightText: Copyright (c) 2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
SPDX-License-Identifier: Apache-2.0

Licensed under the Apache License, Version 2.0 (the "License");
you may not use the files in this directory except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.



The example codes included in this directory are a portion of the code samples
from the companion website to the book "CUDA Fortran for Scientists and Engineers",
both 1st and 2nd editions:

http://store.elsevier.com/product.jsp?isbn=9780124169708

These codes for the first edition are organized by chapter:

Part I - CUDA Fortran Programming

Chapter 1: Introduction
Chapter 2: Performance Measurement and Metrics
Chapter 3: Optimization
Chapter 4: Multi-GPU Programming

Part II - Case Studies

Chapter 5: Monte Carlo Method
Chapter 6: Finite Difference Method
Chapter 7: Applications of Fast Fourier Transform

Appendix C: Calling CUDA C from CUDA Fortran



The codes for the second edition are also organized by chapter:

Part I - CUDA Fortran Programming

Chapter 1 (ch01): Introduction
Chapter 2 (ch02): Correctness, Accuracy and Debugging
Chapter 3 (ch03): Performance Measurement and Metrics
Chapter 4 (ch04): Synchronization
Chapter 5 (ch05): Optimization
Chapter 6 (ch06): Porting Tips and Techniques
Chapter 7 (ch07): Interfacing with CUDA C Code and CUDA Libraries
Chapter 8 (ch08): Multi-GPU Programming

Part II - Case Studies

Chapter 9  (ch09): Monte Carlo Method
Chapter 10 (ch10): Finite Difference Method
Chapter 11 (ch11): Applications of Fast Fourier Transform
Chapter 12 (ch12): Ray Tracing

Introduction
------------
    For certain specific operations, tensor cores offer a 4x performance speedup
    over typical CUDA GPU core programming.  Those specific operations are
    currently matrix multiply operations of two forms.  The first, simpler form:

      Fortran: C = Matmul(A, B), where
        A is a 2 dimensional array dimensioned A(m,k)
        B is a 2 dimensional array dimensioned B(k,n)
        C is a 2 dimensional array dimensioned C(m,n)
        C(i,j) = sum(a(i,:) * b(:,j)), for i=1,m, j=1,n

    A more general form which tensor cores support in hardware, is:
      Fortran: D = C + Matmul(A, B), where
        A, B, C are defined as above.
        D is a 2 dimensional array dimensioned D(m,n), similar to C.

    The tensor core unit itself currently supports 3 combinations of sizes
    for m, n, and k.  The current CUDA naming practice is to run the sizes
    together, so we will refer to them here as m16n16k16, m8n32k16, and
    m32n8k16.  Note that k, the inner dot-product dimension, is currently
    always 16.  For GPU memory arrays of different dimensions than these,
    it is the programmers' responsibility to add padding and blocking.

    We've created a CUDA Fortran device module named WMMA (Warp-Matrix-Multiply-Add). 
    This is the name of the CUDA C++ namespace, and is used like this in CUDA C++:

       wmma::fragment<wmma::accumulator, WMMA_M, WMMA_N, WMMA_K, float> c_frag;

    In Fortran, in the declaration section of your device subroutines and
    functions, you add this line to enable the tensor core functionality:

       use wmma

Data Declaration
----------------
    The most synonymous translation of the C++ declaration above to Fortran
    would be to use parameterized derived types, i.e. the c_frag would be
    declared like this:

      type(fragment(wmmatype=acc, m=WMMA_M, n=WMMA_N, k=WMMA_K, kind=4)) :: c_frag

    We've currently chosen to NOT go that route.  The current implementation of
    nvfortran stores the derived type parameters within the derived type, as
    derived type parameter enquiry must be supported by the language
    implementation, i.e. "print *,c_frag%m" must work.  Storing all of these
    parameters takes up a lot of register space, which adversely affects
    performance on a register-limited GPU.

    The WMMA module defines derived types that have this form:

      type(subMatrixC_m16n16k16_Real4) :: c_frag

    In 2019, we recommend developers use the macros we have provided in
    these examples.  We've determined that through macro pre-processing we
    can generate either the parameterized derived type declaration or the
    specific type with the same code base.  Here is the declaration we use
    before macro pre-processing:
      WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind4) :: c_frag

    In both CUDA C++, and CUDA Fortran, it is important for performance
    reasons that the underlying operations can be called quickly without
    any runtime parameter enquiry overhead.  Using C++ templates and these
    specific Fortran types allows for that.

    The A and B subMatrix types must be distinct.  In addition, as part of their
    declaration, they must be defined to be stored internally as either column
    major or row major.  Our implementation today only supports real(2) data.
    The macro declarations look like this, where WMMAColMajor and WMMARowMajor
    are defined in the WMMA module:

      WMMASubMatrix(WMMAMatrixA, 16, 16, 16, Real, WMMAColMajor) :: sa
      WMMASubMatrix(WMMAMatrixB, 16, 16, 16, Real, WMMARowMajor) :: sb

    Declaring B to be row major and using it in a Matmul operation is equivalent
    to this Fortran statement:
      C = Matmul(A, Transpose(B))

    Likewise, declaring A to be row major is equivalent to this;
      C = Matmul(Transpose(A), B)

    The C subMatrix is not declared with storage order, but it can be loaded
    and stored to memory in either order.  For instance, storing the C result,
    computed in column major order, in row major order is equivalent to this:
      C = Transpose(Matmul(A,B))

    Users of the BLAS dgemm and other *gemm routines will recognize these
    transpose capabilities.

    For both the larger matrices stored in CUDA global memory, and for operating
    on the individual elements of the subMatrices, we use a 16-bit data type,
    which at some point soon in the future will be real(2).  Until then, we have
    created other macros, which developers may use while they get started using
    tensor cores.  This is a straight-forward translation, and so for the entire
    declaration section of the simplest use case, it looks like this:
      use wmma
      CUFReal2, device :: a(m,k)
      CUFReal2, device :: b(k,n)
      real(4), device :: c(m,n)
      WMMASubMatrix(WMMAMatrixA, 16, 16, 16, Real, WMMAColMajor) :: sa
      WMMASubMatrix(WMMAMatrixB, 16, 16, 16, Real, WMMAColMajor) :: sb
      WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind4)    :: sc

WMMA Basic Operations
---------------------
    At the most basic level, to use the tensor cores, you just load the input
    subMatrices from global memory, compute C = Matmul(A,B), and store the
    result back to memory.  The simplest use of the declarations above looks
    like this in Fortran:
      call wmmaLoadMatrix(sa, a(1,1), m)
      call wmmaLoadMatrix(sb, b(1,1), k)
      call wmmaMatmul(sc, sa, sb)
      call wmmaStoreMatrix(c(1,1), sc, m)

    We've named each of these subroutines starting with "wmma" because they
    require every thread of the warp to make the call, and the threads in the
    warp will cooperate to do the work.

    The wmmaLoadMatrix subroutine takes as arguments the derived type to fill,
    the address of the global or shared memory upper left corner, and the stride
    between columns.  The stride is required and corresponds to the lda, ldb,
    and ldc arguments in *gemm BLAS calls.

    The wmmaMatmul subroutine can take 3 or 4 arguments.  These uses are most
    typical:
      call wmmaMatmul(sc, sa, sb)
      call wmmaMatmul(sc, sa, sb, sc)
      call wmmaMatmul(sd, sa, sb, sc)
    As mentioned above, A and B are always real(2), but can be any combination
    of column major or row major ordered.  C and D can be any combination of
    real(2) and real(4).

    The wmmaStoreMatrix is the partner to wmmaLoadMatrix.  The upper left corner
    in global or shared memory is the first argument.  Then the type, then the
    stride.  The A and B subMatrix types cannot be stored, only C.  A fourth
    argument is optional, and specifies the layout, either column major (the
    default) or row major when the store occurs.

WMMA Advanced Operations
------------------------
    We've added some additional warp-level functionality, and expect to work
    with our early adopters to fill in the gaps.  The problems we expect
    developers to encounter include how to detect numeric issues, and how
    to potentially fix them up within device kernels.

    Treating the derived type subMatrices as just 2D numeric arrays through
    overloaded functions can solve some of these problems.  Here are some
    things we've added.

    1. Logical operations:
       You can declare, or even generate without declaring, logical, kind=1,
       WMMA subMatrixC types.  This allows logical operations between two
       WMMAMatrixC types, or between one C type and a scalar.  These logical
       results can then be passed, in turn, to Fortran intrinsic functions like
       Merge(), and reductions like Any(), All(), and Count().  The code for
       that looks like this:
         WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind4)    :: sd
         ...
         call wmmaMatmul(sd, sa, sb, sc)
         if (wmmaAll(sd .lt. 64.0)) then
           . . .
         npos = wmmaCount(sd .ge. 0.0)
           . . .
         call wmmaMerge(sc, -99.0, sd, mask=sd.eq.sc)

       If you would prefer to use the common Fortran names, you can rename the
       local name on the use statement like this:
         use wmma, any => wmmaAny, all => wmmaAll

       Remember in our naming convention, functions and subroutines that start
       with "wmma" imply the work is shared amongst the threads in a warp.

       Merge() is a subroutine, while count(), any(), and all() are functions.
       In general, subprograms which natively return less than a 64-bit scalar
       are okay as device functions.  We prefer to make array-valued subprograms
       and those returning large derived types subroutines for performance
       reasons, and the returned value or intent(out) array or object is
       typically the first argument..

    2. Assignment
       Initializing a subMatrix to zero is a basic operation:
         sc = 0.0
       You can also assign one subMatrixC type to another:
         sc = sd

Operations on the WMMA Underlying Data
--------------------------------------
    We have settled on the name of the data held under the derived types to
    be "x".  The size of that data and how it maps to the original matrix
    locations may be subject to change.  Operations on that data should be
    elemental and applied uniformly by all threads in the warp.  We expect
    something like the following should always be safe:

        WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind4) :: sd
        real(4), device :: xoff, xtol
        ...
        do klp = 1, maxtimes
          if (wmmaAny(sd .gt. xtol)) then
            do i = 1, size(sd%x)
              sd%x(i) = sd%x(i) - xoff
            end do
          end if
        end do

    For the equivalent functionality using the current implementation when
    kind=2, declare the local scalars using the macro:

        WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind2) :: sd
        CUFReal2 :: xoff, xtol, xtmp
        ...
        xoff = CUFreal(10, kind=2)
        ...
        do klp = 1, maxtimes
          if (wmmaAny(sd .gt. xtol)) then
            do i = 1, size(sd%x)
              ! CUFReal2 arithmetic has to be done on scalars for now
              xtmp = sd%x(i)
              sd%x(i) = xtmp - xoff
            end do
          end if
        end do

    Note that we've defined a function named CUFreal() to perform type
    conversions.  Three specific cases are currently implemented:
         real2 = CUFReal(int4,  kind=2)
         real2 = CUFReal(real4, kind=2)
         real4 = CUFReal(real2, kind=4)
    We expect this function to change to the Fortran intrinsic real() when
    we add real(2) support to the language in an upcoming release.  The
    macro can be redefined at that point.

    For the most advanced users, and for top performance, you should operate
    on the 16-bit data two at a time.  We have an experimental module, named
    vector_types, which we have provided to interested users.  Using a vector
    of real(2) of length 2, in combination with cray pointers, results in
    very efficient updates of the subMatrix data:

        use vector_types
        WMMASubMatrix(WMMAMatrixC, 16, 16, 16, Real, WMMAKind2)    :: sd
        CUFVector(N2, Real, 2), device :: cv, dc(*)
        pointer(dp, dc)
        CUFReal2 :: xoff

        dp = loc(sd%x(1))
        xoff = CUFreal(10, kind=2)
        cv = makeCUFVector(xoff,xoff)
        do klp = 1, maxtimes
          if (wmmaAny(sd .gt. xtol)) then
            do i = 1, size(sd%x)/2
              dc(i) = dc(i) - cv
            end do
          end if
        end do

    For efficiency, we also support using the hardware fma operations for both
    the CUFReal2 type and the vector of two real(2) types, i.e.
      d = __fma_rn(a, b, c), which is d = a*b+c.

Host-side Support For Tensor Core Programming
---------------------------------------------
    Host-side support is limited.  For our testing purposes, we have created
    a few functions which have shared in this PGI examples area under the
    Utils directory.  Modern X86 processors support real(4) <-> real(2) type
    conversion uing SSE instructions, and our test code takes advantage of that
    when possible.  The cpuid feature to key on is "f16c", and we have a function
    in our runtime to test that.  We have also written a scalar version of
    half2float() and float2half(), the latter taking the current CPU rounding
    mode into account.

    We have versions of these two conversion functions which take 1D and 2D
    arrays, which is nice for testing purposes.  These should go away once
    real(2) support is in the compiler, but the code can be used as a guide.


Provided Tests
--------------
    The tests are divided into three directories, to correspond to the three
    matrix sizes currently supported.

In m16n16k16:
  wmma1.CUF: Simplest example, multiply two 16x16 real(2) arrays, real(4) result.
  wmma2.CUF: A Submatrix is row major, real(2) result
  wmma3.CUF: A, B Submatrix is row major, real(2) result
  wmma4.CUF: C Submatrix is real(2), D is real(4)
  wmma5.CUF: Store C Submatrix as row major, real(4) result
  wmma6.CUF: Use Submatrix comparison, merge
  wmma7.CUF: Use Submatrix comparison, all
  wmma8.CUF: Use Submatrix comparison, any, v2real2

In m32n8k16:
  wmma1.CUF: Simplest example, 32x16 X 16x8 real(2) arrays, real(4) result.
  wmma2.CUF: B Submatrix is row major, real(2) result
  wmma3.CUF: A, B Submatrix is row major, real(4) result
  wmma4.CUF: C Submatrix is real(2), D is real(4)
  wmma5.CUF: Store C Submatrix as row major, real(4) result
  wmma6.CUF: Use Submatrix comparison, merge
  wmma7.CUF: Use Submatrix comparison, all
  wmma8.CUF: Use Submatrix comparison, count, v2real2

In m8n32k16:
  wmma1.CUF: Simplest example, 8x16 X 16x32 real(2) arrays, real(4) result.
  wmma2.CUF: A Submatrix is row major, real(2) result
  wmma3.CUF: B Submatrix is row major, real(4) result
  wmma4.CUF: C Submatrix is real(2), D is real(4)
  wmma5.CUF: Store C Submatrix as row major, real(4) result
  wmma6.CUF: Use Submatrix comparison, merge
  wmma7.CUF: Use Submatrix comparison, count
  wmma8.CUF: Use Submatrix comparison, any, v2real2

#
#     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# NVIDIA CORPORATION and its licensors retain all intellectual property
# and proprietary rights in and to this software, related documentation
# and any modifications thereto.
# 


The examples in this chapter demonstrate two different approaches to
multi-GPU programming.  The first approach uses the peer-to-peer
capabilities in CUDA Fortran, and the examples for this approach are in
the P2P subdirectory.  The peer-to-peer approach can be used on a
single compute node containing multiple GPUs.  

The second approach to multi-GPU computing uses MPI, or more
precisely CUDA-aware MPI implementations.  These examples are located
in the MPI subdirectory.  Relative to the peer-to-peer approach,
multi-GPU programming via MPI is more flexible regarding the types of
systems used as the GPUs can be contained within a single node or
distributed across multiple nodes, or a combination of both.  

For the P2P examples, the only software required is the NVHPC Fortran
compiler.  For the MPI examples, in addition to the NVHPC Fortran
compiler one also requires an MPI software stack.  MPI implementations
usually provide a script/binary called mpicc and mpif90 that will
compile MPI programs and link all the required libraries. Many
supercomputing centers will have MPI already preinstalled on their
clusters.

This Readme file explains the steps required to install MVAPICH, a
CUDA-aware MPI implementation.  Other MPI implementations will require
different set-up procedures, but the essential issue to keep in mind
is that the underlying Fortran compiler should be the NVHPC Fortran
compiler. 


************************
* Installing MVAPICH:  *
************************

1) Download the latest MVAPICH:
   
The tar file is available from the MVAPICH web site:

http://mvapich.cse.ohio-state.edu/download/mvapich2
 
2) Install libraries for network adapter

Depending on the network adapter used in your system, you may need to
install associated development libraries.  For example, for Infiniband
there are two packages, libibverbs and libibverbs-devel, that are
required to install MVAPICH.  These can be downloaded by:

% yum install libibverbs

and

% yum install libibverbs-devel


3) Configure MVAPICH:

Due to compatibility issues between CUDA and the NVHPC C compiler, we
are going to use gcc for the C compiler and NVHPC Fortran for the
Fortran compiler. We need to specify the location of the CUDA include
files and libraries (in this case, we assume they are located in the
standard location /usr/local/cuda ) and the path where the MVAPICH
binaries, libraries, and include files will be installed (in this case
/share/apps/mvapich2-gpu, a filesystem accessible from all the cluster
nodes).  These can be configured by issuing the following command from
the installation directory containing the configure file:

% FC=nvfortran F77=nvfortran FCFLAGS=-fast FFLAGS=-fast ./configure  \
  --prefix=/share/apps/mvapich2-gpu  \
  --enable-cuda  \
  --with-cuda-include=/usr/local/cuda/include  \
  --with-cuda-libpath=/usr/local/cuda/lib64  \
  --without-hwloc 

There are many other configuration options that vary according to the
network adapter and protocal used.  These are discussed at great
length in the MVAPICH2 User's Guide.  The above options are related to
configuring a CUDA-aware build that enables GPU-GPU communication with
CUDA Fortran.


4) Build and install MVAPICH:

The next steps are to run "make" and then "make install".  For this
last step, depending on the location of the installed software, you
may need to have root privileges.


5) Add the location of the binaries to your path
   
% export PATH=/share/apps/mvapich2-gpu/bin:$PATH


6) Running CUDA-aware MPI applications with MVAPICH

In order to use the CUDA-aware features of MVAPICH, one needs to set the
environment variable MV2_USE_CUDA to 1.  This can either be done in the 
shell:

% export MV2_USE_CUDA=1

or as an argument to the mpirun_rsh command:

% mpirun_rsh -n 2 host1 host2 MV2_USE_CUDA=1 ./mvaApp



*************************
* mpicc with NVC        *
*************************

If there is the need to use mpicc with the NVHPC C compiler to compile
CUDA C files, the following flags are required:

-D__align__\(n\)=__attribute__\(\(aligned\(n\)\)\) -D__location__\(a\)=__annotate__\(a\)  -DCUDARTAPI=  -D__x86_64

! 
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 

program main
    use openacc
    implicit none
    integer :: n        ! size of the vector
    real,dimension(:),allocatable :: a  ! the vector
    real,dimension(:),allocatable :: r  ! the results
    real,dimension(:),allocatable :: e  ! expected results
    integer :: i, j, nerrors
    integer :: c0, c1, c2, c3, cgpu, chost
    character(10) :: arg1
    if( command_argument_count() .gt. 0 )then
	call get_command_argument( 1, arg1 )
	read(arg1,'(i10)') n
    else
	n = 1000000
    endif
    if( n .le. 0 ) n = 1000000
    allocate(a(n))
    allocate(r(n))
    allocate(e(n))
    do i = 1,n
	a(i) = i*2.0
    enddo
do j = 1, 3
    !call acc_init( acc_device_nvidia )
    call system_clock( count=c1 )
    !$acc kernels loop
	do i = 1,n
	    r(i) = sin(a(i)) ** 2 + cos(a(i)) ** 2
	enddo
    call system_clock( count=c2 )
    cgpu = c2 - c1
	do i = 1,n
	    e(i) = sin(a(i)) ** 2 + cos(a(i)) ** 2
	enddo
    call system_clock( count=c3 )
    chost = c3 - c2
    ! check the results
    nerrors = 0
    do i = 1,n
	if( abs(r(i) - e(i)) .gt. 0.000001 )then
	    print *, i, r(i), e(i)
            nerrors = nerrors + 1
	endif
    enddo
    print *, n, ' iterations completed'
    print *, cgpu, ' microseconds on GPU'
    print *, chost, ' microseconds on host'
    if (nerrors .ne. 0) then
       print *, "Test FAILED"
    else
       print *, "Test PASSED"
    endif
enddo
end program

!
!     Copyright (c) 2019, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!
!          THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT
!   WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT
!   NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
!   FITNESS FOR A PARTICULAR PURPOSE.
!
#ifdef NOCUDA
#define FUNCTIONTYPE 
#else
#define FUNCTIONTYPE attributes(device)
#endif 

#define WMMAREAL2 real(2)

MODULE VECTOR_TYPES

TYPE V2REAL2
  WMMAREAL2 :: x, y
END TYPE

TYPE V4REAL2
  WMMAREAL2 :: x, y, z, w
END TYPE

TYPE V2REAL4
  REAL(4) :: x, y
END TYPE

TYPE V3REAL4
  REAL(4) :: x, y, z
END TYPE

TYPE V4REAL4
  REAL(4) :: x, y, z, w
END TYPE

TYPE V2REAL8
  REAL(8) :: x, y
END TYPE

TYPE V2LOGICAL2
  LOGICAL(2) :: x, y
END TYPE

TYPE CUFRealVector(kind, length)
  REAL(kind) :: x(length)
  INTEGER, kind :: kind, length
END TYPE

TYPE CUFLogicalVector(kind, length)
  LOGICAL(kind) :: x(length)
  INTEGER, kind :: kind, length
END TYPE

! Make the types from the component parts
!------------------------------------------------------------------------------
interface makeCUFVector
  FUNCTIONTYPE function __pgi_make_v2real2(x, y) bind(C) result(v)
  import V2REAL2
  WMMAREAL2 :: x, y
  type(V2REAL2) :: v
  end function

  FUNCTIONTYPE function __pgi_make_v2real4(x, y) bind(C) result(v)
  import V2REAL4
  real(4), value :: x, y
  type(V2REAL4) :: v
  end function

  FUNCTIONTYPE function __pgi_make_v3real4(x, y, z) bind(C) result(v)
  import V3REAL4
  real(4), value :: x, y, z
  type(V3REAL4) :: v
  end function

  FUNCTIONTYPE function __pgi_make_v4real4(x, y, z, w) bind(C) result(v)
  import V4REAL4
  real(4), value :: x, y, z, w
  type(V4REAL4) :: v
  end function

  FUNCTIONTYPE function __pgi_make_v2real8(x, y) bind(C) result(v)
  import V2REAL8
  real(8), value :: x, y
  type(V2REAL8) :: v
  end function
end interface

! V2REAL2 Assignment
!------------------------------------------------------------------------------
interface assignment(=)
  FUNCTIONTYPE subroutine __pgi_assgn1_v2real2(y,x) bind(c)
  import V2REAL2
  type(V2REAL2), intent(out) :: y
  WMMAREAL2, dimension(2), intent(in) :: x
  end subroutine
  FUNCTIONTYPE subroutine __pgi_assgn2_v2real2(y,x) bind(c)
  import V2REAL2
  WMMAREAL2, dimension(2), intent(out) :: y
  type(V2REAL2), intent(in) :: x
  end subroutine
  FUNCTIONTYPE subroutine __pgi_assgn3_v2real2(y,x) bind(c)
  import V2REAL2
  type(V2REAL2), intent(out) :: y
  real(4), value, intent(in) :: x
  end subroutine
end interface

! V2REAL2 Arithmetic
!------------------------------------------------------------------------------
interface operator(-)
  FUNCTIONTYPE function __pgi_negate_v2real2(x) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x
  type(V2REAL2) :: v
  end function

  FUNCTIONTYPE function __pgi_sub_v2real2(x, y) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2REAL2) :: v
  end function
end interface

interface operator(+)
  FUNCTIONTYPE function __pgi_add_v2real2(x, y) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2REAL2) :: v
  end function
end interface

interface operator(*)
  FUNCTIONTYPE function __pgi_mul_v2real2(x, y) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2REAL2) :: v
  end function
end interface

interface operator(/)
  FUNCTIONTYPE function __pgi_div_v2real2(x, y) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2REAL2) :: v
  end function
end interface

interface __fma_rn
  FUNCTIONTYPE function __pgi_fma_v2real2(x, y, z) bind(C) result(v)
  import V2REAL2
  type(V2REAL2), intent(in) :: x, y, z
  type(V2REAL2) :: v
  end function
end interface

! V2REAL2 Comparisons
!------------------------------------------------------------------------------
interface operator(.eq.)
  FUNCTIONTYPE function __pgi_cmpeq_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.ne.)
  FUNCTIONTYPE function __pgi_cmpne_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.gt.)
  FUNCTIONTYPE function __pgi_cmpgt_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.lt.)
  FUNCTIONTYPE function __pgi_cmplt_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.ge.)
  FUNCTIONTYPE function __pgi_cmpge_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.le.)
  FUNCTIONTYPE function __pgi_cmple_v2real2(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

! V2REAL2 Comparisons against scalars
!------------------------------------------------------------------------------
interface operator(.eq.)
  FUNCTIONTYPE function __pgi_cmpeq_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.ne.)
  FUNCTIONTYPE function __pgi_cmpne_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.gt.)
  FUNCTIONTYPE function __pgi_cmpgt_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.lt.)
  FUNCTIONTYPE function __pgi_cmplt_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.ge.)
  FUNCTIONTYPE function __pgi_cmpge_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.le.)
  FUNCTIONTYPE function __pgi_cmple_v2realr(x, y) bind(C) result(v)
  import V2REAL2, V2LOGICAL2
  type(V2REAL2), intent(in) :: x
  real(4), value :: y
  type(V2LOGICAL2) :: v
  end function
end interface

! V2Logical2 Operations
!------------------------------------------------------------------------------
interface operator(.not.)
  FUNCTIONTYPE function __pgi_lognot_v2logical2(x) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.and.)
  FUNCTIONTYPE function __pgi_logand_v2logical2(x, y) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.or.)
  FUNCTIONTYPE function __pgi_logor_v2logical2(x, y) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.eqv.)
  FUNCTIONTYPE function __pgi_logeqv_v2logical2(x, y) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface operator(.neqv.)
  FUNCTIONTYPE function __pgi_logneqv_v2logical2(x, y) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x, y
  type(V2LOGICAL2) :: v
  end function
end interface

interface any
  FUNCTIONTYPE function __pgi_any_v2logical2(x) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x
  logical :: v
  end function
end interface

interface all
  FUNCTIONTYPE function __pgi_all_v2logical2(x) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x
  logical :: v
  end function
end interface

interface count
  FUNCTIONTYPE function __pgi_count_v2logical2(x) bind(C) result(v)
  import V2LOGICAL2
  type(V2LOGICAL2), intent(in) :: x
  integer :: v
  end function
end interface

END MODULE

program managedCUF
  !@cuf use cudafor
  implicit none
  integer, parameter :: nx=1024, ny=512
  integer :: a(nx,ny)
  !@cuf	attributes(managed):: a	
  integer :: b, i ,j
    
  a = 1
  b = 3 
  !$cuf kernel do (2) <<<*,*>>>
  do j=1,ny
     do i=1,nx
        a(i,j)=a(i,j)+b
     end do
  end do
  !@cuf	i=cudaDeviceSynchronize()

  !@cuf print *, "Running CUDA version ..."
  if(any(a /= 4)) then
     print *, "**** Program Failed ****"
  else
     print *, "Program Passed"
  end if
end program managedCUF

! 
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 

program main
    implicit none
    integer :: n        ! size of the vector
    real,dimension(:),allocatable :: a, r, e
    integer :: i, nerrors
    character(10) :: arg1
    if( command_argument_count() .gt. 0 )then
        call get_command_argument( 1, arg1 )
        read(arg1,'(i10)') n
    else
        n = 100000
    endif
    if( n .le. 0 ) n = 100000
    allocate(a(n), r(n), e(n))
    do i = 1,n
        a(i) = i*2.0
    enddo
    !$omp target teams loop
        do i = 1,n
            r(i) = a(i) * 2.0
        enddo

        do i = 1,n
            e(i) = a(i) * 2.0
        enddo
    ! check the results
    nerrors = 0
    do i = 1,n
        if( r(i) .ne. e(i) )then
            print *, i, r(i), e(i)
            print *, "Test FAILED"
            stop 'error found'
        endif
    enddo
    print *, n, 'iterations completed'
    if (nerrors .eq. 0) then
       print *, "Test PASSED"
    endif
end program

program testsort
call dosort(100)
call dosort(500)
call dosort(1000)
call dosort(5000)
end
!
subroutine dosort(n)
use curand
use openacc
interface isort
    subroutine isortf(array, idx, n, stream) &
                       bind(C,name='thrust_float_sort_wrapper')
    import acc_handle_kind
    real, dimension(*), intent(in) :: array
    integer, dimension(*), intent(out) :: idx
    integer, value :: n
    integer(kind=acc_handle_kind), value :: stream
    end subroutine
end interface
real :: a(n), b(n)
integer :: idx(n)
type(curandGenerator) :: g
integer(kind=acc_handle_kind) :: istream
a = 0.0
istream = acc_get_cuda_stream(acc_async_sync)
!$acc data copy(a) create(b, idx)
  istat = curandCreateGenerator(g,CURAND_RNG_PSEUDO_XORWOW)
  istat = curandSetStream(g,istream)
  !$acc host_data use_device(a, idx)
    istat = curandGenerate(g, a, n)
    call isort(a, idx, n, istream)
  !$acc end host_data
  !$acc kernels
  x = sum(merge(a, 0.0, (idx/2)*2.ne.idx))
  y = sum(merge(a, 0.0, (idx/2)*2.eq.idx))
  z = sum(a)
  !$acc end kernels
!$acc end data
istat = curandDestroyGenerator(g)
print *,x,y,z,z-(x+y)
if (z-(x+y).lt.1e-4) then
  print *,"test PASSED"
else
  print *,"test FAILED"
endif
end

module rayTracing
#ifdef _CUDA
  use rgbCUDA
  use curand_device
  use cudafor
#else
  use rgbHost
#endif
  
#ifdef _CUDA
#define c_hostDevPtr c_devptr
#define c_hostDevLoc c_devloc
#else
#define c_hostDevPtr c_ptr
#define c_hostDevLoc c_loc
#endif
  
  use iso_c_binding

  ! anti-aliasing parameter
  integer :: nRaysPerPixel
  !@cuf attributes(managed) :: nRaysPerPixel

  !@cuf type(curandStateXORWOW), device, allocatable :: randState_d(:,:)

  
  type ray
     real :: origin(3)
     real :: dir(3)
  end type ray
  
  interface ray
     module procedure rayConstructor
  end interface ray

  ! material types

  enum, bind(c)
     enumerator :: lambMat = 1, metalMat = 2
  end enum
  
  type lambertian
     type(rgb) :: albedo
  end type lambertian

  type metal
     type(rgb) :: albedo
     real :: fuzz
  end type metal
  
  ! objects

  type sphere
     real :: center(3), radius
     integer :: materialType
     type(c_hostDevPtr) :: matPtr
  end type sphere

  type environs
     integer :: nSpheres
     type(sphere), &
          !@cuf managed, &
          allocatable :: spheres(:)
  end type environs

  type hitRecord
     real :: t
     real :: p(3)
     real :: normal(3)
     integer :: materialType
     type(c_hostDevPtr) :: matPtr
  end type hitRecord

  type camera
     real :: lowerLeftCorner(3)
     real :: horizontal(3)
     real :: vertical(3)
     real :: origin(3)
  end type camera

  interface randomNumber
     module procedure :: rngScalar, rngArray
  end interface randomNumber

contains

#ifdef _CUDA
  attributes(device) function rngScalar() result(res)
    implicit none
    real :: res
    integer :: i, j
    type(curandStateXORWOW) :: h
    i = (blockIdx%x-1)*blockDim%x + threadIdx%x
    j = (blockIdx%y-1)*blockDim%y + threadIdx%y
    h = randState_d(i,j)
    res = curand_uniform(h)
    randState_d(i,j) = h
  end function rngScalar

  attributes(device) function rngArray(n) result(res)
    implicit none
    integer, intent(in) :: n
    real :: res(n)
    integer :: i, j, k
    type(curandStateXORWOW) :: h
    i = (blockIdx%x-1)*blockDim%x + threadIdx%x
    j = (blockIdx%y-1)*blockDim%y + threadIdx%y
    h = randState_d(i,j)
    do k = 1, n
       res(k) = curand_uniform(h)
    end do
    randState_d(i,j) = h
  end function rngArray
#else
  function rngScalar() result(res)
    real :: res
    call random_number(res)
  end function rngScalar

  function rngArray(n) result(res)
    integer, intent(in) :: n
    real :: res(n)
    call random_number(res)
  end function rngArray
#endif

  !@cuf attributes(device) &
  function randomPointInUnitSphere() result(res)
    implicit none
    real :: res(3)
    do
       res = randomNumber(3)
       res = 2*res - 1.0
       if (sum(res**2) <= 1.0) exit
    enddo
  end function randomPointInUnitSphere
  
  subroutine environsAlloc(env)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    allocate(env%spheres(env%nSpheres))
  end subroutine environsAlloc

  !@cuf attributes(device) &
  function normalize(a) result(res)
    implicit none
    real :: a(3), res(3)

    res = a/sqrt(sum(a**2))
  end function normalize

  !@cuf attributes(device) &
  function rayConstructor(origin, dir) result(r)
    implicit none
    !dir$ ignore_tkr (d) origin, (d) dir
    real :: origin(3), dir(3)
    type(ray) :: r
    r%origin = origin
    r%dir = normalize(dir)
  end function rayConstructor

  !@cuf attributes(device) &
  function reflect(rin, n) result(res)
    implicit none
    type(ray) :: rin
    real :: n(3)
    real :: res(3)
    res = rin%dir - 2.0*dot_product(rin%dir,n)*n
  end function reflect

  
  !@cuf attributes(device) &
  function scatter(rin, rec, attenuation, rscattered) result(res)
    implicit none
    type(ray) :: rin
    type(hitRecord) :: rec
    type(rgb) :: attenuation
    type(ray) :: rscattered
    logical :: res

    type(lambertian) :: lambPtr; pointer(lambCrayP, lambPtr)
    type(metal) :: metalPtr;     pointer(metalCrayP, metalPtr)
    real :: n(3), dir(3)

    if (rec%materialType == lambMat) then
       n = normalize(rec%normal)
       dir = n + randomPointInUnitSphere()
       rscattered = ray(rec%p, dir)
       lambCrayP = transfer(rec%matPtr, lambCrayP)
       attenuation = lambPtr%albedo
       res = .true.
    else if (rec%materialType == metalMat) then
       n = normalize(rec%normal)
       metalCrayP = transfer(rec%matPtr, metalCrayP)
       dir = reflect(rin, n) + metalPtr%fuzz*randomPointInUnitSphere()
       rscattered = ray(rec%p, dir)
       attenuation = metalPtr%albedo
       res = (dot_product(rscattered%dir, n) > 0)
    end if
        
  end function scatter

  !@cuf attributes(device) &
  function hitSphere(s, r, tmin, tmax, rec) result(res)
    implicit none
    type(sphere) :: s
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    real :: oc(3), a, b, c, disc, t

    oc = r%origin - s%center
    a = dot_product(r%dir, r%dir)
    b = 2.0*dot_product(r%dir, oc)
    c = dot_product(oc, oc) - s%radius**2
    disc = b**2 - 4.0*a*c
    if (disc >= 0.0) then
       t = (-b -sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          rec%materialType = s%materialType          
          rec%matPtr = s%matPtr
          res = .true.
          return
       end if
       t = (-b +sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          rec%materialType = s%materialType
          rec%matPtr = s%matPtr
          res = .true.
          return
       end if
    end if
    res = .false.
  end function hitSphere

  !@cuf attributes(device) &
  function hitEnvirons(env, r, tmin, tmax, rec) result(res)
    implicit none
    type(environs) :: env
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    type(hitRecord) :: recl
    integer :: i
    real :: closest

    closest = tmax
    res = .false.

    do i = 1, env%nSpheres
       if (hitSphere(env%spheres(i), r, tmin, closest, recl)) then
          res = .true.
          rec = recl
          closest = recl%t
       end if
    end do
  end function hitEnvirons

  !@cuf attributes(device) &
  function color(r, env) result(res)
    implicit none
    integer, parameter :: maxDepth = 50
    real, parameter :: shadowAcne = 0.001
    type(ray) :: r
    type(environs) :: env
    type(rgb) :: res

    type(ray) :: lRay, scRay
    type(hitRecord) :: rec
    real :: t, n(3)
    type(rgb) :: attenuation, scAtten
    integer :: depth
    
    attenuation = [1.0, 1.0, 1.0]
    lRay = r

    res = [0.0, 0.0, 0.0]
    do depth = 1, maxDepth
       if (hitEnvirons(env, lRay, shadowAcne, huge(t), rec)) then
          if (scatter(lray, rec, scAtten, scRay)) then
             attenuation = scAtten*attenuation
             lRay = scRay
          else
             res = [0.0, 0.0, 0.0]
             return
          endif
       else
          t = 0.5*(lray%dir(2) + 1.0)  
          res = rgb((1.0-t)*[1.0, 1.0, 1.0] + t*[0.5, 0.7, 1.0])
          res = res * attenuation
          return
       endif
    end do
  end function color

#ifdef _CUDA  
  attributes(global) subroutine renderKernel(fb, nx, ny, env, cam)

    implicit none
    type(rgb) :: fb(nx,ny)
    integer, value :: nx, ny
    type(environs) :: env
    type(camera) :: cam
    
    type(ray) :: r
    real :: dir(3)
    real :: u, v
    integer :: i, j

    integer :: ir
    type(rgb) :: c   

    type(curandStateXORWOW) :: h
    integer(8) :: seed, seq, offset
    
    i = threadIdx%x + (blockIdx%x-1)*blockDim%x
    j = threadIdx%y + (blockIdx%y-1)*blockDim%y

    if (i <= nx .and. j <= ny) then

       ! initialize RNG
       seed = nx*(j-1) + i + 4321
       seq = 0
       offset = 0
       call curand_init(seed, seq, offset, randState_d(i,j))
    
       c = [0.0, 0.0, 0.0]
       do ir = 1, nRaysPerPixel
          u = (real(i-1)+randomNumber())/nx
          v = (real(j-1)+randomNumber())/ny
          dir = cam%lowerLeftCorner + &
               u*cam%horizontal + v*cam%vertical - cam%origin
          r = ray(cam%origin, dir)
          c = c + color(r, env)
       end do
       fb(i,j) = c/nRaysPerPixel
    end if
  end subroutine renderKernel
#endif
    
  subroutine render(fb, env, cam)
    !@cuf use cudafor
    implicit none
    type(rgb) :: fb(:,:)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    type(camera) :: cam
    !@cuf attributes(managed) :: cam

    type(ray) :: r
    real :: u, v
    integer :: nx, ny, i, j

    integer :: ir
    real :: rn(2)
    type(rgb) :: c
    
    nx = size(fb,1)    
    ny = size(fb,2)

#ifdef _CUDA
    block
      type(rgb), device, allocatable :: fb_d(:,:)
      type(dim3) :: tBlock, grid
      
      allocate(fb_d(nx,ny))
      tBlock = dim3(32,8,1)
      grid = dim3((nx-1)/tBlock%x+1, (ny-1)/tBlock%y+1, 1)
      call renderKernel<<<grid, tBlock>>>(fb_d, nx, ny, env, cam)
      fb = fb_d
      deallocate(fb_d)
    end block
#else    
    do j = 1, ny
       do i = 1, nx
          c = [0.0, 0.0, 0.0]
          do ir = 1, nRaysPerPixel
             call random_number(rn)
             u = (real(i-1) + rn(1))/nx
             v = (real(j-1) + rn(2))/ny
             r = ray(cam%origin, cam%lowerLeftCorner + &
                  u*cam%horizontal + v*cam%vertical - cam%origin)
             c = c + color(r, env)
          end do
          fb(i,j) = c/nRaysPerPixel
       end do
    end do
#endif
  end subroutine render
  
end module rayTracing

program main
  use rayTracing
  implicit none
  integer, parameter :: nx = 400, ny = 200
  integer :: i, j
  type(rgb) :: fb(nx,ny)
  type(environs) :: env
  !@cuf attributes(managed) :: env
  type(camera) :: cam
  !@cuf attributes(managed) :: cam


  type(lambertian)  :: lambArr(2)
  !@cuf attributes(device) :: lambArr
  type(metal) :: metalArr(2)
  !@cuf attributes(device) :: metalArr
  type(c_hostDevPtr) :: cPtr
  
  ! setup environment
  env%nSpheres = 4
  call environsAlloc(env)

  lambArr(1) = lambertian(rgb([0.8, 0.3, 0.3]))
  cPtr = c_hostDevLoc(lambArr(1))
  env%spheres(1) = sphere([0.0, 0.0, -1.0], 0.5, lambMat, cPtr)

  lambArr(2) = lambertian(rgb([0.8, 0.8, 0.0]))
  cPtr = c_hostDevLoc(lambArr(2))
  env%spheres(2) = sphere([0.0, -100.5, -1.0], 100.0, lambMat, cPtr)

  metalArr(1) = metal(rgb([0.8, 0.6, 0.2]), 1.0)
  cPtr = c_hostDevLoc(metalArr(1))
  env%spheres(3) = sphere([1.0, 0.0, -1.0], 0.5, metalMat, cPtr)
  
  metalArr(2) = metal(rgb([0.8, 0.8, 0.8]), 0.3)
  cPtr = c_hostDevLoc(metalArr(2))
  env%spheres(4) = sphere([-1.0, 0.0, -1.0], 0.5, metalMat, cPtr)
  
  ! setup camera
  cam%lowerLeftCorner = [-2.0, -1.0, -1.0]
  cam%horizontal = [4.0, 0.0, 0.0]
  cam%vertical = [0.0, 2.0, 0.0]
  cam%origin = [0.0, 0.0, 0.0]

  ! antialiasing parameter
  nRaysPerPixel = 100
  
  ! allocate RNG state array, initialization done in kernel
  !@cuf allocate(randState_d(nx,ny))
  
  call render(fb, env, cam)
  
  ! ppm output

  print "(a2)", 'P3'   ! indicates RGB colors in ASCII, must be flush left
  print *, nx, ny      ! width and height of image
  print *, 255         ! maximum value for each color
  do j = ny, 1, -1
     do i = 1, nx                
        print "(3(1x,i3))", int(255*sqrt(fb(i,j)%v))
     end do
  end do

end program main

!
!  Copyright (c) 2020-2021, NVIDIA CORPORATION & AFFILIATES.  All rights reserved.
!
!  NVIDIA CORPORATION and its licensors retain all intellectual property
!  and proprietary rights in and to this software, related documentation
!  and any modifications thereto.  Any use, reproduction, disclosure or
!  distribution of this software and related documentation without an express
!  license agreement from NVIDIA CORPORATION is strictly prohibited.
!
!  To port an existing code that calls LAPACK routines to GPU, where the arrays
!  are all declared as allocatable, simply use managed memory by:
!  1. Adding `-stdpar -gpu=managed,nvlamath` to the compile line
!  2. Adding `-stdpar -gpu=managed -cudalib=nvlamath` to the link line

module testUtils

integer(4) :: n, lda, ldb, info
integer(4) :: ii, jj
integer(4) :: cr, t1, t2
integer(4) , parameter :: m    = 2000
character*1, parameter :: jobz = 'V'
character*1, parameter :: uplo = 'U'

contains
   subroutine init
   use cusolverdn
   implicit none
   n   = m
   lda = m
   ldb = m
   call system_clock( count_rate = cr )
   end subroutine init

   subroutine setInput( a, b )
   implicit none
   real(8), intent(out) :: a(m,m), b(m)
   real(8)    :: work( 2*m )
   integer(4) :: i, imax, info, seedsize
   integer(4), allocatable :: seed(:)
   call random_seed()
   call random_seed( size = seedsize )
   allocate( seed( seedsize ) )
   seed = 123
   call random_seed( put = seed )
   call random_number( b )
   a = 0.d0
   do i = 1, m
      imax    = maxloc( b, dim = 1 )
      a(i,i)  = b(imax)
      b(imax) = -100.d0
   enddo
   do i = 1, m
      b(i) = a(i,i)
   enddo
   ! Create test matrix with given eigen-values
   call dlarge( m, a, m, seed, work, info )
   end subroutine setInput

   subroutine checkOutput( b, w )
   implicit none
   real(8), intent(in)    :: b(m)
   real(8), intent(inout) :: w(m)
   integer(4) :: i, imax
   real   (8) :: maxerr
   w = abs(w)
   maxerr = 0.d0
   do i = 1, m
      imax = maxloc( w, dim = 1 )
      maxerr = max( maxerr, abs( b(i) - w(imax) ) )
      w(imax) = -100.d0
   enddo
   print*, 'Max error     :', maxerr

   if ( info .eq. 0 .and. maxerr .lt. 1.e-12 ) then
      print*, "Test PASSED"
   else
      print*, "Test FAILED, max error =", maxerr
   endif
   end subroutine checkOutput

   subroutine startTimer
   implicit none
   call system_clock(t1)
   end subroutine startTimer

   subroutine endTimer
   implicit none
   call system_clock(t2)
   print*, "Time (seconds):", ( t2 - t1 ) / real(cr)
   end subroutine endTimer
end module testUtils

program EigenManagedTest
use testUtils

call init

! Warm-up and creation of cuSOLVER handle
call EigenManaged

! Timing
call EigenManaged

end program EigenManagedTest

subroutine EigenManaged
use testUtils
implicit none

integer(4) :: i, j, lwork, liwork
real   (8), allocatable :: a(:,:), b(:)
integer(4), allocatable :: ipiv(:)
real   (8), allocatable :: w(:), work(:)
integer(4), allocatable :: iwork(:)

! Setup input
allocate(a(m,n))
allocate(b(m))
allocate(w(m))
allocate(work(1))
allocate(iwork(1))

call setInput(a,b)

! Get buffer size
call dsyevd( jobz, uplo, n, a, n, w, work, -1, iwork, -1, info )
lwork  = int(  work( 1 ) )
liwork = int( iwork( 1 ) )
deallocate(work)
deallocate(iwork)
allocate(  work(  lwork ) )
allocate( iwork( liwork ) )

! Call solver
call startTimer()
call dsyevd( jobz, uplo, n, a, n, w, work, lwork, iwork, liwork, info )
call endTimer()

! Check answer
call checkOutput(b,w)

deallocate(a)
deallocate(b)
deallocate(w)
deallocate(work)
deallocate(iwork)

end subroutine EigenManaged

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 

      program verify

      character*10 h1, h2, h3, h4
      integer n1, n2, n3, i, nerrors
      real*8 r1, r2, r1_expd, r2_expd

      open (unit=8,file='../expd_results')
      open (unit=9,file='fft.out')

      read(8,*) h1, h2, h3, h4
      read(8,*) h1, h2, n1, n2, n3
      read(9,*) h1, h2, h3, h4
      read(9,*) h1, h2, n1, n2, n3

      nerrors = 0
      do i = 1, 6
         read(8,*) h1, h2, n1, h3, h4, r1_expd, r2_expd
         read(9,*) h1, h2, n1, h3, h4, r1, r2
         if ( abs(r1_expd - r1) .gt. 1.0d-11  ) then
            nerrors = nerrors + 1
         endif    
         if ( abs(r2_expd - r2) .gt. 1.0d-11  ) then
            nerrors = nerrors + 1
         endif    
      enddo

      if (nerrors .ne. 0) then
         print *, "Test FAILED"
      else
         print *, "Test PASSED"
      endif

      close (unit=8)
      close (unit=9)

      end

!
! SPDX-FileCopyrightText: Copyright (c) 2017 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
! SPDX-License-Identifier: LicenseRef-NvidiaProprietary
!
! NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
! property and proprietary rights in and to this material, related
! documentation and any modifications thereto. Any use, reproduction,
! disclosure or distribution of this material and related documentation
! without an express license agreement from NVIDIA CORPORATION or
! its affiliates is strictly prohibited.
!

module matrix

type :: base_matrix(k,c,r)   
  private
    integer, kind :: k = 4 
    integer, len :: c = 1
    integer, len :: r = 1 
end type base_matrix

type, extends(base_matrix) ::  adj_matrix
  private
    class(*), pointer :: m(:,:) => null()
end type adj_matrix

interface getKind
  module procedure getKind4
  module procedure getKind8
end interface getKind

interface getColumns
  module procedure getNumCols4
  module procedure getNumCols8
end interface getColumns

interface getRows
  module procedure getNumRows4
  module procedure getNumRows8
end interface getRows

interface adj_matrix
   module procedure construct_4   ! kind=4 constructor
   module procedure construct_8   ! kind=8 constructor
end interface adj_matrix

interface assignment(=)
   module procedure m2m4          ! assign kind=4 matrix 
   module procedure m2m8          ! assign kind=8 matrix 
end interface assignment(=)


contains

  function getKind4(this) result(rslt)
   class(adj_matrix(4,*,*)) :: this
   integer :: rslt
   rslt = this%k
  end function getKind4

 function getKind8(this) result(rslt)
   class(adj_matrix(8,*,*)) :: this
   integer :: rslt
   rslt = this%k
 end function getKind8

  function getNumCols4(this) result(rslt)
   class(adj_matrix(4,*,*)) :: this
   integer :: rslt
   rslt = this%c
  end function getNumCols4

  function getNumCols8(this) result(rslt)
   class(adj_matrix(8,*,*)) :: this
   integer :: rslt
   rslt = this%c
  end function getNumCols8

  function getNumRows4(this) result(rslt)
   class(adj_matrix(4,*,*)) :: this
   integer :: rslt
   rslt = this%r
  end function getNumRows4

  function getNumRows8(this) result(rslt)
   class(adj_matrix(8,*,*)) :: this
   integer :: rslt
   rslt = this%r
  end function getNumRows8


 function construct_4(k,c,r) result(mat)
     integer(4) :: k
     integer :: c
     integer :: r
     class(adj_matrix(4,:,:)),allocatable :: mat

     allocate(adj_matrix(4,c,r)::mat)

  end function construct_4

  function construct_8(k,c,r) result(mat)
     integer(8) :: k
     integer :: c
     integer :: r
     class(adj_matrix(8,:,:)),allocatable :: mat

     allocate(adj_matrix(8,c,r)::mat)

  end function construct_8

  subroutine m2m4(d,s)
   class(adj_matrix(4,:,:)),allocatable :: d
   class(adj_matrix(4,*,*)) :: s

   if (allocated(d)) deallocate(d)
   allocate(d,source=s)
 end subroutine m2m4

 subroutine m2m8(d,s)
   type(adj_matrix(8,:,:)),allocatable :: d
   type(adj_matrix(8,*,*)) :: s

   if (allocated(d)) deallocate(d)
   allocate(d,source=s)
 end subroutine m2m8

end module matrix


program adj_2

  use matrix
  implicit none
  integer(8):: i,j,k,nerrors

  type(adj_matrix(8,:,:)),allocatable :: adj
  type(adj_matrix(4,:,:)),allocatable :: adj2

  nerrors = 0
  adj = adj_matrix(INT(8,8),2,4)
  adj2 = adj_matrix(4,16,32)

  if (getKind(adj) .ne. 8) then
     nerrors = nerrors + 1
  endif

  if (getColumns(adj) .ne. 2) then
     nerrors = nerrors + 1
  endif

  if (getRows(adj) .ne. 4) then
     nerrors = nerrors + 1
  endif

  if (getKind(adj2) .ne. 4) then
     nerrors = nerrors + 1
  endif

  if (getColumns(adj2) .ne. 16) then
     nerrors = nerrors + 1
  endif

  if (getRows(adj2) .ne. 32) then
     nerrors = nerrors + 1
  endif

  if (nerrors .ne. 0) then
     print *, "Test FAILED"
  else
     print *, "Test PASSED"
  endif

end program adj_2

!
!     Copyright (c) 2015, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!

module check_mod
  use ieee_arithmetic

  interface check
    module procedure checki1, checki2, checki4, checki8
    module procedure checkl1, checkl2, checkl4, checkl8
    module procedure checkr4, checkr8
    module procedure checkc4, checkc8, checkc1
    module procedure checkcptr, checkcptr2d, checkbytes, checkdt
  end interface
  
  interface ulperror
    module procedure ulperrorr4r4, ulperrorr4r8, ulperrorr8r8
  end interface

  interface ieeecheckcases
    module procedure ieeecheckcasesr4, ieeecheckcasesr8
  end interface

  integer, parameter :: maxulperror = 1000

  character(80) :: fmt00="('Relative Tolerance is ignored for integral checks')"
  character(80) :: fmt01="('Absolute and Relative Tolerance ignored for logical/character checks')"
  character(80) :: fmt02="('test number ',i0,' tolerated ',"
  character(80) :: fmt03="('test number ',i0,' FAILED. ',"
  character(80) :: fmt04="(i0,' tests completed. ',i0,' tests PASSED. 0 tests failed.')"
  character(80) :: fmt05="(i0,' tests completed. ',i0,' tests PASSED. ',i0,' tests tolerated')"
  character(80) :: fmt06="(i0,' tests completed. ',i0,' tests passed. ',i0,' tests FAILED.')"
  character(80) :: fmt07="('type ',a,', test number ',i0,', byte ',i0,' FAILED. ',"
  character(80) :: fmt08="('type ',a,', test number ',i0,', member ',i0,', byte ',i0,' FAILED. ',"

  character(80) :: fmt10="'res ',l0,' exp ',l0)"
  character(80) :: fmt11="'res ',i0,' (0x',z2.2,') exp ',i0,' (0x',z2.2,')')"
  character(80) :: fmt12="'res ',i0,' (0x',z4.4,') exp ',i0,' (0x',z4.4,')')"
  character(80) :: fmt13="'res ',i0,' (0x',z8.8,') exp ',i0,' (0x',z8.8,')')"
  character(80) :: fmt14="'res ',i0,' (0x',z16.16,') exp',i0,' (0x',z16.16,')')"
  character(80) :: fmt16="'res ',f0.3,' (0x',z8.8,') exp ',f0.3,' (0x',z8.8,')')"
  character(80) :: fmt17="'res ',f0.3,' (0x',z16.16,') exp ',f0.3,' (0x',z16.16,')')"
  character(80) :: fmt18="'res ',2(f0.3,1x),2('(0x',z8.8,') '),'exp ',2(f0.3,1x),2('(0x',z8.8,') '))"
  character(80) :: fmt19="'res ',2(f0.3,1x),2('(0x',z16.16,') '),'exp ',2(f0.3,1x),2('(0x',z16.16,') '))"

  character(80) :: fmt20="'res (0x',z2.2,') exp (0x',z2.2,')')"

  contains
      real*4 function ulperrorr4r4(rc, dc)
      real*4 rc, dc
      if (rc.eq.0.0) then
        if (dc.eq.0.0) then
          ulperrorr4r4 = 0.0
        else
          ulperrorr4r4 = maxulperror
        endif
      else
        iexp = 23 - (exponent(rc) - 1)
        ulperrorr4r4 = abs(ieee_scalb(rc,iexp) - ieee_scalb(dc,iexp))
      end if
      return
      end function

      real*4 function ulperrorr4r8(rc, dc)
      real*4 rc
      real*8 dc
      if (rc.eq.0.0) then
        if (dabs(dc) .lt. dble(ieee_next_after(0.0,1.0))) then
          ulperrorr4r8 = 0.0
        else
          ulperrorr4r8 = maxulperror
        endif
      else
        iexp = 23 - (exponent(rc) - 1)
        ulperrorr4r8 = real(dabs(ieee_scalb(dble(rc),iexp)-ieee_scalb(dc,iexp)))
      end if
      return
      end function

      real*4 function ulperrorr8r8(rc, dc)
      real*8 rc, dc
      if (rc.eq.0.0d0) then
        if (dc.eq.0.0d0) then
          ulperrorr8r8 = 0.0
        else
          ulperrorr8r8 = maxulperror
        endif
      else
        iexp = 52 - (exponent(rc) - 1)
        ulperrorr8r8 = real(dabs(ieee_scalb(rc,iexp)-ieee_scalb(dc,iexp)))
      end if
      return
      end function

      integer function ieeecheckcasesr4(xres, xexp)
      real*4 xres, xexp
      type(ieee_class_type) :: creslt, cexpct
      creslt = ieee_class(xres)
      cexpct = ieee_class(xexp)
      if (ieee_is_finite(xres).and.ieee_is_finite(xexp)) then
          ! Only check for +/- zero, else fall through
          if ((creslt.eq.ieee_positive_zero) .and. &
              (cexpct.ne.ieee_positive_zero)) then
              ieeecheckcasesr4 = 1  ! FAIL
          else if ((creslt.eq.ieee_negative_zero) .and. &
                   (cexpct.ne.ieee_negative_zero)) then
              ieeecheckcasesr4 = 1  ! FAIL
          else if (xres .eq. xexp) then
              ieeecheckcasesr4 = 2  ! PASS
          else
              ieeecheckcasesr4 = 0  ! Fail, check tolerances
          end if
      else if (creslt .ne. cexpct) then
          ieeecheckcasesr4 = 1   ! FAIL
      else
          ieeecheckcasesr4 = 2   ! PASS
      end if
      return
      end function

      integer function ieeecheckcasesr8(xres, xexp)
      real*8 xres, xexp
      type(ieee_class_type) :: creslt, cexpct
      creslt = ieee_class(xres)
      cexpct = ieee_class(xexp)
      if (ieee_is_finite(xres).and.ieee_is_finite(xexp)) then
          ! Only check for +/- zero, else fall through
          if ((creslt.eq.ieee_positive_zero) .and. &
              (cexpct.ne.ieee_positive_zero)) then
              ieeecheckcasesr8 = 1  ! FAIL
          else if ((creslt.eq.ieee_negative_zero) .and. &
                   (cexpct.ne.ieee_negative_zero)) then
              ieeecheckcasesr8 = 1  ! FAIL
          else if (xres .eq. xexp) then
              ieeecheckcasesr8 = 2  ! PASS
          else
              ieeecheckcasesr8 = 0  ! Fail, check tolerances
          end if
      else if (creslt .ne. cexpct) then
          ieeecheckcasesr8 = 1   ! FAIL
      else
          ieeecheckcasesr8 = 2   ! PASS
      end if
      return
      end function

    ! First integer*1
    subroutine checki1(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      integer*1, dimension(*) :: reslt
      integer*1, dimension(*) :: expct
      integer :: np
      integer*1, optional :: atoler, rtoler
      integer*1 :: atol, rtol
      integer i, tests_passed, tests_failed, tests_tolerated
      if (present(atoler)) then
        atol = abs(atoler)
      else
        atol = 0
      endif
      if (present(rtoler)) then
        rtol = abs(rtoler)
      else
        rtol = 0
      endif
      if (rtol .gt. 0) write(6,fmt=fmt00)
      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else if ((atol .gt. 0) .and. (abs(expct(i) - reslt(i)) .le. atol)) then
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt11) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt11) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checki1

    ! integer*2
    subroutine checki2(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      integer*2, dimension(*) :: reslt
      integer*2, dimension(*) :: expct
      integer :: np
      integer*2, optional :: atoler, rtoler
      integer*2 :: atol, rtol
      integer i, tests_passed, tests_failed, tests_tolerated
      if (present(atoler)) then
        atol = abs(atoler)
      else
        atol = 0
      endif
      if (present(rtoler)) then
        rtol = abs(rtoler)
      else
        rtol = 0
      endif
      if (rtol .gt. 0) write(6,fmt=fmt00)
      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else if ((atol .gt. 0) .and. (abs(expct(i) - reslt(i)) .le. atol)) then
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt12) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt12) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checki2

    ! integer*4
    subroutine checki4(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      integer*4, dimension(*) :: reslt
      integer*4, dimension(*) :: expct
      integer :: np
      integer*4, optional :: atoler, rtoler
      integer*4 :: atol, rtol
      integer i, tests_passed, tests_failed, tests_tolerated
      if (present(atoler)) then
        atol = abs(atoler)
      else
        atol = 0
      endif
      if (present(rtoler)) then
        rtol = abs(rtoler)
      else
        rtol = 0
      endif
      if (rtol .gt. 0) write(6,fmt=fmt00)
      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else if ((atol .gt. 0) .and. (abs(expct(i) - reslt(i)) .le. atol)) then
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt13) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt13) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checki4

    ! integer*8
    subroutine checki8(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      integer*8, dimension(*) :: reslt
      integer*8, dimension(*) :: expct
      integer :: np
      integer*8, optional :: atoler, rtoler
      integer*8 :: atol, rtol
      integer i, tests_passed, tests_failed, tests_tolerated
      if (present(atoler)) then
        atol = abs(atoler)
      else
        atol = 0
      endif
      if (present(rtoler)) then
        rtol = abs(rtoler)
      else
        rtol = 0
      endif
      if (rtol .gt. 0) write(6,fmt=fmt00)
      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else if ((atol .gt. 0) .and. (abs(expct(i) - reslt(i)) .le. atol)) then
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt14) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt14) i, reslt(i), reslt(i), expct(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checki8

    ! Now logical*1
    subroutine checkl1(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      logical*1, dimension(*) :: reslt
      logical*1, dimension(*) :: expct
      integer :: np
      logical*1, optional :: atoler, rtoler
      integer i, tests_passed, tests_failed
      if (present(atoler) .or. present(rtoler)) then
        write(6,fmt=fmt01)
      endif
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt10) i, reslt(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkl1

    ! logical*2
    subroutine checkl2(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      logical*2, dimension(*) :: reslt
      logical*2, dimension(*) :: expct
      integer :: np
      logical*2, optional :: atoler, rtoler
      integer i, tests_passed, tests_failed
      if (present(atoler) .or. present(rtoler)) then
        write(6,fmt=fmt01)
      endif
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt10) i, reslt(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkl2

    ! logical*4
    subroutine checkl4(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      logical*4, dimension(*) :: reslt
      logical*4, dimension(*) :: expct
      integer :: np
      logical*4, optional :: atoler, rtoler
      integer i, tests_passed, tests_failed
      if (present(atoler) .or. present(rtoler)) then
        write(6,fmt=fmt01)
      endif
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt10) i, reslt(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkl4

    ! logical*8
    subroutine checkl8(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      logical*8, dimension(*) :: reslt
      logical*8, dimension(*) :: expct
      integer :: np
      logical*8, optional :: atoler, rtoler
      integer i, tests_passed, tests_failed
      if (present(atoler) .or. present(rtoler)) then
        write(6,fmt=fmt01)
      endif
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt10) i, reslt(i), expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkl8
  !
  ! real*4
    subroutine checkr4(reslt, expct, np, atoler, rtoler, ulptoler, ieee)
!dir$ ignore_tkr (r) reslt, expct
      real*4, dimension(*) :: reslt
      real*4, dimension(*) :: expct
      integer :: np
      real*4, optional :: atoler, rtoler, ulptoler
      logical, optional :: ieee
      integer i, tests_passed, tests_failed, tests_tolerated
      real*4   abserror, relerror
      logical ieee_on, anytolerated

      anytolerated = present(atoler) .or. present(rtoler) .or. present(ulptoler)
      ieee_on = .false.
      if (present(ieee)) ieee_on = ieee

      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0

      do i = 1, np
        if (ieee_on) then
          iri = ieeecheckcases(reslt(i), expct(i))
          if (iri.eq.1) then
            goto 100
          else if (iri.eq.2) then
            tests_passed = tests_passed + 1
            cycle
          end if
        end if

        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
            cycle
        end if

        abserror = abs(expct(i) - reslt(i))
        if (present(atoler)) then
          if (abserror .gt. abs(atoler)) goto 100
        end if

        if (present(rtoler)) then
          relerror = abserror / amax1(abs(expct(i)),ieee_next_after(0.0,1.0))
          if (relerror .gt. abs(rtoler)) goto 100
        end if

        if (present(ulptoler)) then
          if (ulperror(reslt(i),expct(i)) .gt. abs(ulptoler)) goto 100
        end if

        if (anytolerated) then  ! Some tolerances, so if here we've passed
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt16) i, reslt(i),reslt(i), expct(i),expct(i)
            end if
            cycle
        end if

  100   tests_failed = tests_failed + 1   ! No tolerances, here we've failed
        if (tests_failed .le. 100) then
            write(6,fmt=fmt03//fmt16) i, reslt(i),reslt(i), expct(i),expct(i)
        end if
      end do

      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         end if
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      end if
      return
    end subroutine checkr4
    ! real*8
    subroutine checkr8(reslt, expct, np, atoler, rtoler, ulptoler, ieee)
!dir$ ignore_tkr (r) reslt, expct
      real*8, dimension(*) :: reslt
      real*8, dimension(*) :: expct
      integer :: np
      real*8, optional :: atoler, rtoler, ulptoler
      logical, optional :: ieee
      integer i, tests_passed, tests_failed, tests_tolerated
      real*8   abserror, relerror
      logical ieee_on, anytolerated

      anytolerated = present(atoler) .or. present(rtoler) .or. present(ulptoler)
      ieee_on = .false.
      if (present(ieee)) ieee_on = ieee

      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0

      do i = 1, np
        if (ieee_on) then
          iri = ieeecheckcases(reslt(i), expct(i))
          if (iri.eq.1) then
            goto 100
          else if (iri.eq.2) then
            tests_passed = tests_passed + 1
            cycle
          end if
        end if

        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
            cycle
        end if

        abserror = dabs(expct(i) - reslt(i))
        if (present(atoler)) then
          if (abserror .gt. dabs(atoler)) goto 100
        end if

        if (present(rtoler)) then
          relerror = abserror/dmax1(dabs(expct(i)),ieee_next_after(0.0d0,1.0d0))
          if (relerror .gt. dabs(rtoler)) goto 100
        end if

        if (present(ulptoler)) then
          if (ulperror(reslt(i),expct(i)) .gt. dabs(ulptoler)) goto 100
        end if

        if (anytolerated) then  ! Some tolerances, so if here we've passed
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt17) i, reslt(i),reslt(i), expct(i),expct(i)
            end if
            cycle
        end if
  100   tests_failed = tests_failed + 1   ! No tolerances, here we've failed
        if (tests_failed .le. 100) then
            write(6,fmt=fmt03//fmt17) i, reslt(i),reslt(i), expct(i),expct(i)
        end if
      enddo

      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkr8
    subroutine checkc4(reslt, expct, np, atoler, rtoler, ulptoler, ieee)
!dir$ ignore_tkr (r) reslt, expct
      complex*8, dimension(*) :: reslt
      complex*8, dimension(*) :: expct
      integer :: np
      complex*8, optional :: atoler, rtoler, ulptoler
      logical, optional :: ieee
      integer i, tests_passed, tests_failed, tests_tolerated
      real*4     abserror, relerror
      real*4     rres, rexp, rx
      logical ieee_on, anytolerated

      anytolerated = present(atoler) .or. present(rtoler) .or. present(ulptoler)
      ieee_on = .false.
      if (present(ieee)) ieee_on = ieee

      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0

      do i = 1, np
        if (ieee_on) then
          rres = real(reslt(i))
          rexp = real(expct(i))
          irri = ieeecheckcases(rres, rexp)
          rres = imag(reslt(i))
          rexp = imag(expct(i))
          icri = ieeecheckcases(rres, rexp)
          if ((irri.eq.1) .or. (icri.eq.1)) then
            goto 100
          else if ((irri.eq.2) .and. (icri.eq.2)) then
            tests_passed = tests_passed + 1
            cycle
          end if
        end if

        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
            cycle
        end if

        abserror = cabs(expct(i) - reslt(i))
        if (present(atoler)) then
          if (abserror .gt. cabs(atoler)) goto 100
        end if

        if (present(rtoler)) then
          relerror = abserror / amax1(cabs(expct(i)),ieee_next_after(0.0,1.0))
          if (relerror .gt. cabs(rtoler)) goto 100
        end if

        if (present(ulptoler)) then
          rres = real(reslt(i))
          rexp = real(expct(i))
          if (ulperror(rres,rexp) .gt. real(ulptoler)) goto 100
          rres = imag(reslt(i))
          rexp = imag(expct(i))
          if (ulperror(rres,rexp) .gt. imag(ulptoler)) goto 100
        end if

        if (anytolerated) then  ! Some tolerances, so if here we've passed
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt18) i, reslt(i),reslt(i), expct(i),expct(i)
            end if
            cycle
        end if

  100   tests_failed = tests_failed + 1   ! No tolerances, here we've failed
        if (tests_failed .le. 100) then
            write(6,fmt=fmt03//fmt18) i, reslt(i),reslt(i), expct(i),expct(i)
        end if
      enddo

      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkc4
    ! complex*16
    subroutine checkc8(reslt, expct, np, atoler, rtoler, ulptoler, ieee)
!dir$ ignore_tkr (r) reslt, expct
      complex*16, dimension(*) :: reslt
      complex*16, dimension(*) :: expct
      integer :: np
      complex*16, optional :: atoler, rtoler, ulptoler
      logical, optional :: ieee
      integer i, tests_passed, tests_failed, tests_tolerated
      real*8     abserror, relerror
      real*8     rres, rexp, rx
      logical ieee_on, anytolerated

      anytolerated = present(atoler) .or. present(rtoler) .or. present(ulptoler)
      ieee_on = .false.
      if (present(ieee)) ieee_on = ieee

      tests_passed = 0
      tests_failed = 0
      tests_tolerated = 0

      do i = 1, np
        if (ieee_on) then
          rres = dreal(reslt(i))
          rexp = dreal(expct(i))
          irri = ieeecheckcases(rres, rexp)
          rres = dimag(reslt(i))
          rexp = dimag(expct(i))
          icri = ieeecheckcases(rres, rexp)
          if ((irri.eq.1) .or. (icri.eq.1)) then
            goto 100
          else if ((irri.eq.2) .and. (icri.eq.2)) then
            tests_passed = tests_passed + 1
            cycle
          end if
        end if

        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
            cycle
        end if

        abserror = cdabs(expct(i) - reslt(i))
        if (present(atoler)) then
          if (abserror .gt. cdabs(atoler)) goto 100
        end if

        if (present(rtoler)) then
          relerror = abserror / dmax1(cdabs(expct(i)),ieee_next_after(0.0d0,1.0d0))
          if (relerror .gt. cdabs(rtoler)) goto 100
        end if

        if (present(ulptoler)) then
          rres = dreal(reslt(i))
          rexp = dreal(expct(i))
          if (ulperror(rres,rexp) .gt. dreal(ulptoler)) goto 100
          rres = dimag(reslt(i))
          rexp = dimag(expct(i))
          if (ulperror(rres,rexp) .gt. dimag(ulptoler)) goto 100
        end if

        if (anytolerated) then  ! Some tolerances, so if here we've passed
            tests_passed = tests_passed + 1
            tests_tolerated = tests_tolerated + 1
            if (tests_tolerated .le. 100) then
              write(6,fmt=fmt02//fmt19) i, reslt(i),reslt(i), expct(i),expct(i)
            end if
            cycle
        end if

  100   tests_failed = tests_failed + 1   ! No tolerances, here we've failed
        if (tests_failed .le. 100) then
            write(6,fmt=fmt03//fmt19) i, reslt(i),reslt(i), expct(i),expct(i)
        end if
      enddo

      if (tests_failed .eq. 0) then
         if (tests_tolerated .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
         else
            write(6,fmt=fmt05) np, tests_passed, tests_tolerated
         endif
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkc8

    ! Now character*1
    subroutine checkc1(reslt, expct, np, atoler, rtoler)
!dir$ ignore_tkr (r) reslt, expct
      character*1, dimension(*) :: reslt
      character*1, dimension(*) :: expct
      integer :: np
      character*1, optional :: atoler, rtoler
      integer i, tests_passed, tests_failed
      if (present(atoler) .or. present(rtoler)) then
        write(6,fmt=fmt01)
      endif
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (expct(i) .eq. reslt(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt11) i, ichar(reslt(i)),reslt(i),ichar(expct(i)),expct(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkc1

    ! Now c_ptr
    subroutine checkcptr(reslt, expct, np)
      use iso_c_binding
      type(c_ptr) :: reslt, expct
      integer :: np
      integer*1, dimension(:), pointer :: ia1, ia2
      integer i, tests_passed, tests_failed

      call c_f_pointer(reslt, ia1, (/np/))
      call c_f_pointer(expct, ia2, (/np/))
      tests_passed = 0
      tests_failed = 0
      do i = 1, np
        if (ia2(i) .eq. ia1(i)) then
            tests_passed = tests_passed + 1
        else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt03//fmt11) i, ia1(i),ia1(i), ia2(i),ia2(i)
            end if
        endif
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) np, tests_passed
      else
            write(6,fmt=fmt06) np, tests_passed, tests_failed
      endif
      return
    end subroutine checkcptr

    ! Now c_ptr2d
    subroutine checkcptr2d(reslt, expct, isz, icnt)
      use iso_c_binding
      type(c_ptr) :: reslt, expct
      integer ::isz, icnt
      integer*1, dimension(:,:), pointer :: ia1, ia2
      integer i, tests_passed, tests_failed

      call c_f_pointer(reslt, ia1, (/ isz, icnt /))
      call c_f_pointer(expct, ia2, (/ isz, icnt /))
      tests_passed = 0
      tests_failed = 0
      do j = 1, icnt
        do i = 1, isz
          if (ia2(i,j) .eq. ia1(i,j)) then
            if (i .eq. isz) tests_passed = tests_passed + 1
          else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt07//fmt20) "c_ptr", j, i, ia1(i,j),ia2(i,j)
            end if
            exit
          endif
        end do
      enddo
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) icnt, tests_passed
      else
            write(6,fmt=fmt06) icnt, tests_passed, tests_failed
      endif
      return
    end subroutine checkcptr2d

    ! Just a simple routine for checking derived types
    subroutine checkbytes(reslt, expct, name, isz, icnt)
!dir$ ignore_tkr reslt, expct
      integer*1, dimension(isz,*) :: reslt
      integer*1, dimension(isz,*) :: expct
      character*(*) :: name
      integer :: isz, icnt
      integer i, tests_passed, tests_failed
      tests_passed = 0
      tests_failed = 0
      do j = 1, icnt
        do i = 1, isz
          if (expct(i,j) .eq. reslt(i,j)) then
            if (i .eq. isz) tests_passed = tests_passed + 1
          else
            tests_failed = tests_failed + 1
            if (tests_failed .le. 100) then
              write(6,fmt=fmt07//fmt20) name, j, i, reslt(i,j),expct(i,j)
            end if
            exit
          endif
        end do
      end do
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) icnt, tests_passed
      else
            write(6,fmt=fmt06) icnt, tests_passed, tests_failed
      endif
      return
    end subroutine checkbytes

    ! A more complicated routine for checking derived types
    subroutine checkdt(reslt, expct, name, lcnt, lsize, mcnt, msize, moffset)
!dir$ ignore_tkr reslt, expct
      integer*1, dimension(*) :: reslt
      integer*1, dimension(*) :: expct
      character*(*) :: name
      integer :: lcnt, lsize, mcnt, msize(mcnt), moffset(mcnt)

      integer i,j,k,ii,ij,ik, tests_passed, tests_failed
      tests_passed = 0
      tests_failed = 0
      ik = 0
      do k = 1, lcnt     ! For each array element in the reslt/expct array
        do j = 1, mcnt     ! For each member in a dt element
          ij = moffset(j)  ! This is the offset from beginning of the element
          isz = msize(j)   ! This is the size of the member in the element
          do i = 1, isz       ! Loop over each char in the member
            ii = ik+ij+i
            if (expct(ii) .eq. reslt(ii)) then
                if (i .eq. isz) tests_passed = tests_passed + 1
            else
                tests_failed = tests_failed + 1
                if (tests_failed .le. 100) then
                  write(6,fmt=fmt08//fmt20) name, k, j, i, reslt(ii),expct(ii)
                end if
                exit
            endif
          end do
        end do
        ik = ik + lsize  ! jump to the next element in the array
      end do
      if (tests_failed .eq. 0) then
            write(6,fmt=fmt04) lcnt*mcnt, tests_passed
      else
            write(6,fmt=fmt06) lcnt*mcnt, tests_passed, tests_failed
      endif
      return
    end subroutine checkdt

end module check_mod

      program hello
      include 'mpif.h'
      integer ierr, myproc, nerrors
      nerrors = 0
      call mpi_init(ierr)
      if (ierr .ne. 0) then
         nerrors = nerrors + 1
      endif
      call mpi_comm_rank(MPI_COMM_WORLD, myproc, ierr)
      if (ierr .ne. 0) then
         nerrors = nerrors + 1
      endif

      print *, "Hello world!  I'm node", myproc

      call mpi_finalize(ierr)
      if (ierr .ne. 0) then
         nerrors = nerrors + 1
      endif
      if (nerrors .ne. 0) then
         print *, "Test FAILED"
      else
         print *, "Test PASSED"
      endif
      end

program main
  implicit none
  integer, parameter :: n=8
  real :: a(n), b(n)
#ifdef _CUDA
  attributes(device) :: a, b
  real :: a_h(n), b_h(n)
#endif
  integer :: i

  !$cuf kernel do <<<*,*>>> 
  do i = 1, n  
     a(i) = i+1
  enddo

  !$cuf kernel do <<<*,*>>>
  do i = 1, n
     b(i) = a(i)+1
  enddo

#ifdef _CUDA
  a_h = a; b_h = b
  print *, 'GPU version'
  print *, a_h
  print *, b_h
#else
  print *, a
  print *, b
#endif

end program main

program sum_accuracy
  implicit none
  real, allocatable :: x(:)
  real :: sum_intrinsic,sum_cpu, sum_kahan, sum_pairwise, &
       comp, y, tmp
  double precision :: sum_cpu_dp
  integer :: i,inext,icurrent,  N=10000000

  allocate (x(N))
  x=7.

  ! Summation using intrinsic
  sum_intrinsic=sum(x)

  ! Recursive summation 
  sum_cpu=0.
  sum_cpu_dp=0.d0
  do i=1,N
     ! accumulator in single precision
     sum_cpu=sum_cpu+x(i)
     ! accumulator in double precision
     sum_cpu_dp=sum_cpu_dp+x(i)
  end do

  ! Kahan summation
  sum_kahan=0.
  comp=0. ! running compensation to recover lost low-order bits
  
  do i=1,N
     y    = comp +x(i)
     tmp  = sum_kahan + y     ! low-order bits may be lost
     comp = (sum_kahan-tmp)+y ! (sum-tmp) recover low-order bits
     sum_kahan = tmp
  end do
  sum_kahan=sum_kahan +comp
  
  ! Pairwise summation
  icurrent=N
  inext=ceiling(real(N)/2)
  do while (inext >1)
     do i=1,inext
        if ( 2*i <= icurrent) x(i)=x(i)+x(i+inext)
     end do
     icurrent=inext
     inext=ceiling(real(inext)/2)
  end do
  sum_pairwise=x(1)+x(2)
  
  write(*, "('Summming ',i10, &
       ' elements of magnitude ',f3.1)") N,7.
  write(*, "('Sum with intrinsic function       =',f12.1, &
       '   Error=', f12.1)")  &
       sum_intrinsic, 7.*N-sum_intrinsic
  write(*, "('Recursive sum with SP accumulator =',f12.1, &
       '   Error=', f12.1)")  sum_cpu, 7.*N-sum_cpu
  write(*, "('Recursive sum with DP accumulator =',f12.1, &
       '   Error=', f12.1)")  sum_cpu_dp, 7.*N-sum_cpu_dp
  write(*, "('Pairwise sum in SP                =',f12.1, &
       '   Error=', f12.1)")  sum_pairwise, 7.*N-sum_pairwise
  write(*, "('Compensated sum in SP             =',f12.1, &
       '   Error=', f12.1)")  sum_kahan, 7.*N-sum_kahan
  
  deallocate(x)
end program sum_accuracy

program hello
use mpi
integer ierr, myproc, nerrors
nerrors = 0
call mpi_init(ierr)
if (ierr .ne. 0) then
   nerrors = nerrors + 1
endif
call mpi_comm_rank(MPI_COMM_WORLD, myproc, ierr)
if (ierr .ne. 0) then
   nerrors = nerrors + 1
endif

print *, "Hello world!  I'm node", myproc

call mpi_finalize(ierr)
if (ierr .ne. 0) then
   nerrors = nerrors + 1
endif
if (nerrors .ne. 0) then
   print *, "Test FAILED"
else
   print *, "Test PASSED"
endif
end

module &
#ifdef _CUDA
  rgbCUDA
#else
  rgbHost
#endif

  type rgb
     real :: v(3)
  end type rgb

  interface assignment (=)
     module procedure rgbEqR3, r3EqRgb
  end interface assignment (=)

  interface operator(*)
     module procedure rgbTimesR3, r3TimesRgb, rgbTimesRgb, &
          rgbTimesR, rTimesRgb
  end interface operator(*)

  interface operator(/)
     module procedure rgbDivR3, r3DivRgb, rgbDivRgb, rgbDivI
  end interface operator(/)

  interface operator(+)
     module procedure rgbPlusR3, r3PlusRgb, rgbPlusRgb
  end interface operator(+)

  interface operator(-)
     module procedure rgbMinusR3, r3MinusRgb, rgbMinusRgb
  end interface operator(-)

contains

  !@cuf attributes(device) &
  subroutine rgbEqR3(rgbout, rin)
    type(rgb), intent(out) :: rgbout
    real(4), intent(in) :: rin(3)
    rgbout%v = rin
  end subroutine rgbEqR3
  
  !@cuf attributes(device) &
  subroutine r3EqRgb(rout, rgbin)
    real(4), intent(out) :: rout(3)
    type(rgb), intent(in) :: rgbin
    rout = rgbin%v
  end subroutine r3EqRgb

  !@cuf attributes(device) &
  function rgbTimesR3(rgbin, rin) result(res)
    type(rgb), intent(in) :: rgbin
    real(4), intent(in) :: rin(3)
    real(4) :: res(3)
    res = rgbin%v * rin
  end function rgbTimesR3

  !@cuf attributes(device) &
  function r3TimesRgb(rin, rgbin) result(res)
    real(4), intent(in) :: rin(3)
    type(rgb), intent(in) :: rgbin
    real(4) :: res(3)
    res = rgbin%v * rin
  end function r3TimesRgb

  !@cuf attributes(device) &
  function rgbTimesRgb(rgb1, rgb2) result(res)
    type(rgb), intent(in) :: rgb1, rgb2
    real(4) :: res(3)
    res = rgb1%v * rgb2%v
  end function rgbTimesRgb

  !@cuf attributes(device) &
  function rgbTimesR(rgbin, rin) result(res)
    type(rgb), intent(in) :: rgbin
    real(4), intent(in) :: rin
    real(4) :: res(3)
    res = rgbin%v * rin
  end function rgbTimesR

  !@cuf attributes(device) &
  function rTimesRgb(rin, rgbin) result(res)
    real(4), intent(in) :: rin
    type(rgb), intent(in) :: rgbin
    real(4) :: res(3)
    res = rgbin%v * rin
  end function rTimesRgb

  !@cuf attributes(device) &
  function rgbDivR3(rgbin, rin) result(res)
    type(rgb), intent(in) :: rgbin
    real(4), intent(in) :: rin(3)
    real(4) :: res(3)
    res = rgbin%v / rin
  end function rgbDivR3

  !@cuf attributes(device) &
  function rgbDivI(rgbin, iin) result(res)
    type(rgb), intent(in) :: rgbin
    integer(4), intent(in) :: iin
    real(4) :: res(3)
    res = rgbin%v / iin
  end function rgbDivI

  !@cuf attributes(device) &
  function r3DivRgb(rin, rgbin) result(res)
    real(4), intent(in) :: rin(3)
    type(rgb), intent(in) :: rgbin
    real(4) :: res(3)
    res = rgbin%v / rin
  end function r3DivRgb

  !@cuf attributes(device) &
  function rgbDivRgb(rgb1, rgb2) result(res)
    type(rgb), intent(in) :: rgb1, rgb2
    real(4) :: res(3)
    res = rgb1%v / rgb2%v
  end function rgbDivRgb

  !@cuf attributes(device) &
  function rgbPlusR3(rgbin, rin) result(res)
    type(rgb), intent(in) :: rgbin
    real(4), intent(in) :: rin(3)
    real(4) :: res(3)
    res = rgbin%v + rin
  end function rgbPlusR3

  !@cuf attributes(device) &
  function r3PlusRgb(rin, rgbin) result(res)
    real(4), intent(in) :: rin(3)
    type(rgb), intent(in) :: rgbin
    real(4) :: res(3)
    res = rgbin%v + rin
  end function r3PlusRgb

  !@cuf attributes(device) &
  function rgbPlusRgb(rgb1, rgb2) result(res)
    type(rgb), intent(in) :: rgb1, rgb2
    real(4) :: res(3)
    res = rgb1%v + rgb2%v
  end function rgbPlusRgb

  !@cuf attributes(device) &
  function rgbMinusR3(rgbin, rin) result(res)
    type(rgb), intent(in) :: rgbin
    real(4), intent(in) :: rin(3)
    real(4) :: res(3)
    res = rgbin%v - rin
  end function rgbMinusR3

  !@cuf attributes(device) &
  function r3MinusRgb(rin, rgbin) result(res)
    real(4), intent(in) :: rin(3)
    type(rgb), intent(in) :: rgbin
    real(4) :: res(3)
    res = rgbin%v - rin
  end function r3MinusRgb

  !@cuf attributes(device) &
  function rgbMinusRgb(rgb1, rgb2) result(res)
    type(rgb), intent(in) :: rgb1, rgb2
    real(4) :: res(3)
    res = rgb1%v - rgb2%v
  end function rgbMinusRgb

end module 

program main
  implicit none
  integer, parameter :: n=8
  
  real :: a(n), b(n)
  !@cuf  real, device :: a_d(n), b_d(n)
  integer :: i

  !@cuf associate(a => a_d)
  !$cuf kernel do
  do i = 1, n
     a(i) = i+1
  enddo
  !@cuf associate(b => b_d) 
  !$cuf kernel do
  do i = 1, n
     b(i) = a(i)+1
  enddo
  !@cuf end associate ! b ...
  !@cuf end associate ! a ...
  !@cuf a = a_d; b = b_d

  !@cuf print *, 'GPU run'
  print *, a
  print *, b
end program main

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!

! An example of how to call the cublas single precision matrix multiply
! routine cublasSgemm
!
! Build for running on the host:
!   nvfortran -o sgemm_host cublasSgemm.F90 -lblas
!
! Build for running on the gpu:
!   nvfortran -cuda -o sgemm_gpu cublasSgemm.F90 -cudalib=cublas
!


program test_cublasSgemm
#ifdef _CUDA
use cudafor
use cublas
real, device, allocatable, dimension(:,:) :: A, B, C
#else
real, allocatable, dimension(:,:) :: A, B, C
#endif
real, allocatable :: T(:,:), Expct(:)

real :: alpha = 1.0e0
real :: beta  = 0.0e0
real :: t1, t2, tt, gflops
integer :: i, j, k, nerrors

! print *, "Enter N: "
! read(5,*) n

n = 1000

allocate(A(n,n), B(n,n), C(n,n), T(n,n), Expct(n))

call random_number(T)
do j = 1, n
  Expct(j) = 2.0 * sum(T(:,j))
end do
    
A = 2.0
B = T
C = -9.9

call cpu_time(t1)

call sgemm('n','n', n, n, n, alpha, A, n, B, n, beta, C, n)

#ifdef _CUDA
istat = cudaDeviceSynchronize()  ! Only needed for a fair time
#endif

call cpu_time(t2)

print *, "Checking results...."

T = C

nerrors = 0
do j = 1, n
  do i = 1, n
    if (abs(T(i,j) - Expct(j)) .gt. 5.0e-3) then
       nerrors = nerrors + 1
    endif
  enddo
enddo

if (nerrors .ne. 0) then
   print *, "Test FAILED"
else
   print *, "Test PASSED"
endif

gflops = (real(n) * real(n) * real(n) * 2.0) / 1000000000.0
tt = t2 - t1
print *, "Total Time: ",tt
print *, "Total SGEMM gflops: ",gflops/tt

end

      PROGRAM FFTPDE
C
C   This is the standard Fortran-77 version of the APP Benchmark 4, the
C   3-D FFT PDE benchmark.
C   On 64 bit systems, double precision should be disabled.
C   Computer specific and tuning notes may be located by searching for C>>.
C>>
C   David H. Bailey     January 8, 1991
C
C   In the following parameter statement, M1, M2 and M3 are the Log_2 of the
C   three dimensions of the 3-D input array.  Set MX = MAX (M1, M2, M3).
C   A is the multiplier of the random number generator (here set to 5^13),
C   and S is the initial seed.  AL is the value of alpha.  NT is the number
C   of iterations.  timer is a double precision function that returns elapsed
C   CPU time in timers.
C
      IMPLICIT real*8 (A-H, O-Z)
      PARAMETER (M1 = 7, M2 = 7, M3 = 6, MM = M1 + M2 + M3, MP = M3,     
     $  MX = 4, N1 = 2 ** M1, N2 = 2 ** M2, N3 = 2 ** M3, NN = 2 ** MM, 
     $  NP = 2 ** MP, NT = 6, NX = 2 ** MX, A = 1220703125.D0,
     $  AL = 1D-6, PI = 3.141592653589793238D0, S = 314159265.D0)
c     PARAMETER (M1 = 8, M2 = 8, M3 = 7, MM = M1 + M2 + M3,
c    $  MX = 8, N1 = 2 ** M1, N2 = 2 ** M2, N3 = 2 ** M3, NN = 2 ** MM, 
c    $  NT = 6, NX = 2 ** MX, A = 1220703125.D0,
c    $  AL = 1D-6, PI = 3.141592653589793238D0, S = 314159265.D0)
c     DIMENSION U(2*NX), X0(2*N1*N2*N3), X1(N1,N2,2*N3),                
c    $  X2(N1,N2,2*N3), X3(N1,N2,N3), Y(4*NX)
      DIMENSION X1real(N1,N2,N3), X2real(N1,N2,N3), X3(N1,N2,N3)
      DIMENSION X1imag(N1,N2,N3), X2imag(N1,N2,N3)
      real*8 tm1,tm0,timer
c
c for some reason SPARC doesnt like passing double prec const to vranlc
c make it a variable.
c
      open (unit=6,file='fft.out',status='unknown')
      aa=a
C
C   Initialize.
C
      WRITE (6, 1) N1, N2, N3
 1    FORMAT ('3-D FFT PDE TEST'/'DIMENSIONS =',3I5)
      TM0 = timer ()
c     CALL CFFTZ (0, MX, U, X0, Y)
      CALL VRANLC (0, T1, Aa, X0)
      RN = 1.D0 / NN
      AP = - 4.D0 * AL * PI ** 2
      N12 = N1 / 2
      N22 = N2 / 2
      N32 = N3 / 2
C
C   Compute AN = A ^ (2 * NQ) (mod 2^46).
C
      T1 = A
C
      DO 100 I = 1, M1+M2+1
        T1 = RANDLC (T1, T1)
 100  CONTINUE
C
      AN = T1
      TT = S
C
C   Each instance of this loop may be performed independently.
C
      DO 130 K = 1, N3
        KK = K - 1
        KL = KK
        T1 = S
        T2 = AN
C
C   Find starting seed T1 for this KK using the binary rule for exponentiation.
C
        DO 110 I = 1, 100
          IK = KK / 2
          IF (2 * IK .NE. KK) T2 = RANDLC (T1, T2)
          IF (IK .EQ. 0) GOTO 120
          T2 = RANDLC (T2, T2)
          KK = IK
 110    CONTINUE
C
C   Compute 2 * NQ pseudorandom numbers.
C
 120   continue
        CALL VRANLC (N1*N2, T2, aa, x1real(1,1,k))
        CALL VRANLC (N1*N2, T2, aa, x1imag(1,1,k))
 130  CONTINUE
C
C   On a single processor system, the 110 loop and line 120 can be replaced
C   by the following single line.
C
C120     CALL VRANLC (2 * NQ, TT, Aa, X0(2*KL*NQ+1))
C
C   Copy data in X0 into the 3-D array X1.
C
c     DO 160 K = 1, N3
c       K1 = K - 1
c
c       DO 150 J = 1, N2
c         J1 = J - 1
c         JK = 2 * (J1 + K1 * N2) * N1
c
c         DO 140 I = 1, N1
c           X1(I,J,K) = X0(2*I-1+JK)
c           X1(I,J,K+N3) = X0(2*I+JK)
c140      CONTINUE
C
c150    CONTINUE
c160  CONTINUE
C
C   Perform a forward 3-D FFT on X1.
C
      CALL CFFT3 (-1, M1, M2, M3, N1, N2, N3, X1real,x1imag)
C
C   Compute exponential terms.
C
      DO 190 K = 1, N3
        K1 = K - 1
        IF (K .GT. N32) K1 = K1 - N3
C
        DO 180 J = 1, N2
          J1 = J - 1
          IF (J .GT. N22) J1 = J1 - N2
          JK = J1 ** 2 + K1 ** 2
C
          DO 170 I = 1, N1
            I1 = I - 1
            IF (I .GT. N12) I1 = I1 - N1
            X3(I,J,K) = EXP (AP * (I1 ** 2 + JK))
 170      CONTINUE
C
 180    CONTINUE
 190  CONTINUE
C
C   Perform the following for KT = 1, ..., NT.
C
      DO 270 KT = 1, NT
C
C   Multiply by the exponential term raised to the KT power.
C
        DO 220 K = 1, N3
          DO 210 J = 1, N2
            DO 200 I = 1, N1
              T1 = X3(I,J,K) ** KT
              X2real(I,J,K) = T1 * X1real(I,J,K)
              X2imag(I,J,K) = T1 * X1imag(I,J,K)
 200        CONTINUE
 210      CONTINUE
 220    CONTINUE
C
C   Compute inverse 3-D FFT.
C
        CALL CFFT3 (1, M1, M2, M3, N1, N2, N3, x2real,x2imag)
C
C   Normalize by 1 / (N1 * N2 * N3).
C
        DO 250 K = 1, N3
          DO 240 J = 1, N2
            DO 230 I = 1, N1
              X2real(I,J,K) = RN * X2real(I,J,K)
              X2imag(I,J,K) = RN * X2imag(I,J,K)
 230        CONTINUE
 240      CONTINUE
 250    CONTINUE
C
C   Compute checksum.
C
        T1 = 0.D0
        T2 = 0.D0
C
        DO 260 I = 1, N3
        DO 260 J = 1, 1024/N3
		  I1 = J - 1 + (I-1) * (1024/N3)
          JJ = MOD (3 * I1, N2) + 1
          KK = MOD (5 * I1, N3) + 1
          T1 = T1 + X2real(JJ,KK,I)
          T2 = T2 + X2imag(JJ,KK,I)
 260    CONTINUE
c       DO 260 I = 1, 1024
c         I1 = I - 1
c         II = MOD (I1, N1) + 1
c         JJ = MOD (3 * I1, N2) + 1
c         KK = MOD (5 * I1, N3) + 1
c         T1 = T1 + X2real(II,JJ,KK)
c         T2 = T2 + X2imag(II,JJ,KK)
c260    CONTINUE
C
        WRITE (6, 2) KT, T1, T2
 2      FORMAT ('T =',I5,5X,'CHECKSUM =',1P2D22.12)
 270  CONTINUE
C
      TM1 = timer ()
      TM = TM1 - TM0
      WRITE (6, 3) TM
 3    FORMAT ('TEST COMPLETED'/'CPU TIME =',F12.6)
      STOP
      END
C
      FUNCTION RANDLC (X, A)
C
C   This routine returns a uniform pseudorandom double precision number in the
C   range (0, 1) by using the linear congruential generator
C
C   x_{k+1} = a x_k  (mod 2^46)
C
C   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
C   before repeating.  The argument A is the same as 'a' in the above formula,
C   and X is the same as x_0.  A and X must be odd double precision integers
C   in the range (1, 2^46).  The returned value RANDLC is normalized to be
C   between 0 and 1, i.e. RANDLC = 2^(-46) * x_1.  X is updated to contain
C   the new seed x_1, so that subsequent calls to RANDLC using the same
C   arguments will generate a continuous sequence.
C
C   This routine should produce the same results on any computer with at least
C   48 mantissa bits in double precision floating point data.  On 64 bit
C   systems, double precision should be disabled.
C
C   David H. Bailey     October 26, 1990
C
      IMPLICIT real*8 (A-H, O-Z)
      SAVE KS, R23, R46, T23, T46
      DATA KS/0/
C
C   If this is the first call to RANDLC, compute R23 = 2 ^ -23, R46 = 2 ^ -46,
C   T23 = 2 ^ 23, and T46 = 2 ^ 46.  These are computed in loops, rather than
C   by merely using the ** operator, in order to insure that the results are
C   exact on all systems.  This code assumes that 0.5D0 is represented exactly.
C
      IF (KS .EQ. 0) THEN
        R23 = 1.D0
        R46 = 1.D0
        T23 = 1.D0
        T46 = 1.D0
C
        DO 100 I = 1, 23
          R23 = 0.5D0 * R23
          T23 = 2.D0 * T23
 100    CONTINUE
C
        DO 110 I = 1, 46
          R46 = 0.5D0 * R46
          T46 = 2.D0 * T46
 110    CONTINUE
C
        KS = 1
      ENDIF
C
C   Break A into two parts such that A = 2^23 * A1 + A2.
C
      T1 = R23 * A
      A1 = AINT (T1)
      A2 = A - T23 * A1
C
C   Break X into two parts such that X = 2^23 * X1 + X2, compute
C   Z = A1 * X2 + A2 * X1  (mod 2^23), and then
C   X = 2^23 * Z + A2 * X2  (mod 2^46).
C
      T1 = R23 * X
      X1 = AINT (T1)
      X2 = X - T23 * X1
      T1 = A1 * X2 + A2 * X1
      T2 = AINT (R23 * T1)
      Z = T1 - T23 * T2
      T3 = T23 * Z + A2 * X2
      T4 = AINT (R46 * T3)
      X = T3 - T46 * T4
c     RANDLC = R46 * X
      RANDLC = X
C
      RETURN
      END
C
      SUBROUTINE VRANLC (N, X, A, Y)
C
C   This routine generates N uniform pseudorandom double precision numbers in
C   the range (0, 1) by using the linear congruential generator
C
C   x_{k+1} = a x_k  (mod 2^46)
C
C   where 0 < x_k < 2^46 and 0 < a < 2^46.  This scheme generates 2^44 numbers
C   before repeating.  The argument A is the same as 'a' in the above formula,
C   and X is the same as x_0.  A and X must be odd double precision integers
C   in the range (1, 2^46).  The N results are placed in Y and are normalized
C   to be between 0 and 1.  X is updated to contain the new seed, so that
C   subsequent calls to VRANLC using the same arguments will generate a
C   continuous sequence.  If N is zero, only initialization is performed, and
C   the variables X, A and Y are ignored.
C
C   This routine is the standard version designed for scalar or RISC systems.
C   However, it should produce the same results on any single processor
C   computer with at least 48 mantissa bits in double precision floating point
C   data.  On 64 bit systems, double precision should be disabled.
C
C   David H. Bailey     October 26, 1990
C
      IMPLICIT real*8 (A-H, O-Z)
      DIMENSION Y(N)
      SAVE KS, R23, R46, T23, T46
      DATA KS/0/
C
C   If this is the first call to VRANLC, compute R23 = 2 ^ -23, R46 = 2 ^ -46,
C   T23 = 2 ^ 23, and T46 = 2 ^ 46.  See comments in RANDLC.
C
      IF (KS .EQ. 0 .OR. N .EQ. 0) THEN
        R23 = 1.D0
        R46 = 1.D0
        T23 = 1.D0
        T46 = 1.D0
C
        DO 100 I = 1, 23
          R23 = 0.5D0 * R23
          T23 = 2.D0 * T23
 100    CONTINUE
C
        DO 110 I = 1, 46
          R46 = 0.5D0 * R46
          T46 = 2.D0 * T46
 110    CONTINUE
C
        KS = 1
        IF (N .EQ. 0) RETURN
      ENDIF
C
C   Break A into two parts such that A = 2^23 * A1 + A2.
C
      T1 = R23 * A
      A1 = AINT (T1)
      A2 = A - T23 * A1
C
C   Generate N results.   This loop is not vectorizable.
C
      DO 120 I = 1, N
C
C   Break X into two parts such that X = 2^23 * X1 + X2, compute
C   Z = A1 * X2 + A2 * X1  (mod 2^23), and then
C   X = 2^23 * Z + A2 * X2  (mod 2^46).
C
        T1 = R23 * X
        X1 = AINT (T1)
        X2 = X - T23 * X1
        T1 = A1 * X2 + A2 * X1
        T2 = AINT (R23 * T1)
        Z = T1 - T23 * T2
        T3 = T23 * Z + A2 * X2
        T4 = AINT (R46 * T3)
        X = T3 - T46 * T4
        Y(I) = R46 * X
 120  CONTINUE
C
      RETURN
      END
C
      SUBROUTINE CFFT3 (IS, M1, M2, M3, N1, N2, N3, X1real,X1imag)
C
C   This performs a 3-D complex-to-complex FFT on the array X1, which is
C   assumed to have dimensions (N1,N2,2*N3).  It is assumed that N1 = 2 ^ M1,
C   N2 = 2 ^ M2 and N3 = 2 ^ M3.  Real and imaginary parts are stored
C   completely separated (i.e. separated by N3 units in the last dimension of
C   X1).  IS is the sign of the transform, either 1 or -1.  U is the root of
C   unity array, which must have been previously initialized by calling CFFTZ
C   with 0 as the first argument and MM = MAX (M1,M2,M3) as the timer
C   argument.  X2 is used as a scratch array and must be the same size as X1.
C   Y is a scratch array of size 4 * 2 ^ MM.
C
C   David H. Bailey     October 26, 1990
C
      IMPLICIT real*8 (A-H, O-Z)
      DIMENSION X1real(N1,N2,N3),X1imag(N1,N2,N3)
	  parameter(mxsz=8192)
	  complex z(mxsz),w(mxsz/2)
	  logical inverse
	  real timer
	  if(n1.gt.mxsz.or.n2.gt.mxsz.or.n3.gt.mxsz)then
		print *,'Error in CFFT3. Maximum size allowed=',mxsz
		stop 998
	  endif
c	  print *,'cfft3'
c	  print *,'is=',is,' m1=',m1,' m2=',m2,' m3=',m3
c	  print *,' n1=',n1,' n2=',n2,' n3=',n3
c	  print *,'time=',timer()
c	  print *,'input x1 real ='
c	  do k=1,n3
c		do j=1,n2
c			print '(4e12.5)',(x1(i,j,k),i=1,n1)
c		end do
c	  end do
c	  print *,'input x1 imaj ='
c	  do k=n3+1,2*n3
c		do j=1,n2
c			print '(4e12.5)',(x1(i,j,k),i=1,n1)
c		end do
c	  end do
	  if(is.eq.1)then 
		inverse=.false.
	  else
		inverse=.true.
	  endif
	  call tabfft(w,n1)
c	  print *,'first w:'
c	  print '(4e12.5)',(w(i),i=1,n1/2)
	  do k=1,n3
		do j=1,n2
			do i=1,n1
				z(i)=cmplx(x1real(i,j,k),x1imag(i,j,k))
			end do
			call fft(z,inverse,w,n1,m1)
			do i=1,n1
				x1real(i,j,k)=real(z(i))
				x1imag(i,j,k)=aimag(z(i))
			end do
		end do
	  end do
c	  print *,'Time after first stage=',timer()
	  call tabfft(w,n2)
c	  print *,'second w:'
c	  print '(4e12.5)',(w(i),i=1,n2/2)
	  do k=1,n3
		do j=1,n1
			do i=1,n2
				z(i)=cmplx(x1real(j,i,k),x1imag(j,i,k))
			end do
			call fft(z,inverse,w,n2,m2)
			do i=1,n2
				x1real(j,i,k)=real(z(i))
				x1imag(j,i,k)=aimag(z(i))
			end do
		end do
	  end do
c	  print *,'Time after second stage=',timer()
	  call tabfft(w,n3)
c	  print *,'second w:'
c	  print '(4e12.5)',(w(i),i=1,n3/2)
	  do k=1,n2
		do j=1,n1
			do i=1,n3
				z(i)=cmplx(x1real(j,k,i),x1imag(j,k,i))
			end do
			call fft(z,inverse,w,n3,m3)
			do i=1,n3
				x1real(j,k,i)=real(z(i))
				x1imag(j,k,i)=aimag(z(i))
			end do
		end do
	  end do
c	  print *,'Time after third stage=',timer()
c	  print *,'output x1 real ='
c	  do k=1,n3
c		do j=1,n2
c			print '(4e12.5)',(x1(i,j,k),i=1,n1)
c		end do
c	  end do
c	  print *,'output x1 imaj ='
c	  do k=n3+1,2*n3
c		do j=1,n2
c			print '(4e12.5)',(x1(i,j,k),i=1,n1)
c		end do
c	  end do
C
      RETURN
      END

      subroutine fft( x,inverse,w,nx,lnx )
      complex x(nx),
     $        w(nx/2)
      logical  inverse

c   fft
c   (note that variable iter = log(base 2) of nx

      real    rnx
      complex t,
     $        wk

      integer itab(12)
      integer iter

      data itab / 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048 /
      iter=lnx

      nxp2 = nx
      rnx  = 1./float(nx)

      do 30 it = 1,iter
         n = 1
         nxp = nxp2
         nxp2 = nxp/2
         do 20 m = 1,nxp2
			if( inverse ) then
				wk = conjg(w(n))
			else
				wk = w(n)
			end if
            do 10 mxp = nxp,nx,nxp
               j1 = mxp - nxp + m
               j2 = j1 + nxp2
                  t = x(j1) - x(j2)
                  x(j1) = x(j1) + x(j2)
                  x(j2) = t*wk
c	  print *,'it=',it,' m=',m,' mxp=',mxp,' j1=',j1,' j2=',j2
  10        continue
            n = n +itab(it)
  20     continue
  30  continue

      n2 = nx/2
      n1 = nx - 1
      j = 1

      do i = 1,n1
		if( i .lt. j ) then
			t = x(j)
			x(j) = x(i)
			x(i) = t
		end if
        k = n2
  42    if( k .lt. j ) then
            j = j - k
            k = k/2
            go to 42
		end if
         j = j + k
      end do

      if( inverse ) then
         do k = 1,nx
            x(k) = rnx*x(k)
         end do
      end if

      end
      subroutine tabfft(w,nx)
c----------------------------------------------------------------------
c     calculate some arrays needed for the fft filter
c----------------------------------------------------------------------
      complex w(nx/2)

      do 1 i=1,nx/2
      arg = (i-1)*3.141592653589793/float(nx/2)
      w(i) = cmplx(cos(arg),sin(arg))
   1  continue
      return
      end
c
      real*8 function timer()
      real*4 etime, tarray(2)
      timer = etime(tarray)
      end

!
! SPDX-FileCopyrightText: Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
! SPDX-License-Identifier: LicenseRef-NvidiaProprietary
!
! NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
! property and proprietary rights in and to this material, related
! documentation and any modifications thereto. Any use, reproduction,
! disclosure or distribution of this material and related documentation
! without an express license agreement from NVIDIA CORPORATION or
! its affiliates is strictly prohibited.
!

!
! Jacobi iteration example using Do Concurrent in Fortran
! Build with to target NVIDIA GPU
!   nvfortran -stdpar -Minfo=accel -fast f3.f90
! Build with to target host multicore
!   nvfortran -stdpar=multicore -Minfo=accel -fast f3.f90
!
module sm
contains
 subroutine smooth( a, b, w0, w1, w2, n, m, niters )
  real, dimension(:,:) :: a,b
  real :: w0, w1, w2
  integer :: n, m, niters
  integer :: i, j, iter
   do iter = 1,niters
    do concurrent(i=2 : n-1, j=2 : m-1) 
      a(i,j) = w0 * b(i,j) + &
               w1 * (b(i-1,j) + b(i,j-1) + b(i+1,j) + b(i,j+1)) + &
               w2 * (b(i-1,j-1) + b(i-1,j+1) + b(i+1,j-1) + b(i+1,j+1))
    enddo
    do concurrent(i=2 : n-1, j=2 : m-1)
      b(i,j) = w0 * a(i,j) + &
               w1 * (a(i-1,j) + a(i,j-1) + a(i+1,j) + a(i,j+1)) + &
               w2 * (a(i-1,j-1) + a(i-1,j+1) + a(i+1,j-1) + a(i+1,j+1))
    enddo
   enddo
 end subroutine
 
 subroutine smoothhost( a, b, w0, w1, w2, n, m, niters )
  real, dimension(:,:) :: a,b
  real :: w0, w1, w2
  integer :: n, m, niters
  integer :: i, j, iter
   do iter = 1,niters
    do i = 2,n-1
     do j = 2,m-1
      a(i,j) = w0 * b(i,j) + &
               w1 * (b(i-1,j) + b(i,j-1) + b(i+1,j) + b(i,j+1)) + &
               w2 * (b(i-1,j-1) + b(i-1,j+1) + b(i+1,j-1) + b(i+1,j+1))
     enddo
    enddo
    do i = 2,n-1
     do j = 2,m-1
      b(i,j) = w0 * a(i,j) + &
               w1 * (a(i-1,j) + a(i,j-1) + a(i+1,j) + a(i,j+1)) + &
               w2 * (a(i-1,j-1) + a(i-1,j+1) + a(i+1,j-1) + a(i+1,j+1))
     enddo
    enddo
   enddo
 end subroutine
end module

program main
 use sm
 implicit none
 real,dimension(:,:),allocatable :: aahost, bbhost, aapar, bbpar
 real :: w0, w1, w2
 integer :: i,j,n,m,iters
 integer :: c0, c1, c2, c3, c4, cpar, cseq
 integer :: errs, args
 character(10) :: arg
 real :: dif, tol

 n = 1000
 m = n
 iters = 100

 allocate( aapar(n,m) )
 allocate( bbpar(n,m) )
 allocate( aahost(n,m) )
 allocate( bbhost(n,m) )
 do i = 1,n
   do j = 1,m
     aapar(i,j) = 0
     bbpar(i,j) = i*1000 + j
     aahost(i,j) = 0
     bbhost(i,j) = i*1000 + j
   enddo
 enddo
 w0 = 0.5
 w1 = 0.3
 w2 = 0.2
 call system_clock( count=c1 )
 call smooth( aapar, bbpar, w0, w1, w2, n, m, iters )
 call system_clock( count=c2 )
 cpar = c2 - c1
 call smoothhost( aahost, bbhost, w0, w1, w2, n, m, iters )
 call system_clock( count=c3)
 cseq = c3 - c2
 ! check the results
 errs = 0
 tol = 0.000005
 do i = 1,n
  do j = 1,m
   dif = abs(aapar(i,j) - aahost(i,j))
   if( aahost(i,j) .ne. 0 ) dif = abs(dif/aahost(i,j))
   if( dif .gt. tol )then
    errs = errs + 1
    if( errs .le. 10 )then
     print *, i, j, aapar(i,j), aahost(i,j)
    endif
   endif
  enddo
 enddo
 print *, cpar, ' microseconds on parallel with do concurrent'
 print *, cseq, ' microseconds on sequential'
 if (errs .ne. 0) then
    print *, "Test FAILED"
    print *, errs, ' errors found'
 else
    print *, "Test PASSED"
 endif

end program

! 
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.
!
!
!    These example codes are a portion of the code samples from the companion
!    website to the book "CUDA Fortran for Scientists and Engineers":
!
! http://store.elsevier.com/product.jsp?isbn=9780124169708
!

module timing
  interface wallclock
     function wallclock() result(res) bind(C, name='wallclock')
       use iso_c_binding
       real (c_double) :: res
     end function wallclock
  end interface wallclock
end module timing

program testcublas2
call cublasTestOmpInteger (1000)
call cublasTestOmpInteger8(1000)
call cublasTestOmpReal    (1000)
call cublasTestOmpDouble  (1000)
end
!
subroutine cublasTestOmpInteger(n)
use cublas_v2
use omp_lib
integer :: a(n), b(n)
integer :: ierr
type( cublasHandle ) :: handle

a = 1
b = 2
ierr = cublasCreate( handle )
ierr = ierr + cublasSetStream(handle,ompx_get_cuda_stream(omp_get_default_device(), .false.))
!$omp target enter data map( to: a(1:n), b(1:n) )
!$omp target data use_device_ptr( a, b )
call sswap(n, a, 1, b, 1)
ierr = cublasSswap(handle, n, a, 1, b, 1)
!$omp end target data
!$omp target exit data map( from: a, b )
if (all(a.eq.1).and.all(b.eq.2)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
ierr = cublasDestroy( handle )
end
!
subroutine cublasTestOmpInteger8(n)
use cublas_v2
use omp_lib
integer(8) :: a(n), b(n)
integer :: ierr
type( cublasHandle ) :: handle

a = 1
b = 2
ierr = cublasCreate( handle )
ierr = ierr + cublasSetStream(handle,ompx_get_cuda_stream(omp_get_default_device(), .false.))
!$omp target enter data map( to: a(1:n), b(1:n) )
!$omp target data use_device_ptr( a, b )
call dswap(n, a, 1, b, 1)
ierr = cublasDswap(handle, n, a, 1, b, 1)
!$omp end target data
!$omp target exit data map( from: a, b )
if (all(a.eq.1).and.all(b.eq.2)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
ierr = cublasDestroy( handle )
end
!
subroutine cublasTestOmpReal(n)
use cublas_v2
use omp_lib
real :: a(n), b(n)
integer :: ierr
type( cublasHandle ) :: handle

a = 1.
b = 2.
ierr = cublasCreate( handle )
ierr = ierr + cublasSetStream(handle,ompx_get_cuda_stream(omp_get_default_device(), .false.))
!$omp target enter data map( to: a(1:n), b(1:n) )
!$omp target data use_device_ptr( a, b )
call sswap(n, a, 1, b, 1)
ierr = cublasSswap(handle, n, a, 1, b, 1)
!$omp end target data
!$omp target exit data map( from: a, b )
if (all(a.eq.1.).and.all(b.eq.2.)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
ierr = cublasDestroy( handle )
end
!
subroutine cublasTestOmpDouble(n)
use cublas_v2
use omp_lib
real(8) :: a(n), b(n)
integer :: ierr

type( cublasHandle ) :: handle
a = 1.0d0
b = 2.0d0
ierr = cublasCreate( handle )
ierr = ierr + cublasSetStream(handle,ompx_get_cuda_stream(omp_get_default_device(), .false.))
!$omp target enter data map( to: a(1:n), b(1:n) )
!$omp target data use_device_ptr( a, b )
call dswap(n, a, 1, b, 1)
ierr = cublasDswap(handle, n, a, 1, b, 1)
!$omp end target data
!$omp target exit data map( from: a, b )
if (all(a.eq.1.0d0).and.all(b.eq.2.0d0)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
ierr = cublasDestroy( handle )
end

module rayTracing
#ifdef _CUDA
  use rgbCUDA
  use curand_device
  use cudafor
#else
  use rgbHost
#endif

#ifdef _CUDA
#define c_hostDevPtr c_devptr
#define c_hostDevLoc c_devloc
#else
#define c_hostDevPtr c_ptr
#define c_hostDevLoc c_loc
#endif
    
  use iso_c_binding

  ! anti-aliasing parameter
  integer :: nRaysPerPixel
  !@cuf attributes(managed) :: nRaysPerPixel

  !@cuf type(curandStateXORWOW), device, allocatable :: randState_d(:,:)
  
  type ray
     real :: origin(3)
     real :: dir(3)
  end type ray
  
  interface ray
     module procedure rayConstructor
  end interface ray

  ! material types

  enum, bind(c)
     enumerator :: lambMat = 1, metalMat = 2, dielMat = 3
  end enum

  type lambertian
     type(rgb) :: albedo
  end type lambertian

  type metal
     type(rgb) :: albedo
     real :: fuzz
  end type metal
    
  type dielectric
     real :: refractiveIndex
  end type dielectric
  
  ! objects

  type sphere
     real :: center(3), radius
     integer :: materialType
     type(c_hostDevPtr) :: matPtr
  end type sphere

  type environs
     integer :: nSpheres
     type(sphere), &
          !@cuf managed, &
          allocatable :: spheres(:)
  end type environs

  type hitRecord
     real :: t
     real :: p(3)
     real :: normal(3)
     integer :: materialType
     type(c_hostDevPtr) :: matPtr
  end type hitRecord

  type camera
     real :: lowerLeftCorner(3)
     real :: horizontal(3)
     real :: vertical(3)
     real :: origin(3)
     real :: u(3), v(3), w(3)
     real :: lensRadius
  end type camera

  interface camera
     module procedure cameraConstructor
  end interface camera
  
  interface randomNumber
     module procedure :: rngScalar, rngArray
  end interface randomNumber

contains

#ifdef _CUDA
  attributes(device) function rngScalar() result(res)
    implicit none
    real :: res
    integer :: i, j
    type(curandStateXORWOW) :: h
    i = (blockIdx%x-1)*blockDim%x + threadIdx%x
    j = (blockIdx%y-1)*blockDim%y + threadIdx%y
    h = randState_d(i,j)
    res = curand_uniform(h)
    randState_d(i,j) = h
  end function rngScalar

  attributes(device) function rngArray(n) result(res)
    implicit none
    integer, intent(in) :: n
    real :: res(n)
    integer :: i, j, k
    type(curandStateXORWOW) :: h
    i = (blockIdx%x-1)*blockDim%x + threadIdx%x
    j = (blockIdx%y-1)*blockDim%y + threadIdx%y
    h = randState_d(i,j)
    do k = 1, n
       res(k) = curand_uniform(h)
    end do
    randState_d(i,j) = h
  end function rngArray
#else
  function rngScalar() result(res)
    real :: res
    call random_number(res)
  end function rngScalar

  function rngArray(n) result(res)
    integer, intent(in) :: n
    real :: res(n)
    call random_number(res)
  end function rngArray
#endif

  function cross(a, b) result(c)
    implicit none
    real :: a(3), b(3), c(3)
    c(1) = a(2)*b(3) - a(3)*b(2)
    c(2) = a(3)*b(1) - a(1)*b(3)
    c(3) = a(1)*b(2) - a(2)*b(1)
  end function cross
  
  !@cuf attributes(device) &
  function randomPointInUnitSphere() result(res)
    implicit none
    real :: res(3)
    do
       res = randomNumber(3)
       res = 2*res - 1.0
       if (sum(res**2) <= 1.0) exit
    enddo
  end function randomPointInUnitSphere

  !@cuf attributes(device) &
  function randomPointInUnitDisk() result(res)
    implicit none
    real :: res(2)
    do
       res = randomNumber(2)
       res = 2*res - 1.0
       if (sum(res**2) <= 1.0) exit
    enddo
  end function randomPointInUnitDisk

    
  subroutine environsAlloc(env)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    allocate(env%spheres(env%nSpheres))
  end subroutine environsAlloc
  
  !@cuf attributes(device) &
  function normalize(a) result(res)
    implicit none
    real :: a(3), res(3)

    res = a/sqrt(sum(a**2))
  end function normalize

  !@cuf attributes(device) &
  function rayConstructor(origin, dir) result(r)
    implicit none
    !dir$ ignore_tkr (d) origin, (d) dir
    real :: origin(3), dir(3)
    type(ray) :: r
    r%origin = origin
    r%dir = normalize(dir)
  end function rayConstructor

  function cameraConstructor(lookFrom, lookAt, vup, vfov, aspect, &
       aperture, distToFocus) result(cam)
    implicit none
    real :: lookFrom(3), lookAt(3), vup(3), vfov, aspect
    real, optional :: aperture, distToFocus
    type(camera) :: cam
    
    real :: u(3), v(3), w(3), theta, halfHeight, halfWidth, pi
    real :: focalLength

    w = (lookFrom - lookAt)/sqrt(sum((lookFrom-lookAt)**2))
    u = cross(vup, w)/sqrt(sum(cross(vup, w)**2))
    v = cross(w, u)

    pi = 4.0*atan(1.0)
    theta = vfov*pi/180.0
    halfHeight = tan(theta/2.0)
    halfWidth = halfHeight*aspect

    if (present(distToFocus)) then
       focalLength = distToFocus
    else
       focalLength = 1.0
    end if
    
    cam%origin = lookFrom
    cam%lowerLeftCorner = cam%origin &
         - focalLength*(halfWidth*u + halfHeight*v + w)
    cam%horizontal = 2.0*halfWidth*u*focalLength
    cam%vertical = 2.0*halfHeight*v*focalLength
    cam%u = u
    cam%v = v
    cam%w = w
    if (present(aperture)) then
       cam%lensRadius = aperture/2
    else
       cam%lensRadius = 0.0
    end if

  end function cameraConstructor

  !@cuf attributes(device) &
  function reflect(rin, n) result(res)
    implicit none
    type(ray) :: rin
    real :: n(3)
    real :: res(3)
    res = rin%dir - 2.0*dot_product(rin%dir,n)*n
  end function reflect

  !@cuf attributes(device) &
  function refract(rin, n, niOverNt, refDir) result(res)
    implicit none
    type(ray) :: rin        ! incident ray
    real :: n(3)            ! unit surface normal
    real :: niOverNt        ! incident/transmitted refractive index ratio
    real :: refDir(3)       ! direction of refracted ray 
    logical :: res          ! refracted (.true.) or reflected (.false.)

    real :: rproj, cosT2

    rproj = dot_product(rin%dir,n)
    cosT2 = 1.0 - niOverNt**2*(1-rproj**2)
    if (cosT2 > 0.0) then
       refDir = niOverNt*(rin%dir - rproj*n) - sqrt(cosT2)*n
       res = .true.      
    else
       res = .false.
    end if
  end function refract


   
  !@cuf attributes(device) &
  function scatter(rin, rec, attenuation, rscattered) result(res)
    implicit none
    type(ray) :: rin
    type(hitRecord) :: rec
    type(rgb) :: attenuation
    type(ray) :: rscattered
    logical :: res

    type(lambertian) :: lambPtr; pointer(lambCrayP, lambPtr)
    type(metal) :: metalPtr;     pointer(metalCrayP, metalPtr)
    type(dielectric) :: dielPtr; pointer(dielCrayP, dielPtr)
    real :: n(3), dir(3)

    if (rec%materialType == lambMat) then

       n = normalize(rec%normal)
       dir = n + randomPointInUnitSphere()
       rscattered = ray(rec%p, dir)
       lambCrayP = transfer(rec%matPtr, lambCrayP)
       attenuation = lambPtr%albedo
       res = .true.

    else if (rec%materialType == metalMat) then

       n = normalize(rec%normal)
       metalCrayP = transfer(rec%matPtr, metalCrayP)
       dir = reflect(rin, n) + metalPtr%fuzz*randomPointInUnitSphere()
       rscattered = ray(rec%p, dir)
       attenuation = metalPtr%albedo
       res = (dot_product(rscattered%dir, n) > 0)

    else if (rec%materialType == dielMat) then

       attenuation = [1.0, 1.0, 1.0]
       block
         real :: niOverNt, cosine, rn, reflectProb

         dielCrayP = transfer(rec%matPtr, dielCrayP)
         ! determine if inside or outside dielectric
         if (dot_product(rin%dir, rec%normal) > 0.0) then
            ! incident ray in dielectric
            n = -rec%normal
            niOverNt = dielPtr%refractiveIndex
            cosine = niOverNt * &
                 dot_product(rin%dir, rec%normal)/sqrt(sum(rin%dir**2))
         else
            ! incident ray outside dielectric
            n = rec%normal
            niOverNt = 1.0/dielPtr%refractiveIndex
            cosine = - dot_product(rin%dir, rec%normal)/sqrt(sum(rin%dir**2))
         end if
         
         ! determine if scattered ray is refracted or reflected
         if (refract(rin, n, niOverNt, dir)) then
            reflectProb = schlick(cosine, dielPtr%refractiveIndex)
         else
            reflectProb = 1.0
         end if
         
         rn = randomnumber()
         if (rn < reflectProb) then       
            dir = reflect(rin, rec%normal)
            rscattered = ray(rec%p, dir)
         else
            rscattered = ray(rec%p, dir)
         end if
         res = .true.
       end block

    endif
                
  end function scatter

  ! Schlick approximation
  !@cuf attributes(device) &
  function schlick(cosine, refractiveIndex) result(res)
    implicit none
    real :: cosine, refractiveIndex
    real :: res
    res = ((1-refractiveIndex)/(1+refractiveIndex))**2
    res = res + (1.0-res)*(1-cosine)**5    
  end function schlick

  
  !@cuf attributes(device) &
  function hitSphere(s, r, tmin, tmax, rec) result(res)
    implicit none
    type(sphere) :: s
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    real :: oc(3), a, b, c, disc, t

    oc = r%origin - s%center
    a = dot_product(r%dir, r%dir)
    b = 2.0*dot_product(r%dir, oc)
    c = dot_product(oc, oc) - s%radius**2
    disc = b**2 - 4.0*a*c
    if (disc >= 0.0) then
       t = (-b -sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          rec%materialType = s%materialType
          rec%matPtr = s%matPtr
          res = .true.
          return
       end if
       t = (-b +sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          rec%materialType = s%materialType
          rec%matPtr = s%matPtr
          res = .true.
          return
       end if
    end if
    res = .false.
  end function hitSphere

  !@cuf attributes(device) &
  function hitEnvirons(env, r, tmin, tmax, rec) result(res)
    implicit none
    type(environs) :: env
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    type(hitRecord) :: recl
    integer :: i
    real :: closest

    closest = tmax
    res = .false.

    do i = 1, env%nSpheres
       if (hitSphere(env%spheres(i), r, tmin, closest, recl)) then
          res = .true.
          rec = recl
          closest = recl%t
       end if
    end do
  end function hitEnvirons

  !@cuf attributes(device) &
  function color(r, env) result(res)
    implicit none
    integer, parameter :: maxDepth = 50
    real, parameter :: shadowAcne = 0.001
    type(ray) :: r
    type(environs) :: env
    type(rgb) :: res

    type(ray) :: lRay, scRay
    type(hitRecord) :: rec
    real :: t, n(3)
    type(rgb) :: attenuation, scAtten
    integer :: depth
    
    attenuation = [1.0, 1.0, 1.0]
    lRay = r

    res = [0.0, 0.0, 0.0]
    do depth = 1, maxDepth
       if (hitEnvirons(env, lRay, shadowAcne, huge(t), rec)) then
          if (scatter(lray, rec, scAtten, scRay)) then
             attenuation = scAtten*attenuation
             lRay = scRay
          else
             res = [0.0, 0.0, 0.0]
             return
          endif
       else
          t = 0.5*(lray%dir(2) + 1.0)  
          res = rgb((1.0-t)*[1.0, 1.0, 1.0] + t*[0.5, 0.7, 1.0])
          res = res * attenuation
          return
       endif
    end do
  end function color

#ifdef _CUDA  
  attributes(global) subroutine renderKernel(fb, nx, ny, env, cam)

    implicit none
    type(rgb) :: fb(nx,ny)
    integer, value :: nx, ny
    type(environs) :: env
    type(camera) :: cam
    
    type(ray) :: r
    real :: dir(3)
    real :: rd(2), origin(3)
    real :: u, v
    integer :: i, j

    integer :: ir
    type(rgb) :: c   

    type(curandStateXORWOW) :: h
    integer(8) :: seed, seq, offset
    
    i = threadIdx%x + (blockIdx%x-1)*blockDim%x
    j = threadIdx%y + (blockIdx%y-1)*blockDim%y

    if (i <= nx .and. j <= ny) then

       ! initialize RNG
       seed = nx*(j-1) + i + 4321
       seq = 0
       offset = 0
       call curand_init(seed, seq, offset, randState_d(i,j))
    
       c = [0.0, 0.0, 0.0]
       do ir = 1, nRaysPerPixel
          u = (real(i-1)+randomNumber())/nx
          v = (real(j-1)+randomNumber())/ny

          ! defocus blur origin
          rd = randomPointInUnitDisk()
          origin = cam%origin + &
               cam%lensRadius*rd(1)*cam%u + cam%lensRadius*rd(2)*cam%v

          dir = cam%lowerLeftCorner + &
               u*cam%horizontal + v*cam%vertical - origin
          r = ray(origin, dir)
          c = c + color(r, env)
       end do
       fb(i,j) = c/nRaysPerPixel
    end if
  end subroutine renderKernel
#endif
    
  subroutine render(fb, env, cam)
    !@cuf use cudafor
    implicit none
    type(rgb) :: fb(:,:)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    type(camera) :: cam
    !@cuf attributes(managed) :: cam

    type(ray) :: r
    real :: u, v
    integer :: nx, ny, i, j

    integer :: ir
    real :: rn(2)
    type(rgb) :: c
    real :: rd(2), origin(3)

    nx = size(fb,1)    
    ny = size(fb,2)

#ifdef _CUDA
    block
      type(rgb), device, allocatable :: fb_d(:,:)
      type(dim3) :: tBlock, grid
      
      allocate(fb_d(nx,ny))
      tBlock = dim3(32,8,1)
      grid = dim3((nx-1)/tBlock%x+1, (ny-1)/tBlock%y+1, 1)
      call renderKernel<<<grid, tBlock>>>(fb_d, nx, ny, env, cam)
      fb = fb_d
      deallocate(fb_d)
    end block
#else    
    do j = 1, ny
       do i = 1, nx
          c = [0.0, 0.0, 0.0]
          do ir = 1, nRaysPerPixel
             call random_number(rn)
             u = (real(i-1) + rn(1))/nx
             v = (real(j-1) + rn(2))/ny

             ! defocus blur offset
             rd = randomPointInUnitDisk()
             origin = cam%origin + &
                  cam%lensRadius*rd(1)*cam%u + cam%lensRadius*rd(2)*cam%v

             r = ray(origin, cam%lowerLeftCorner + &
                  u*cam%horizontal + v*cam%vertical - origin)
             c = c + color(r, env)
          end do
          fb(i,j) = c/nRaysPerPixel
       end do
    end do
#endif
  end subroutine render
  
end module rayTracing

program main
  use rayTracing
  implicit none
  integer, parameter :: nx = 400, ny = 200
  integer :: i, j
  type(rgb) :: fb(nx,ny)
  type(environs) :: env
  !@cuf attributes(managed) :: env
  type(camera) :: cam
  !@cuf attributes(managed) :: cam

  type(lambertian) :: lambArr(2)
  !@cuf attributes(device) :: lambArr
  type(metal) :: metalArr(1)
  !@cuf attributes(device) :: metalArr
  type(dielectric) :: dielArr(1)
  !@cuf attributes(device) :: dielArr
  type(c_hostDevPtr) :: cPtr

  ! setup environment
  env%nSpheres = 5
  call environsAlloc(env)

  lambArr(1) = lambertian(rgb([0.1, 0.2, 0.5]))
  cPtr = c_hostDevLoc(lambArr(1))
  env%spheres(1) = sphere([0.0, 0.0, -1.0], 0.5, lambMat, cPtr)

  lambArr(2)= lambertian(rgb([0.8, 0.8, 0.0]))
  cPtr = c_hostDevLoc(lambArr(2))
  env%spheres(2) = sphere([0.0, -100.5, -1.0], 100.0, lambMat, cPtr)

  metalArr(1) = metal(rgb([0.8, 0.6, 0.2]), 0.0)
  cPtr = c_hostDevLoc(metalArr(1))
  env%spheres(3) = sphere([1.0, 0.0, -1.0], 0.5, metalMat, cPtr)
  
  dielArr(1) = dielectric(1.5)
  cPtr = c_hostDevLoc(dielArr(1))
  env%spheres(4) = sphere([-1.0, 0.0, -1.0], 0.5, dielMat, cPtr)  
  env%spheres(5) = sphere([-1.0, 0.0, -1.0], -0.45, dielMat, cPtr)
  
  ! setup camera
  cam = camera( &
       lookFrom = [3.0,3.0,2.0], &
       lookAt = [0.0,0.0,-1.0], &
       vup = [0.0, 1.0, 0.0], &
       vfov = 20.0, &
       aspect = real(nx)/ny, &
       aperture = 2.0, &
       distToFocus = sqrt(sum( ([3.0,3.0,2.0]-[0.0,0.0,-1.0])**2 )))

  ! antialiasing parameter
  nRaysPerPixel = 100
  
  ! allocate RNG state array, initialization done in kernel
  !@cuf allocate(randState_d(nx,ny))
  
  call render(fb, env, cam)
  
  ! ppm output

  print "(a2)", 'P3'   ! indicates RGB colors in ASCII, must be flush left
  print *, nx, ny      ! width and height of image
  print *, 255         ! maximum value for each color
  do j = ny, 1, -1
     do i = 1, nx                
        print "(3(1x,i3))", int(255*sqrt(fb(i,j)%v))
     end do
  end do

end program main

program testcublasxt
call foo1(1000)
call foo2(1000)
call foo3(1000)
call foo4(1000)
end
!
subroutine foo1(n)
use cublasxt
real(4) :: a(n,n), b(n,n), c(n,n), alpha, beta
type(cublasXtHandle) :: h
integer ndevices(1)
a = 1.0
b = 2.0
c = -1.0
alpha = 1.0
beta = 0.0
istat = cublasXtCreate(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
ndevices(1) = 0
istat = cublasXtDeviceSelect(h, 1, ndevices)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtSgemm(h, CUBLAS_OP_N, CUBLAS_OP_N, &
                      n, n, n, &
                      alpha, A, n, B, n, beta, C, n)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtDestroy(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
if (all(c.eq.2.0*n)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
print *,c(1,1),c(n,n)
end
!
subroutine foo2(n)
use cublasxt
real(8) :: a(n,n), b(n,n), c(n,n), alpha, beta
type(cublasXtHandle) :: h
integer ndevices(1)
a = 1.0d0
b = 2.0d0
c = -1.0d0
alpha = 1.0d0
beta = 0.0
istat = cublasXtCreate(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
ndevices(1) = 0
istat = cublasXtDeviceSelect(h, 1, ndevices)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtDgemm(h, CUBLAS_OP_N, CUBLAS_OP_N, &
                      n, n, n, &
                      alpha, A, n, B, n, beta, C, n)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtDestroy(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
if (all(c.eq.2.0d0*n)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
print *,c(1,1),c(n,n)
end
!
subroutine foo3(n)
use cublasXt
complex*8 :: a(n,n), b(n,n), c(n,n), alpha, beta
type(cublasXtHandle) :: h
integer ndevices(1)
a = cmplx(1.,0.)
b = cmplx(2.,0.)
c = cmplx(-1.0,0.)
alpha = cmplx(1.0d0,0.0)
beta = cmplx(0.0,0.0)
istat = cublasXtCreate(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
ndevices(1) = 0
istat = cublasXtDeviceSelect(h, 1, ndevices)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtCgemm(h, CUBLAS_OP_N, CUBLAS_OP_N, &
                      n, n, n, &
                      alpha, A, n, B, n, beta, C, n)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtDestroy(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
if (all(real(c).eq.2.0*n)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
print *,c(1,1),c(n,n)
end
!
subroutine foo4(n)
use cublasXt
complex*16 :: a(n,n), b(n,n), c(n,n), alpha, beta
type(cublasXtHandle) :: h
integer ndevices(1)
a = cmplx(1.0d0,0.0d0)
b = cmplx(2.0d0,0.0d0)
c = cmplx(-1.0d0,0.0d0)
alpha = cmplx(1.0d0,0.0d0)
beta = cmplx(0.0d0,0.0d0)
istat = cublasXtCreate(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
ndevices(1) = 0
istat = cublasXtDeviceSelect(h, 1, ndevices)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtZgemm(h, CUBLAS_OP_N, CUBLAS_OP_N, &
                      n, n, n, &
                      alpha, A, n, B, n, beta, C, n)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
istat = cublasXtDestroy(h)
if (istat .ne. CUBLAS_STATUS_SUCCESS) print *,istat
if (all(dble(c).eq.2.0d0*n)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
print *,c(1,1),c(n,n)
end

program testsort
call dosort(100)
call dosort(500)
call dosort(1000)
call dosort(5000)
end
!
subroutine dosort(n)
use curand
use openacc
interface isort
    subroutine isortf(array, idx, n, stream) &
                       bind(C,name='thrust_float_sort_wrapper')
    import acc_handle_kind
    real, dimension(*), intent(in) :: array
    integer, dimension(*), intent(out) :: idx
!@cuf attributes(device) :: array, idx
    integer, value :: n
    integer(kind=acc_handle_kind), value :: stream
    end subroutine
end interface
real, allocatable :: a(:), b(:)
integer, allocatable :: idx(:)
type(curandGenerator) :: g
integer(kind=acc_handle_kind) :: istream
allocate(a(n))
allocate(b(n))
allocate(idx(n))
a = 0.0
istream = acc_get_cuda_stream(acc_async_sync)
istat = curandCreateGenerator(g,CURAND_RNG_PSEUDO_XORWOW)
istat = curandSetStream(g,istream)
!$acc host_data use_device(a, idx)
  istat = curandGenerate(g, a, n)
  call isort(a, idx, n, istream)
!$acc end host_data
!$acc kernels
x = sum(merge(a, 0.0, (idx/2)*2.ne.idx))
y = sum(merge(a, 0.0, (idx/2)*2.eq.idx))
z = sum(a)
!$acc end kernels
istat = curandDestroyGenerator(g)
print *,x,y,z,z-(x+y)
if (z-(x+y).lt.1e-4) then
  print *,"test PASSED"
else
  print *,"test FAILED"
endif
end

! 
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 


!
! Jacobi iteration example using OpenACC Directives in Fortran
! Build with
!   nvfortran -acc -Minfo=accel -fast f3.f90
!
module sm
contains
 subroutine smooth( a, b, w0, w1, w2, n, m, niters )
  real, dimension(:,:) :: a,b
  real :: w0, w1, w2
  integer :: n, m, niters
  integer :: i, j, iter
  !$acc data copy(a(:,:)) copyin(b(:,:))
   do iter = 1,niters
    !$acc kernels loop
    do i = 2,n-1
     do j = 2,m-1
      a(i,j) = w0 * b(i,j) + &
               w1 * (b(i-1,j) + b(i,j-1) + b(i+1,j) + b(i,j+1)) + &
               w2 * (b(i-1,j-1) + b(i-1,j+1) + b(i+1,j-1) + b(i+1,j+1))
     enddo
    enddo
    !$acc kernels loop
    do i = 2,n-1
     do j = 2,m-1
      b(i,j) = w0 * a(i,j) + &
               w1 * (a(i-1,j) + a(i,j-1) + a(i+1,j) + a(i,j+1)) + &
               w2 * (a(i-1,j-1) + a(i-1,j+1) + a(i+1,j-1) + a(i+1,j+1))
     enddo
    enddo
   enddo
  !$acc end data
 end subroutine
 subroutine smoothhost( a, b, w0, w1, w2, n, m, niters )
  real, dimension(:,:) :: a,b
  real :: w0, w1, w2
  integer :: n, m, niters
  integer :: i, j, iter
   do iter = 1,niters
    do i = 2,n-1
     do j = 2,m-1
      a(i,j) = w0 * b(i,j) + &
               w1 * (b(i-1,j) + b(i,j-1) + b(i+1,j) + b(i,j+1)) + &
               w2 * (b(i-1,j-1) + b(i-1,j+1) + b(i+1,j-1) + b(i+1,j+1))
     enddo
    enddo
    do i = 2,n-1
     do j = 2,m-1
      b(i,j) = w0 * a(i,j) + &
               w1 * (a(i-1,j) + a(i,j-1) + a(i+1,j) + a(i,j+1)) + &
               w2 * (a(i-1,j-1) + a(i-1,j+1) + a(i+1,j-1) + a(i+1,j+1))
     enddo
    enddo
   enddo
 end subroutine
end module

program main
 use sm
 use openacc
 real,dimension(:,:),allocatable :: aa, bb
 real,dimension(:,:),allocatable :: aahost, bbhost
 real :: w0, w1, w2
 integer :: i,j,n,m,iters
 integer :: c0, c1, c2, c3, cgpu, chost
 integer :: errs, args
 character(10) :: arg
 real :: dif, tol

 n = 0
 m = 0
 iters = 0
 args = command_argument_count()
 if( args .gt. 0 )then
   call get_command_argument( 1, arg )
   read(arg,'(i10)') n
   if( args .gt. 1 )then
    call get_command_argument( 2, arg )
    read(arg,'(i10)') m
    if( args .gt. 2 )then
     call get_command_argument( 3, arg )
     read(arg,'(i10)') iters
     if( args .gt. 3 )then
      call get_command_argument( 4, arg )
      if( arg .eq. 'host' .or. arg .eq. 'HOST' )then
       call acc_set_device( acc_device_host )
       print *, 'set host'
      else if( arg .eq. 'nvidia' .or. arg .eq. 'NVIDIA' )then
       call acc_set_device( acc_device_nvidia )
       call acc_init( acc_device_nvidia )
       print *, 'initialize nvidia'
      else
       print *, 'unknown device:', arg
       print *, 'using default'
      endif
     endif
    endif
   endif
 endif
 if( n .le. 0 ) n = 1000
 if( m .le. 0 ) m = n
 if( iters .le. 0 ) iters = 10

 allocate( aa(n,m) )
 allocate( bb(n,m) )
 allocate( aahost(n,m) )
 allocate( bbhost(n,m) )
 do i = 1,n
   do j = 1,m
     aa(i,j) = 0
     bb(i,j) = i*1000 + j
     aahost(i,j) = 0
     bbhost(i,j) = i*1000 + j
   enddo
 enddo
 w0 = 0.5
 w1 = 0.3
 w2 = 0.2
 call system_clock( count=c1 )
 call smooth( aa, bb, w0, w1, w2, n, m, iters )
 call system_clock( count=c2 )
 cgpu = c2 - c1
 call smoothhost( aahost, bbhost, w0, w1, w2, n, m, iters )
 call system_clock( count=c3)
 chost = c3 - c2
 ! check the results
 errs = 0
 tol = 0.000005
 do i = 1,n
  do j = 1,m
   dif = abs(aa(i,j) - aahost(i,j))
   if( aahost(i,j) .ne. 0 ) dif = abs(dif/aahost(i,j))
   if( dif .gt. tol )then
    errs = errs + 1
    if( errs .le. 10 )then
     print *, i, j, aa(i,j), aahost(i,j)
    endif
   endif
  enddo
 enddo
 print *, cgpu, ' microseconds on GPU'
 print *, chost, ' microseconds on host'
 if (errs .ne. 0) then
    print *, "Test FAILED"
    print *, errs, ' errors found'
 else
    print *, "Test PASSED"
 endif

end program

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!

program cufft2dTest
  use cufft
  use openacc
  integer, parameter :: m=768, n=512
  complex, allocatable  :: a(:,:),b(:,:),c(:,:)
  real, allocatable     :: r(:,:),q(:,:)
  integer :: iplan1, iplan2, iplan3, ierr

  allocate(a(m,n),b(m,n),c(m,n))
  allocate(r(m,n),q(m,n))

  a = 1; r = 1
  xmx = -99.0

  ! This block must be in the same program unit as the allocate statements
  ! for this to work without an OpenACC host_data region.
  ! Also must compile with -acc -gpu=managed -cuda.
  ierr = cufftPlan2D(iplan1,m,n,CUFFT_C2C)
  ierr = ierr + cufftSetStream(iplan1,acc_get_cuda_stream(acc_async_sync))

  ierr = ierr + cufftExecC2C(iplan1,a,b,CUFFT_FORWARD)
  ierr = ierr + cufftExecC2C(iplan1,b,c,CUFFT_INVERSE)

  ! scale c
  !$acc kernels
  c = c / (m*n)
  !$acc end kernels

  ! Check forward answer
  write(*,*) 'Max error C2C FWD: ', cmplx(maxval(real(b)) - sum(real(b)), &
                                          maxval(imag(b)))
  ! Check inverse answer
  write(*,*) 'Max error C2C INV: ', maxval(abs(a-c))

  ! Real transform
  ierr = ierr + cufftPlan2D(iplan2,m,n,CUFFT_R2C)
  ierr = ierr + cufftPlan2D(iplan3,m,n,CUFFT_C2R)
  ierr = ierr + cufftSetStream(iplan2,acc_get_cuda_stream(acc_async_sync))
  ierr = ierr + cufftSetStream(iplan3,acc_get_cuda_stream(acc_async_sync))

  ierr = ierr + cufftExecR2C(iplan2,r,b)
  ierr = ierr + cufftExecC2R(iplan3,b,q)

  !$acc kernels
  xmx = maxval(abs(r-q/(m*n)))
  !$acc end kernels

  ! Check R2C + C2R answer
  write(*,*) 'Max error R2C/C2R: ', xmx

  ierr = ierr + cufftDestroy(iplan1)
  ierr = ierr + cufftDestroy(iplan2)
  ierr = ierr + cufftDestroy(iplan3)

  if (ierr.eq.0) then
    print *,"test PASSED"
  else
    print *,"test FAILED"
  endif

end program cufft2dTest

!
! Copyright (c) 2017, NVIDIA Corporation.  All rights reserved.
!
! Please refer to the NVIDIA end user license agreement (EULA) associated
! with this source code for terms and conditions that govern your use of
! this software. Any use, reproduction, disclosure, or distribution of
! this software and related documentation outside the terms of the EULA
! is strictly prohibited.
!

module fp32

    real(kind=4) :: RISKFREE = 0.02
    real(kind=4) :: VOLATILITY = 0.30

contains
 
    real(kind=4)  function CND( d )
        implicit none
        real(kind=4) :: d
        real(kind=4), parameter :: A1 = 0.31938153
        real(kind=4), parameter :: A2 = -0.356563782
        real(kind=4), parameter :: A3 = 1.781477937
        real(kind=4), parameter :: A4 = -1.821255978
        real(kind=4), parameter :: A5 = 1.330274429
        real(kind=4), parameter :: RSQRT2PI = 0.39894228040143267793994605993438
        real(kind=4) :: K, abs, exp
    
        K = 1.0 / ( 1.0 + 0.2316419 * abs(d))
    
        CND = RSQRT2PI * exp(-0.5 * d * d) *          &
                (K * (A1 + K * (A2 + K * (A3 + K * (A4 + K * A5)))))
    
        if( d .gt. 0 ) CND = 1.0 - CND
    
        return
    end function

    subroutine blackscholesbody( callResult, putResult, Sf,Xf,Tf,Rf,Vf)
        implicit none
        real(kind=4) :: Sf, Xf, Tf, Rf, Vf
        real(kind=4) :: callResult, putResult
        real(kind=4) :: S, X, T, R, V
        real(kind=4) :: sqrtT, d1, d2, CNDD1, CNDD2, log, exp, expRT
    
        S = Sf
        X = Xf
        T = Tf
        R = Rf
        V = Vf
    
        sqrtT = sqrt(T)
        d1 = log( S / X ) + (R + 0.5 * V * V * T) / (V * sqrtT)
        d2 = d1 - V * sqrtT
        CNDD1 = CND( d1 )
        CNDD2 = CND( d2 )
    
        expRT = exp( -R * T)
        callResult = ( S * CNDD1 - X * expRT * CNDD2)
        putResult = (X * expRT * ( 1.0 - CNDD2) - S * (1.0 - CNDD1))
      
        return
    end subroutine

    subroutine blackscholes(h_callresult,h_putresult,h_stockprice, &
                            h_optionstrike,h_optionyears, riskfree, &
                            volatility, optN, accelerate)
        use accel_lib
        implicit none
        real(kind=4) :: h_callresult(0:*), h_putresult(0:*), h_stockprice(0:*)
        real(kind=4) :: h_optionstrike(0:*), h_optionyears(0:*), riskfree
        real(kind=4) :: volatility
        integer :: optN, accelerate, i

        real(kind=4) :: Sf, Xf, Tf, Rf, Vf
        real(kind=4) :: callResult, putResult
        real(kind=4) :: S, X, T, R, V
        real(kind=4) :: sqrtT, d1, d2, CNDD1, CNDD2, log, exp, expRT

        !$acc kernels loop if (accelerate > 0)
        !$omp parallel do if (accelerate > 0)
        do i = 0, optN-1
            call blackscholesbody( h_callresult(i), h_putresult(i), &
            h_stockprice(i), h_optionstrike(i), h_optionyears(i), &
            riskfree, volatility )
        enddo
        !$acc end kernels
        !$end parallel do

    end subroutine

    real(kind=4) function randfloat( low, high )
        implicit none
        real(kind=4) :: low, high, t
        call random_number(t)
        randfloat = ( 1.0 - t ) * low + t * high
        return
    end function

end module fp32

program tester
    use fp32
    use accel_lib 
    implicit none
    integer opt_n, opt_sz, iterations, i
    real(kind=4),allocatable,dimension(:) :: callresultcpu, &
                putresultcpu,callresultgpu, putresultgpu, &
                stockprice,optionstrike, optionyears
    real(kind=4) :: delta, ref, sum_delta, sum_ref, max_delta 
    real(kind=4) :: l1norm, gputime, cpu_time
    real(kind=8) :: t(10), ms, msAcc
    
#ifdef _OPENACC
    call acc_init( acc_device_nvidia )
#endif
    
    opt_n = 4000000
    opt_sz = opt_n
    iterations = 10
    
    write(6,*)'Initializing data...'
    
    allocate( callresultcpu(0:opt_sz-1 ) )
    allocate( putresultcpu(0:opt_sz-1 ))
    allocate( callresultgpu(0:opt_sz-1 ))
    allocate( putresultgpu(0:opt_sz-1 ))
    allocate( stockprice(0:opt_sz-1 ))
    allocate( optionstrike(0:opt_sz-1 ))
    allocate( optionyears(0:opt_sz-1 ))
    
    ! generate options set
    
    do i = 0, opt_n-1
        callresultcpu(i) = 0.0
        putresultcpu(i) = -1.0
        callresultgpu(i) = 0.0
        putresultgpu(i) = -1.0
        stockprice(i) = randfloat( 5.0, 30.0 )
        optionstrike(i) = randfloat( 1.0, 100.0 )
        optionyears(i) = randfloat( 0.25, 10.0 )
    enddo
    
    write(6,*)''
    write(6,*)'Running Unaccelerated Version iterations ', iterations
    
    call cpu_time( t(1) )
    do i = 0, iterations-1
        call blackscholes( callresultcpu, putresultcpu,stockprice, &
                           optionstrike, optionyears, RISKFREE, &
                           VOLATILITY, opt_n, 0 )
    enddo
    call cpu_time( t(2) )
    ms = ( t(2) - t(1) ) / real( iterations, kind=8)
    
    write(6,*)''
    write(6,*)'Running Accelerated Version iterations ', iterations
    
    call cpu_time( t(3) )
    do i = 0, iterations-1
        call blackscholes( callresultgpu, putresultgpu,stockprice, &
                           optionstrike, optionyears, RISKFREE, &
                           VOLATILITY, opt_n, 1 )
    enddo
    call cpu_time( t(4) )
    msAcc = ( t(4) - t(3) ) / real( iterations, kind=8)
    
    write(6,*)''
    write(6,*)'Unaccelerated '
    write(6,*)'BlackScholes() time msec ', ms * 1.d3
    write(6,*)'GB/s ', (5.d0 * dble(opt_n) * 4 * 1.d-9) / (ms) 
    write(6,*)'GOptions/s ', (2.d0 * dble(opt_n) * 1.d-9) / (ms) 
    
    write(6,*)''
    write(6,*)'Accelerated '
    write(6,*)'BlackScholes() time msec ', msAcc * 1.d3
    write(6,*)'GB/s ', (5.d0 * dble(opt_n) * 4 * 1.d-9) / (msAcc) 
    write(6,*)'GOptions/s ', (2.d0 * dble(opt_n) * 1.d-9) / (msAcc) 
    
    write(6,*)''
    write(6,*)'Comparing the results...'
    
    sum_delta = 0.0
    sum_ref = 0.0
    max_delta = 0.0
    
    do i = 0, opt_n-1
        ref = callresultcpu(i)
        delta = abs( callresultcpu(i) - callresultgpu(i) )
        if( delta .gt. max_delta ) max_delta = delta
        sum_delta = sum_delta + delta
        sum_ref = sum_ref + abs( ref )
    enddo
    L1norm = sum_delta / sum_ref
    write(6,*)'L1 norm: ', L1norm
    write(6,*)'Max absolute error: ', max_delta

    if (max_delta .gt. 2.0e-5) then
       print *, "Test FAILED"
    else
       print *, "Test PASSED"
    endif
    
    deallocate( optionstrike(0:opt_sz-1 ))
    deallocate( optionyears(0:opt_sz-1 ))
    deallocate( stockprice )
    deallocate( putresultgpu )
    deallocate( putresultcpu )
    deallocate( callresultgpu )
    deallocate( callresultcpu )

end program

program main
  implicit none
  integer, parameter :: n=8
  real :: a(n), b(n)
  integer :: i

  do i = 1, n
     a(i) = i+1
  enddo

  do i = 1, n
     b(i) = a(i)+1
  enddo

  print *, a
  print *, b
end program main

program test_accuracy
  real :: x, y, dist
  double precision:: x_dp, y_dp, dist_dp
  
  x=Z'3F1DC57A'
  y=Z'3F499AA3'
  dist= x**2 +y**2

  x_dp=real(x,8)
  y_dp=real(y,8)
  dist_dp= x_dp**2 +y_dp**2

  print *, 'Result with operands in single precision:'
  print '((2x,z8)) ', dist

  print *, 'Result in double precision with operands'
  print *, 'promoted to double precision:'
  print '((2x,z16))', dist_dp

  print *, 'Result in single precision with operands'
  print *, 'promoted to double precision:'
  print '((2x,z8))', real(dist_dp,4)

end program test_accuracy

program main
  !@cuf use cudafor
  implicit none
  integer, parameter :: n=8
  real :: a(n), b(n)
  !@cuf attributes(managed) :: a, b
  integer :: i

  !$cuf kernel do <<<*,*>>> 
  do i = 1, n
     a(i) = i+1
  enddo

  !$cuf kernel do <<<*,*>>>
  do i = 1, n
     b(i) = a(i)+1
  enddo

  !@cuf i = cudaDeviceSynchronize()
  !@cuf print *, 'GPU version'
  
  print *, a
  print *, b
end program main

module m
contains
  subroutine increment(a, b)
    implicit none
    integer, intent(inout) :: a(:)
    integer, intent(in) :: b
    integer :: i, n

    n = size(a)
    do i = 1, n
       a(i) = a(i)+b
    enddo

  end subroutine increment
end module m


program incrementCPU
  use m
  implicit none
  integer, parameter :: n = 256
  integer :: a(n), b

  a = 1
  b = 3
  call increment(a, b)

  if (any(a /= 4)) then
     print *, '**** Program Failed ****'
  else
     print *, 'Program Passed'
  endif
end program incrementCPU

! 
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.
!
!
!    These example codes are a portion of the code samples from the companion
!    website to the book "CUDA Fortran for Scientists and Engineers":
!
! http://store.elsevier.com/product.jsp?isbn=9780124169708
!

module precision_m
  integer, parameter :: singlePrecision = kind(0.0)
  integer, parameter :: doublePrecision = kind(0.0d0)
  
#ifdef DOUBLE
  integer, parameter :: fp_kind = doublePrecision
#else
  integer, parameter :: fp_kind = singlePrecision
#endif
end module precision_m

program sparseMatVec
    integer n
    n = 25 ! # rows/cols in dense matrix
    call sparseMatVecSub1(n)
    n = 45 ! # rows/cols in dense matrix
    call sparseMatVecSub1(n)
end program

subroutine sparseMatVecSub1(n)
  use openacc
  use cusparse

  implicit none

  integer n

  ! dense data
  real(4), allocatable :: Ade(:,:), x(:), y(:)
  
  ! sparse CSR arrays
  real(4), allocatable :: csrValA(:) 
  integer, allocatable :: nnzPerRowA(:), csrRowPtrA(:), csrColIndA(:)

  allocate(Ade(n,n), x(n), y(n))
  allocate(csrValA(n))
  allocate(nnzPerRowA(n), csrRowPtrA(n+1), csrColIndA(n))

  call sparseMatVecSub2(Ade, x, y, csrValA, nnzPerRowA, csrRowPtrA, &
                                                         csrColIndA, n)
  deallocate(Ade)
  deallocate(x)
  deallocate(y)
  deallocate(csrValA)
  deallocate(nnzPerRowA)
  deallocate(csrRowPtrA)
  deallocate(csrColIndA)
end subroutine

subroutine sparseMatVecSub2(Ade, x, y, csrValA, nnzPerRowA, csrRowPtrA, &
                                                             csrColIndA, n)
  use openacc
  use cusparse

  implicit none

  ! dense data
  real(4) :: Ade(n,n), x(n), y(n)
  
  ! sparse CSR arrays
  real(4) :: csrValA(n) 
  integer :: nnzPerRowA(n), csrRowPtrA(n+1), csrColIndA(n)

  integer :: n, nnz, status, i
  type(cusparseHandle) :: h
  type(cusparseMatDescr) :: descrA
#if CUDA_VERSION >= 11000
  integer(8) :: bsize
  type(c_devptr) :: bdptr
  type(c_ptr) :: bcptr
  integer(1), pointer :: buffer(:)
  integer(1) :: crayp(*); pointer(pbuf,crayp)
  type(cusparseSpMatDescr) :: matA
  type(cusparseDnVecDescr) :: vecX, vecY
#endif
#if CUDA_VERSION >= 12000
  type(cusparseDnMatDescr) :: dnsA
#endif

  ! parameters
  real(4) :: alpha, beta

  ! result
  real(4) :: xerr
  
  ! initalize CUSPARSE and matrix descriptor  
  status = cusparseCreate(h)
  if (status /= CUSPARSE_STATUS_SUCCESS) &
       write(*,*) 'cusparseCreate error: ', status
  status = cusparseCreateMatDescr(descrA)
  status = cusparseSetMatType(descrA, &
       CUSPARSE_MATRIX_TYPE_GENERAL)
  status = cusparseSetMatIndexBase(descrA, &
       CUSPARSE_INDEX_BASE_ONE)
  status = cusparseSetStream(h, acc_get_cuda_stream(acc_async_sync))
  
  !$acc data create(Ade, x, y, csrValA, nnzPerRowA, csrRowPtrA, csrColIndA)

  ! Initialize matrix (upper circular shift matrix)
  !$acc kernels
  Ade = 0.0  
  do i = 1, n-1
     Ade(i,i+1) = 1.0          
  end do
  Ade(n,1) = 1.0

  ! Initialize vectors and constants
  do i = 1, n
     x(i) = i
  enddo
  y = 0.0
  !$acc end kernels

  !$acc update host(x)
  write(*,*) 'Original vector:'
  write(*,'(5(1x,f7.2))') x

  ! convert matrix from dense to csr format
  !$acc host_data use_device(Ade, nnzPerRowA, csrValA, csrRowPtrA, csrColIndA)
  status = cusparseSnnz_v2(h, CUSPARSE_DIRECTION_ROW, &
       n, n, descrA, Ade, n, nnzPerRowA, nnz) 
#if CUDA_VERSION < 12000
  status = cusparseSdense2csr(h, n, n, descrA, Ade, n, &
       nnzPerRowA, csrValA, csrRowPtrA, csrColIndA)
#else
  status = cusparseCreateDnMat(dnsA, n, n, n, Ade, CUDA_R_32F, CUSPARSE_ORDER_COL)
  status = cusparseCreateCsr(matA, n, n, 0, csrRowPtrA, csrColIndA, &
           csrValA, CUSPARSE_INDEX_32I, CUSPARSE_INDEX_32I, &
           CUSPARSE_INDEX_BASE_ONE, CUDA_R_32F)
  status = cusparseDenseToSparse_buffersize(h, dnsA, matA, CUSPARSE_DENSETOSPARSE_ALG_DEFAULT, bsize)
  print *,"DenseToSparse buffersize required: ",bsize
  if (bsize.gt.0) then
    bdptr = acc_malloc(bsize)
    ! One way without CUF is move the c_depvtr to a c_ptr, then call c_f_pointer
    bcptr = transfer(bdptr, bcptr)
    call c_f_pointer(bcptr, buffer, [ bsize ])
  else
    nullify(buffer)
  end if
  status = cusparseDenseToSparse_analysis(h, dnsA, matA, CUSPARSE_DENSETOSPARSE_ALG_DEFAULT, buffer)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseDenseToSparse_analysis: ", status
  status = cusparseDenseToSparse_convert(h, dnsA, matA, CUSPARSE_DENSETOSPARSE_ALG_DEFAULT, buffer)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseDenseToSparse_convert: ", status
  if (bsize.gt.0) call acc_free(bdptr)
  status = cusparseDestroyDnMat(dnsA)
#endif

  !$acc end host_data

  ! A is upper circular shift matrix
  ! y = alpha*A*x + beta*y
  alpha = 1.0
  beta = 0.0
  !$acc host_data use_device(csrValA, csrRowPtrA, csrColIndA, x, y)
#if CUDA_VERSION <= 10020
  status = cusparseScsrmv(h, CUSPARSE_OPERATION_NON_TRANSPOSE, &
       n, n, n, alpha, descrA, csrValA, csrRowPtrA, &
       csrColIndA, x, beta, y)
#else
  status = cusparseCreateDnVec(vecX, n, x, CUDA_R_32F)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseCreateDnVec: ",status

  status = cusparseCreateDnVec(vecY, n, y, CUDA_R_32F)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseCreateDnVec: ",status

  status = cusparseCreateCsr(matA, n, n, nnz, csrRowPtrA, csrColIndA, &
             csrValA, CUSPARSE_INDEX_32I, CUSPARSE_INDEX_32I, &
             CUSPARSE_INDEX_BASE_ONE, CUDA_R_32F)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseCreateCsr: ",status

  status = cusparseSpMV_buffersize(h, CUSPARSE_OPERATION_NON_TRANSPOSE, alpha, &
           matA, vecX, beta, vecY, CUDA_R_32F, CUSPARSE_SPMV_CSR_ALG1, bsize)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseSpMV_buffersize: ",status

  print *,"SpMV buffersize required: ",bsize
  if (bsize.gt.0) then
    bdptr = acc_malloc(bsize)
    ! One way without CUF is move the c_depvtr to a c_ptr, then call c_f_pointer
    bcptr = transfer(bdptr, bcptr)
    call c_f_pointer(bcptr, buffer, [ bsize ])
  else
    nullify(buffer)
  end if

  status = cusparseSpMV(h, CUSPARSE_OPERATION_NON_TRANSPOSE, alpha, &
           matA, vecX, beta, vecY, CUDA_R_32F, CUSPARSE_SPMV_CSR_ALG1, buffer)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseSpMV: ",status
  if (bsize.gt.0) call acc_free(bdptr)
#endif
  !$acc end host_data

  !$acc wait
  write(*,*) 'Shifted vector:'
  write(*,'(5(1x,f7.2))') y

  ! shift-down y and add original x
  ! A' is lower circular shift matrix
  ! x = alpha*A'*y + beta*x
  beta = -1.0
  !$acc host_data use_device(csrValA, csrRowPtrA, csrColIndA, x, y)
#if CUDA_VERSION <= 10020
  status = cusparseScsrmv(h, CUSPARSE_OPERATION_TRANSPOSE, &
       n, n, n, alpha, descrA, csrValA, csrRowPtrA, &
       csrColIndA, y, beta, x)
#else
  status = cusparseSpMV_buffersize(h, CUSPARSE_OPERATION_TRANSPOSE, alpha, &
           matA, vecY, beta, vecX, CUDA_R_32F, CUSPARSE_SPMV_CSR_ALG1, bsize)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseSpMV_buffersize: ",status

  print *,"SpMV buffersize required: ",bsize
  if (bsize.gt.0) then
    bdptr = acc_malloc(bsize)
    ! One way without CUF is to use cray pointers
    pbuf = transfer(bdptr, pbuf)
  end if

  status = cusparseSpMV(h, CUSPARSE_OPERATION_TRANSPOSE, alpha, &
           matA, vecY, beta, vecX, CUDA_R_32F, CUSPARSE_SPMV_CSR_ALG1, crayp)
  if (status.ne.CUSPARSE_STATUS_SUCCESS) print *,"cusparseSpMV: ",status
  if (bsize.gt.0) call acc_free(bdptr)
#endif
  !$acc end host_data

  !$acc kernels
  xerr = maxval(abs(x))
  !$acc end kernels
  !$acc end data

  write(*,*) 'Max error = ', xerr
  if (xerr.le.1.e-5) then
    write(*,*) 'Test PASSED'
  else
    write(*,*) 'Test FAILED'
  endif

end subroutine

module precision_m
  use, intrinsic :: iso_fortran_env
  use iso_fortran_env, only: real32, real64
  integer, parameter :: singlePrecision = real32
  integer, parameter :: doublePrecision = real64
  
#ifdef DOUBLE
  integer, parameter :: fp_kind = doublePrecision
#else
  integer, parameter :: fp_kind = singlePrecision
#endif

end module precision_m

program testcurand1
call foo1(1000)
call foo2(1000)
call foo3(1000)
end
!
subroutine foo1(n)
use curand
integer :: a(n)
type(curandGenerator) :: g
integer(8) nbits
logical passing
a = 0
passing = .true.
istat = curandCreateGeneratorHost(g,CURAND_RNG_PSEUDO_XORWOW)
istat = curandGenerate(g, a, n)
istat = curandDestroyGenerator(g)
nbits = 0
do i = 1, n
  if (i.lt.10) print *,i,a(i)
  nbits = nbits + popcnt(a(i))
end do
print *,"Should be roughly half the bits set"
nbits = nbits / n
if ((nbits .lt. 12) .or. (nbits .gt. 20)) then
  passing = .false.
else
  print *,"nbits is ",nbits," which passes"
endif
if (passing) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end
!
subroutine foo2(n)
use curand
real :: a(n)
type(curandGenerator) :: g
logical passing
a = 0.0
passing = .true.
istat = curandCreateGeneratorHost(g,CURAND_RNG_PSEUDO_XORWOW)
istat = curandGenerate(g, a, n)
istat = curandDestroyGenerator(g)
print *,"Should be uniform around 0.5"
do i = 1, n
  if (i.lt.10) print *,i,a(i)
  if ((a(i).lt.0.0) .or. (a(i).gt.1.0)) passing = .false.
end do
rmean = sum(a)/n
if ((rmean .lt. 0.4) .or. (rmean .gt. 0.6)) then
  passing = .false.
else
  print *,"Mean is ",rmean," which passes"
endif
if (passing) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end
!
subroutine foo3(n)
use curand
real(8) :: a(n)
type(curandGenerator) :: g
logical passing
a = 0.0d0
passing = .true.
istat = curandCreateGeneratorHost(g,CURAND_RNG_PSEUDO_XORWOW)
istat = curandGenerate(g, a, n)
istat = curandDestroyGenerator(g)
do i = 1, n
  if (i.lt.10) print *,i,a(i)
  if ((a(i).lt.0.0d0) .or. (a(i).gt.1.0d0)) passing = .false.
end do
rmean = sum(a)/n
if ((rmean .lt. 0.4d0) .or. (rmean .gt. 0.6d0)) then
  passing = .false.
else
  print *,"Mean is ",rmean," which passes"
endif
if (passing) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end

!
!     Copyright (c) 2020, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!

program cufft2dompTest
  use cufft
  use cudafor ! for cudaDeviceSynchronize
  use omp_lib

  implicit none
  integer, parameter :: m=768, n=512
  complex, allocatable :: a(:,:),b(:,:),c(:,:)
  real   , allocatable :: r(:,:),q(:,:)
  integer :: iplan1, iplan2, iplan3, ierr
  real, dimension(4) :: res

  allocate( a(m,n), b(m,n), c(m,n) )
  allocate( r(m,n), q(m,n) )

  a = 1; r = 1

  ierr = cufftPlan2D(iplan1,m,n,CUFFT_C2C)
  ierr = ierr + cufftSetStream(iplan1,ompx_get_cuda_stream(omp_get_default_device(), .false.))

  ierr = ierr + cufftExecC2C(iplan1,a,b,CUFFT_FORWARD)
  ierr = ierr + cufftExecC2C(iplan1,b,c,CUFFT_INVERSE)

  ierr = ierr + cudaDeviceSynchronize()

  res(1) = maxval( real(b) ) - sum( real(b) )
  res(2) = maxval( imag(b) )
  res(3) = maxval( abs( a - c / (m*n) ) )

  ! Check forward answer
  write(*,*) 'Max error C2C FWD: ', cmplx( res(1), res(2) ) 

  ! Check inverse answer
  write(*,*) 'Max error C2C INV: ', res(3)

  ! Real transform
  ierr = ierr + cufftPlan2D(iplan2,m,n,CUFFT_R2C)
  ierr = ierr + cufftPlan2D(iplan3,m,n,CUFFT_C2R)
  ierr = ierr + cufftSetStream(iplan2,ompx_get_cuda_stream(omp_get_default_device(), .false.))
  ierr = ierr + cufftSetStream(iplan3,ompx_get_cuda_stream(omp_get_default_device(), .false.))

  ierr = ierr + cufftExecR2C(iplan2,r,b)
  ierr = ierr + cufftExecC2R(iplan3,b,q)

  ierr = ierr + cudaDeviceSynchronize()

  res(4) = maxval( abs( r - q / (m*n) ) )

  ! Check R2C + C2R answer
  write(*,*) 'Max error R2C/C2R: ', res(4)

  ierr = ierr + cufftDestroy(iplan1)
  ierr = ierr + cufftDestroy(iplan2)
  ierr = ierr + cufftDestroy(iplan3)

  deallocate( a, b, c )
  deallocate( r, q )

  if (ierr.eq.0 .and. maxval( res ) .lt. 1.e-6) then
    print *,"Test PASSED"
  else
    print *,"Test FAILED, max error =", maxval( res )
  endif

end program cufft2dompTest

!
!  Copyright (c) 2020-2021, NVIDIA CORPORATION & AFFILIATES.  All rights reserved.
!
!  NVIDIA CORPORATION and its licensors retain all intellectual property
!  and proprietary rights in and to this software, related documentation
!  and any modifications thereto.  Any use, reproduction, disclosure or
!  distribution of this software and related documentation without an express
!  license agreement from NVIDIA CORPORATION is strictly prohibited.
!
!  For an existing code that uses OpenMP target offload to accelerate some of
!  the computation but has calls to LAPACK routines (on the CPU), the LAPACK
!  computation can be moved to the GPU by:
!  1. Adding `omp target enter data` directive with appropriate data movement
!  2. Adding `-gpu=nvlamath` to the compile line to access the device call
!     interface
!  3. Adding `-cudalib=nvlamath` to the link line to build the code.

module testUtils

integer(4) :: n, lda, ldb, info
integer(4) :: ii, jj
integer(4) :: cr, t1, t2
real   (8) :: mysecond
real   (8) :: gflops
integer(4), parameter :: m    = 7000
integer(4), parameter :: nrhs = 2

contains
   subroutine init
   use cusolverdn
   implicit none
   n   = m
   lda = m
   ldb = m
   call system_clock( count_rate = cr )
   ! For computing dgetrf gflops
   gflops = ((dble(n)*dble(n)*dble(n)*0.6666666666667d0) + (dble(n)*dble(n))) / 1000000000.0
   end subroutine init

   subroutine setInput( a, b )
   implicit none
   real(8), intent(out) :: a(m,m), b(m,nrhs)
   integer(4) :: seedsize
   integer(4), allocatable :: seed(:)
   call random_seed()
   call random_seed( size = seedsize )
   allocate( seed( seedsize ) )
   seed = 123
   call random_seed( put = seed )
   call random_number( a )
   do ii = 1, n
      b(ii,1) = sum( a(ii,:) )
      b(ii,2) = 2*b(ii,1)
   enddo
   end subroutine setInput

   subroutine checkOutput( x )
   implicit none
   real(8), intent(in) :: x(m,nrhs)
   real(8) :: err(2)
   do ii = 1, 2
     err(ii) = maxval( abs( x(:,ii) - ii ) )
   enddo
   print*, 'Max error     :', maxval(err)

   if ( info .eq. 0 .and. maxval(err) .lt. 1.e-9 ) then
      print*, "Test PASSED"
   else
      print*, "Test FAILED, max error =", maxval(err)
   endif
   end subroutine checkOutput

   subroutine startTimer
   implicit none
   call system_clock(t1)
   end subroutine startTimer

   subroutine endTimer
   implicit none
   real(8) :: t
   call system_clock(t2)
   t = ( t2 - t1 ) / real(cr)
   print*, "Time (seconds):", t
   print*, "GFlops        :", gflops / t
   end subroutine endTimer
end module testUtils

program LUOpenMPTest
use testUtils

call init

! Warm-up and creation of cuSOLVER handle
call LUOpenMP

! Timing
call LUOpenMP

end program LUOpenMPTest

subroutine LUOpenMP
use testUtils
implicit none

real   (8), allocatable :: a(:,:), b(:,:)
integer(4), allocatable :: ipiv(:)

! Setup input
allocate(a(m,n))
allocate(b(m,nrhs))
allocate(ipiv(m))

call setInput(a,b)

! Call LU routines
!$omp target enter data map( to: a, b ) map( alloc: ipiv )
   !$omp target data use_device_ptr( a, ipiv, b )
   call startTimer()
   call dgetrf(m,n,a,lda,ipiv,info)
   call endTimer()
   call dgetrs('n',n,nrhs,a,lda,ipiv,b,ldb,info)
   !$omp end target data
!$omp target exit data map( from: b ) map( delete: a, ipiv )

! Check answer
call checkOutput(b)

deallocate(a)
deallocate(b)
deallocate(ipiv)

end subroutine LUOpenMP

program testcublas2
call foo1(1000)
call foo2(1000)
call foo3(1000)
call foo4(1000)
end
!
subroutine foo1(n)
use cublas
integer :: a(n), b(n)
a = 1
b = 2
!$acc data copy(a, b)
call sswap(n, a, 1, b, 1)
call cublasSswap(n, a, 1, b, 1)
!$acc end data
if (all(a.eq.1).and.all(b.eq.2)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end
!
subroutine foo2(n)
use cublas
integer(8) :: a(n), b(n)
a = 1
b = 2
!$acc data copy(a, b)
call dswap(n, a, 1, b, 1)
call cublasDswap(n, a, 1, b, 1)
!$acc end data
if (all(a.eq.1).and.all(b.eq.2)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end
!
subroutine foo3(n)
use cublas
real :: a(n), b(n)
a = 1.
b = 2.
!$acc data copy(a, b)
call sswap(n, a, 1, b, 1)
call cublasSswap(n, a, 1, b, 1)
!$acc end data
if (all(a.eq.1.).and.all(b.eq.2.)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end
!
subroutine foo4(n)
use cublas
real(8) :: a(n), b(n)
a = 1.0d0
b = 2.0d0
!$acc data copy(a, b)
call dswap(n, a, 1, b, 1)
call cublasDswap(n, a, 1, b, 1)
!$acc end data
if (all(a.eq.1.0d0).and.all(b.eq.2.0d0)) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end

module parameters
  use, intrinsic :: iso_fortran_env
  integer, parameter :: nx = 4096, ny = 4096
  integer, parameter :: iterMax = 100
  integer, parameter :: reportInterval = 10
  integer, parameter :: fp_kind = real32
  real(fp_kind), parameter :: tol = 1.0e-5_fp_kind 
end module parameters
  
module arrays
  use parameters
  real(fp_kind) :: a(nx,ny), aNew(nx,ny), absResidual(2:nx-1,2:ny-1)
  !@cuf real(fp_kind), device :: a_d(nx,ny), aNew_d(nx,ny)
  !@cuf attributes(device) :: absResidual
end module arrays

module laplaceRoutines
contains
  subroutine initialize()
    use parameters
    use arrays
    implicit none
    real(fp_kind), parameter :: &
         pi = 2.0_fp_kind*asin(1.0_fp_kind)
    real(fp_kind) :: y0(nx)
    integer :: i 
    
    do i = 1, nx
       y0(i) = sin(pi*(i-1)/(nx-1))
    enddo
    a = 0.0_fp_kind
    a(:,1) = y0
    a(:,ny) = y0*exp(-pi)   
    aNew = a
    !@cuf aNew_d = aNew
    !@cuf a_d = a
  end subroutine initialize


  subroutine laplaceSolution()
    use parameters
#ifdef _CUDA
    use arrays, only: a => a_d, aNew => aNew_d, absResidual
#else    
    use arrays
#endif
    !@cuf use cudafor
    implicit none
    real(fp_kind) :: maxResidual = 2*tol 
    integer :: iter
    
    iter=0
    do while ( maxResidual > tol .and. iter <= iterMax )
       iter = iter + 1
       call jacobiIteration()
       maxResidual = maxval(absResidual)     
       if(mod(iter,reportInterval) == 0) &
            print '(i8,3x,f10.6)', iter, maxResidual       
       a = aNew
    end do
  end subroutine laplaceSolution


  subroutine jacobiIteration()
    use parameters
#ifdef _CUDA
    use arrays, only: a => a_d, aNew => aNew_d, absResidual
#else
    use arrays
#endif    
    implicit none
    integer :: i, j

    !$cuf kernel do(2) <<<*,*>>>
    do j=2,ny-1
       do i=2,nx-1
          aNew(i,j) = 0.2_fp_kind * & 
               (a(i,j-1)+a(i-1,j)+a(i+1,j)+a(i,j+1)) + &
               0.05_fp_kind * &
               (a(i-1,j-1)+a(i+1,j-1)+a(i-1,j+1)+a(i+1,j+1))
          absResidual(i,j) = abs(aNew(i,j)-a(i,j))
       end do
    end do
  end subroutine jacobiIteration

end module laplaceRoutines


program main
  use parameters
  use arrays
  use laplaceRoutines
  implicit none

  real :: startTime, stopTime

  !@cuf print '(/,a,/)', 'GPU version'
  print '(/,a,i0,a,i0,a)', &
       'Relaxation calculation on ', nx, ' x ', ny, ' mesh'

  print *, 'Iteration   Max Residual'  

  call initialize()

  call cpu_time(startTime)
  call laplaceSolution()

  call cpu_time(stopTime) 
  print '(a,f10.3,a)',  '  Completed in ', &
       stopTime-startTime, ' seconds'
end program main

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 

      program matmul_time
c
#if defined (PGF90)
      include 'lib3f.h'
#else
      real etime
#endif
      integer i, j, k
      integer size, ntimes, m, n, p
      parameter (size=1000)
      parameter (m=size,n=size,p=size)
      parameter (ntimes=5)
      real*8 a, b, c, arow
      dimension a(m,n), b(n,p), c(n,p), arow(n)
!hpf$ distribute (*,block) :: a, b
!hpf$ align c(:,:) with b(:,:) 
c
      integer l
      real walltime, mflops
      integer hz, clock0, clock1, clock2
      integer t, nerrors
      allocatable t(:)
      real tarray(2), time0, time1, time2
!hpf$ distribute t(cyclic)
#if defined (HPF)
      allocate (t(number_of_processors()))
#else
      allocate (t(1))
#endif
#if defined (SYSCLK)
      call system_clock(count_rate=hz)
#endif
c
      do i = 1, m
      do j = 1, n
         a(i,j) = 1.0
      enddo
      enddo
      do i = 1, n
      do j = 1, p
         b(i,j) = 1.0
      enddo
      enddo
      do j = 1, p
      do i = 1, m
         c(i,j) = 0.0
      enddo
      enddo
c
#if defined (SYSCLK)
      call system_clock(count=clock0)
#else
      time0 = etime(tarray)
#endif
      do l = 1, ntimes
#if defined MATMUL
         c = matmul(a, b)
#elif defined BLAS
         call dgemm('no transpose','no transpose',m,n,p,
     &              1.0d0, a, m, b, n, 1.0d0, c, m)
#else
!$omp parallel 
         do i = 1, m
!$omp do
            do ii = 1, n
               arow(ii) = a(i,ii)
            enddo
!hpf$ independent
!$omp do
            do j = 1, p
               do k = 1, n
                  c(i,j) = c(i,j) + arow(k) * b(k,j)
               enddo
            enddo
         enddo
!$omp end parallel
#endif
         call dummy(c)
         call cpu_time(t2)
      enddo
#if defined (SYSCLK)
      call system_clock(count=clock1)
#else
      time1 = etime(tarray)
#endif
      do i = 1, ntimes
         call dummy(c)
      enddo
#if defined (SYSCLK)
      call system_clock(count=clock2)
#else
      time2 = etime(tarray)
#endif
c
#if defined (SYSCLK)
      t = (clock1 - clock0) - (clock2 - clock1)
      walltime = (real(sum(t)) / real(hz)) / real(ntimes)
      mflops = (m*p*(2*n-1)) / (walltime * 1.0e+06)
      print *, walltime, clock0, clock1, clock2
#else
      walltime = ((time1 - time0) - (time2 - time1)) / real(ntimes)
      mflops = (m*p*(2*n-1)) / (walltime * 1.0e+06)
      print *, walltime, time0, time1, time2
#endif
c
      print *, "M =",M,", N =",N,", P =",P
      print *, "MFLOPS = ", mflops

      nerrors = 0
      do j = 1, p
         do i = 1, m
            if (c(i,j) .ne. (dble(size)*dble(ntimes))) then
               nerrors = nerrors + 1
            endif
         enddo
      enddo
      if (nerrors .ne. 0) then
         print *, "Test FAILED"
      else
         print *, "Test PASSED"
      endif
c
      end
c
      subroutine dummy(c)
      return
      end

module rayTracing
#ifdef _CUDA
  use rgbCUDA
#else
  use rgbHost
#endif
  
  real, parameter :: lowerLeftCorner(3) = [-2.0, -1.0, -1.0]
  real, parameter :: horizontal(3) = [4.0, 0.0, 0.0]
  real, parameter :: vertical(3) = [0.0, 2.0, 0.0]
  real, parameter :: origin(3) = [0.0, 0.0, 0.0]

  type ray
     real :: origin(3)
     real :: dir(3)
  end type ray

  interface ray
     module procedure rayConstructor
  end interface ray
  
  type sphere
     real :: center(3), radius
  end type sphere

  type environs
     integer :: nSpheres
     type(sphere), &
          !@cuf managed, &
          allocatable :: spheres(:)
  end type environs

  type hitRecord
     real :: t
     real :: p(3)
     real :: normal(3)
  end type hitRecord
  
contains
  
  subroutine environsAlloc(env)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    allocate(env%spheres(env%nSpheres))
  end subroutine environsAlloc

  !@cuf attributes(device) &
  function normalize(a) result(res)
    implicit none
    real :: a(3), res(3)

    res = a/sqrt(sum(a**2))
  end function normalize

  !@cuf attributes(device) &
  function rayConstructor(origin, dir) result(r)
    implicit none
    !dir$ ignore_tkr (d) origin, (d) dir
    real :: origin(3), dir(3)
    type(ray) :: r
    r%origin = origin
    r%dir = normalize(dir)
  end function rayConstructor


  !@cuf attributes(device) &
  function hitSphere(s, r, tmin, tmax, rec) result(res)
    implicit none
    type(sphere) :: s
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    real :: oc(3), a, b, c, disc, t

    oc = r%origin - s%center
    a = dot_product(r%dir, r%dir)
    b = 2.0*dot_product(r%dir, oc)
    c = dot_product(oc, oc) - s%radius**2
    disc = b**2 - 4.0*a*c
    if (disc >= 0.0) then
       t = (-b -sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          res = .true.
          return
       end if
       t = (-b +sqrt(disc))/(2.0*a)
       if (t > tmin .and. t < tmax) then
          rec%t = t
          rec%p = r%dir*t + r%origin
          rec%normal = (rec%p - s%center)/s%radius
          res = .true.
          return
       end if
    end if
    res = .false.
  end function hitSphere

  !@cuf attributes(device) &
  function hitEnvirons(env, r, tmin, tmax, rec) result(res)
    implicit none
    type(environs) :: env
    type(ray) :: r
    real :: tmin, tmax
    type(hitRecord) :: rec
    logical :: res
    
    type(hitRecord) :: recl
    integer :: i
    real :: closest

    closest = tmax
    res = .false.

    do i = 1, env%nSpheres
       if (hitSphere(env%spheres(i), r, tmin, closest, recl)) then
          res = .true.
          rec = recl
          closest = recl%t
       end if
    end do
  end function hitEnvirons

  !@cuf attributes(device) &
  function color(r, env) result(res)
    implicit none    
    type(ray) :: r
    type(environs) :: env
    type(rgb) :: res

    type(hitRecord) :: rec
    real :: t, n(3)
    
    if (hitEnvirons(env, r, 0.0, huge(t), rec)) then
       n = normalize(rec%normal)
       res = rgb(0.5*(n+1.0))
    else
       t = 0.5*(r%dir(2) + 1.0)  
       res = rgb((1.0-t)*[1.0, 1.0, 1.0] + t*[0.5, 0.7, 1.0])
    endif
  end function color

#ifdef _CUDA  
  attributes(global) subroutine renderKernel(fb, nx, ny, env)
    implicit none
    type(rgb) :: fb(nx,ny)
    integer, value :: nx, ny
    type(environs) :: env
    type(ray) :: r
    real :: dir(3)
    real :: u, v
    integer :: i, j

    i = threadIdx%x + (blockIdx%x-1)*blockDim%x
    j = threadIdx%y + (blockIdx%y-1)*blockDim%y
    if (i <= nx .and. j <= ny) then
       u = real(i)/nx
       v = real(j)/ny
       dir = lowerLeftCorner + u*horizontal + v*vertical - origin
       r = ray(origin, dir)
       fb(i,j) = color(r, env)
    end if
  end subroutine renderKernel
#endif
    
  subroutine render(fb, env)
    !@cuf use cudafor
    implicit none
    type(rgb) :: fb(:,:)
    type(environs) :: env
    !@cuf attributes(managed) :: env
    type(ray) :: r
    real :: u, v
    integer :: nx, ny, i, j
    
    nx = size(fb,1)    
    ny = size(fb,2)

#ifdef _CUDA
    block
      type(rgb), device, allocatable :: fb_d(:,:)
      type(dim3) :: tBlock, grid

      allocate(fb_d(nx,ny))
      tBlock = dim3(32,8,1)
      grid = dim3((nx-1)/tBlock%x+1, (ny-1)/tBlock%y+1, 1)
      call renderKernel<<<grid, tBlock>>>(fb_d, nx, ny, env)
      fb = fb_d
      deallocate(fb_d)
    end block
#else    
    do j = 1, ny
       do i = 1, nx                
          u = real(i)/nx
          v = real(j)/ny
          r = ray(origin, &
               lowerLeftCorner + u*horizontal + v*vertical - origin)
          fb(i,j) = color(r, env)
       end do
    end do
#endif
  end subroutine render
  
end module rayTracing

program main
  use rayTracing
  implicit none
  integer, parameter :: nx = 400, ny = 200
  integer :: i, j
  type(rgb) :: fb(nx,ny)
  type(environs) :: env
  !@cuf attributes(managed) :: env

  env%nSpheres = 2
  call environsAlloc(env)
  
  env%spheres(1) = sphere([0.0, 0.0, -1.0], 0.5)
  env%spheres(2) = sphere([0.0, -100.5, -1.0], 100.0)
  
  call render(fb, env)
  
  ! ppm output

  print "(a2)", 'P3'   ! indicates RGB colors in ASCII, must be flush left
  print *, nx, ny      ! width and height of image
  print *, 255         ! maximum value for each color
  do j = ny, 1, -1
     do i = 1, nx                
        print "(3(1x,i3))", int(255*fb(i,j)%v)
     end do
  end do

end program main

!
! SPDX-FileCopyrightText: Copyright (c) 2017 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
! SPDX-License-Identifier: LicenseRef-NvidiaProprietary
!
! NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
! property and proprietary rights in and to this material, related
! documentation and any modifications thereto. Any use, reproduction,
! disclosure or distribution of this material and related documentation
! without an express license agreement from NVIDIA CORPORATION or
! its affiliates is strictly prohibited.
!

program test_matmul
real*8, dimension(2000,2000) :: a, b, c, c_expd
integer*4 :: n = 2000, m = 2000, l = 2000
real*8 :: t1, t2, t3, t4
integer*4 :: i, j, niters, nerrors

call random_number(a)
call random_number(b)
c = 0.0d0
c_expd = 0.0d0
nerrors = 0
niters = 1   ! was 10000

call cpu_time(t1)
do i = 1, niters
  call matmul_s(a,b,c_expd,n,m,l)
enddo
call cpu_time(t2)

call cpu_time(t3)
do i = 1, niters
  call matmul_p(a,b,c,n,m,l)
enddo
call cpu_time(t4)

do j = 1, m
  do i = 1, n
    if (abs(c(i,j) - c_expd(i,j)) .gt. 0.00000000001) then
       nerrors = nerrors + 1
    endif
  enddo
enddo

print *, "Serial Time(seconds): ",t2-t1
print *, "Parallel Time(seconds): ",t4-t3

if (nerrors .ne. 0) then
  print *, "Test FAILED"
else
  print *, "Test PASSED"
endif
end



subroutine matmul_p(a,b,c,n,m,l)
integer*4 :: n, m, l
real*8, dimension(n,l) :: a
real*8, dimension(l,m) :: b
real*8, dimension(n,m) :: c

integer*4 :: i, j, k

do i = 1, n
  do j = 1, m
    do k = 1, l
       c(i,j) = c(i,j) + (a(i,k) * b(k,m))
    enddo
  enddo
enddo

end

!pgi$r noconcur
subroutine matmul_s(a,b,c,n,m,l)
integer*4 :: n, m, l
real*8, dimension(n,l) :: a
real*8, dimension(l,m) :: b
real*8, dimension(n,m) :: c

integer*4 :: i, j, k

do i = 1, n
  do j = 1, m
    do k = 1, l
       c(i,j) = c(i,j) + (a(i,k) * b(k,m))
    enddo
  enddo
enddo

end

module mtests
  integer, parameter :: n = 1000
  contains
    subroutine testany( a, b )
    use openacc_curand
    real :: a(n), b(n)
    type(curandStateXORWOW) :: h
    integer(8) :: seed, seq, offset

    !$acc parallel num_gangs(1) vector_length(1) copy(a,b) private(h)
    seed = 12345
    seq = 0
    offset = 0
    call curand_init(seed, seq, offset, h)
    !$acc loop seq
    do i = 1, n
      a(i) = curand_uniform(h)
      b(i) = curand_normal(h)
    end do
    !$acc end parallel
    return
    end subroutine
end module mtests

program t
use mtests
real :: a(n), b(n), c(n)
logical passing
a = 1.0
b = 2.0
passing = .true.
call testany(a,b)
c = a
print *,"Should be uniform around 0.5"
do i = 1, n
  if (i.lt.10) print *,i,c(i)
  if ((c(i).lt.0.0) .or. (c(i).gt.1.0)) passing = .false.
end do
rmean = sum(c)/n
if ((rmean .lt. 0.4) .or. (rmean .gt. 0.6)) then
  passing = .false.
else
  print *,"Mean is ",rmean," which passes"
endif
c = b
print *,"Should be normal around 0.0"
nc1 = 0;
nc2 = 0;
do i = 1, n
  if (i.lt.10) print *,i,c(i)
  if ((c(i) .gt. -4.0) .and. (c(i) .lt. 0.0)) nc1 = nc1 + 1
  if ((c(i) .gt.  0.0) .and. (c(i) .lt. 4.0)) nc2 = nc2 + 1
end do
print *,"Found on each side of zero ",nc1,nc2
if (abs(nc1-nc2) .gt. (n/10)) npassing = .false.
rmean = sum(c,mask=abs(c).lt.4.0)/n
if ((rmean .lt. -0.1) .or. (rmean .gt. 0.1)) then
  passing = .false.
else
  print *,"Mean is ",rmean," which passes"
endif

if (passing) then
  print *,"Test PASSED"
else
  print *,"Test FAILED"
endif
end

!
! SPDX-FileCopyrightText: Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
! SPDX-License-Identifier: LicenseRef-NvidiaProprietary
!
! NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
! property and proprietary rights in and to this material, related
! documentation and any modifications thereto. Any use, reproduction,
! disclosure or distribution of this material and related documentation
! without an express license agreement from NVIDIA CORPORATION or
! its affiliates is strictly prohibited.
!

!
! sAXPY example using Do Concurrent construct in Fortran
! Build with
!   nvfortran -stdpar -Minfo -fast saxpy.f90
! Build with to target Multicore
!   nvfortran -stdpar=multicore -Minfo=accel -fast saxpy.f90
!

module sm
    contains
    subroutine saxpy_concurrent(x,y,n,a)
        real,dimension(:) :: x, y
        real :: a
        integer :: n, i  
        do concurrent (i = 1: n)
          y(i) = a*x(i)+y(i)
        enddo  
    end subroutine 

    subroutine saxpy_do(x,y,n,a)
        real,dimension(:) :: x, y
        real :: a
        integer :: n, i  
        do i = 1, n
          y(i) = a*x(i)+y(i)
        enddo  
    end subroutine 
end module

program main
    use sm
    real,dimension(:),allocatable :: x, x2, y
    real :: a = 2.0
    integer :: n, i, err = 0
    integer :: c0, c1, c2, cpar, cseq
    n = 1000000
    allocate(x2(n), x(n), y(n))

    do i = 1, n
       x(i)  = 1
       x2(i) = 1
       y(i)  = i
    enddo

    call system_clock( count=c0 )
    call saxpy_do(x2, y, n, a)
    call system_clock( count=c1 )
    call saxpy_concurrent(x, y, n, a)
    call system_clock( count=c2 )
    cseq = c1 - c0
    cpar = c2 - c1

    do i = 1, n
      if(x(i) .ne. x2(i)) then
          err = err + 1
      endif
    enddo

    print *, cseq, ' microseconds sequential'
    print *, cpar, ' microseconds parallel with stdpar'
    if(err .eq. 0) then
      print *, "Test PASSED"
    else
      print *, "Test FAILED"
    endif

end program

program main
  !@cuf use cudafor
  implicit none
  integer, parameter :: nx = 400, ny = 200
  integer :: i, j
  type rgb
     real :: v(3)
  end type rgb
  type(rgb) :: fb(nx, ny)
  !@cuf type(rgb), device :: fb_d(nx, ny)
  
  !@cuf associate (fb => fb_d)
  !$cuf kernel do (2) <<<*,*>>>
  do j = 1, ny
     do i = 1, nx                
        fb(i,j)%v(1) = real(i)/nx
        fb(i,j)%v(2) = real(j)/ny
        fb(i,j)%v(3) = 0.2
     end do
  end do
  !@cuf end associate

  !@cuf fb = fb_d
  
  ! ppm output

  print "(a2)", 'P3'   ! indicates RGB colors in ASCII, must be flush left
  print *, nx, ny      ! width and height of image
  print *, 255         ! maximum value for each color

  do j = ny, 1, -1
     do i = 1, nx                
        print "(3(1x,i3))", int(255*fb(i,j)%v)
     end do
  end do

end program main

module timing
  interface wallclock
     function wallclock() result(res) bind(C, name='wallclock')
       use iso_c_binding
       real (c_double) :: res
     end function wallclock
  end interface wallclock
end module timing

!
! SPDX-FileCopyrightText: Copyright (c) 2017 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
! SPDX-License-Identifier: LicenseRef-NvidiaProprietary
!
! NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
! property and proprietary rights in and to this material, related
! documentation and any modifications thereto. Any use, reproduction,
! disclosure or distribution of this material and related documentation
! without an express license agreement from NVIDIA CORPORATION or
! its affiliates is strictly prohibited.
!
	program linpack
	common // aa(200,200),a(201,200),b(200),x(200)
	doubleprecision aa,a,b,x
      doubleprecision time(8,6),cray,ops,total,norma,normx
      doubleprecision resid,residn,eps,epslon
      doubleprecision t1,tm2
      integer ipvt(200)
      interface second
      doubleprecision function second() bind (C,name='second')
#ifdef _WIN32
      !dec$ attributes stdcall, decorate :: second
#endif
      end function
      end interface

c	call fpmode(128)
	lda = 201
      ldaa = 200
c
      n = 100
      cray = .056
      ops = (2.0e0*n**3)/3.0e0 + 2.0e0*n**2
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call sgefa(a,lda,n,ipvt,info)
         time(1,1) = second() - t1
         t1 = second()
         call sgesl(a,lda,n,ipvt,b,0)
         time(1,2) = second() - t1
         total = time(1,1) + time(1,2)
C
C     COMPUTE A RESIDUAL TO VERIFY RESULTS.
C
         do 10 i = 1,n
            x(i) = b(i)
   10    continue
         call matgen(a,lda,n,b,norma)
         do 20 i = 1,n
            b(i) = -b(i)
   20    continue
         CALL SMXPY(n,b,n,lda,x,a)
         RESID = 0.0
         NORMX = 0.0
         DO 30 I = 1,N
            RESID = max( RESID, ABS(b(i)) )
            NORMX = max( NORMX, ABS(X(I)) )
   30    CONTINUE
         eps = epslon(1.0d0)
	RESIDn = RESID/( N*NORMA*NORMX*EPS )
         write(6,40)
   40    format('     norm. resid      resid           machep',
     $          '         x(1)-1        x(n)-1')
         write(6,50) residn,resid,eps,x(1)-1,x(n)-1
   50    format(1p5e16.8)
c
         write(6,60) n
   60    format(//'    times are reported for matrices of order ',i5)
         write(6,70)
   70    format(6x,'sgefa',6x,'sgesl',6x,'total',5x,'Kflops',7x,'unit',
     $         6x,'ratio')
c
         time(1,3) = total
         time(1,4) = ops/(1.0e3*total)
         time(1,5) = 2.0e3/time(1,4)
         time(1,6) = total/cray
         write(6,80) lda
   80    format(' times for array with leading dimension of',i4)
         write(6,110) (time(1,i),i=1,6)
c	goto 998
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call sgefa(a,lda,n,ipvt,info)
         time(2,1) = second() - t1
         t1 = second()
         call sgesl(a,lda,n,ipvt,b,0)
         time(2,2) = second() - t1
         total = time(2,1) + time(2,2)
         time(2,3) = total
         time(2,4) = ops/(1.0e3*total)
         time(2,5) = 2.0e3/time(2,4)
         time(2,6) = total/cray
         write(6,110) (time(2,i),i=1,6)
c
         call matgen(a,lda,n,b,norma)
         t1 = second()
         call sgefa(a,lda,n,ipvt,info)
         time(3,1) = second() - t1
         t1 = second()
         call sgesl(a,lda,n,ipvt,b,0)
         time(3,2) = second() - t1
         total = time(3,1) + time(3,2)
         time(3,3) = total
         time(3,4) = ops/(1.0e3*total)
         time(3,5) = 2.0e3/time(3,4)
         time(3,6) = total/cray
         write(6,110) (time(3,i),i=1,6)
c
         ntimes = 500
         t1 = second()
         do 89 i = 1,ntimes
            call matgen(a,lda,n,b,norma)
 89	continue
	tm2 = second() - t1
	t1 = second()
	do 90 i = 1,ntimes
            call matgen(a,lda,n,b,norma)
            call sgefa(a,lda,n,ipvt,info)
            call sgesl(a,lda,n,ipvt,b,0)
   90    continue
         time(4,1) = (second() - t1 - tm2)/ntimes
         time(4,2) = 0
         total = time(4,1) + time(4,2)
         time(4,3) = total
         time(4,4) = ops/(1.0e3*total)
         time(4,5) = 2.0e3/time(4,4)
         time(4,6) = total/cray
c
         write(6,110) (time(4,i),i=1,6)
  110    format(3(f11.5),f11.0,2(f11.5))
 998	continue
c
         write(6,140) ldaa
  140    format(/' times for array with leading dimension of',i4)
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call sgefa(aa,ldaa,n,ipvt,info)
         time(5,1) = second() - t1
         t1 = second()
         call sgesl(aa,ldaa,n,ipvt,b,0)
         time(5,2) = second() - t1
         total = time(5,1) + time(5,2)
         time(5,3) = total
         time(5,4) = ops/(1.0e3*total)
         time(5,5) = 2.0e3/time(5,4)
         time(5,6) = total/cray
         write(6,110) (time(5,i),i=1,6)
c	goto 999
c
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call sgefa(aa,ldaa,n,ipvt,info)
         time(6,1) = second() - t1
         t1 = second()
         call sgesl(aa,ldaa,n,ipvt,b,0)
         time(6,2) = second() - t1
         total = time(6,1) + time(6,2)
         time(6,3) = total
         time(6,4) = ops/(1.0e3*total)
         time(6,5) = 2.0e3/time(6,4)
         time(6,6) = total/cray
         write(6,110) (time(6,i),i=1,6)
c
         call matgen(aa,ldaa,n,b,norma)
         t1 = second()
         call sgefa(aa,ldaa,n,ipvt,info)
         time(7,1) = second() - t1
         t1 = second()
         call sgesl(aa,ldaa,n,ipvt,b,0)
         time(7,2) = second() - t1
         total = time(7,1) + time(7,2)
         time(7,3) = total
         time(7,4) = ops/(1.0e3*total)
         time(7,5) = 2.0e3/time(7,4)
         time(7,6) = total/cray
         write(6,110) (time(7,i),i=1,6)
c
         ntimes = 500
         t1 = second()
         do 119 i = 1, ntimes
            call matgen(aa,ldaa,n,b,norma)
 119	continue
            tm2 = second() - t1
         t1 = second()
		do 120 i = 1,ntimes
            call matgen(aa,ldaa,n,b,norma)
            call sgefa(aa,ldaa,n,ipvt,info)
            call sgesl(aa,ldaa,n,ipvt,b,0)
  120    continue
         time(8,1) = (second() - t1 - tm2)/ntimes
         time(8,2) = 0
         total = time(8,1) + time(8,2)
         time(8,3) = total
         time(8,4) = ops/(1.0e3*total)
         time(8,5) = 2.0e3/time(8,4)
         time(8,6) = total/cray
c
         write(6,110) (time(8,i),i=1,6)
 999	continue
	print *
	print *,'ROLLED',' DOUBLE ',' PRECISION LINPACK PERFORMANCE ',
     $		nint(min(time(4,4),time(8,4))), ' KFLOPS '

         if (resid .gt. 1.0d-13) then
            print *, "Test FAILED"
         else
            print *, "Test PASSED"
         endif
	 stop
      end
      subroutine matgen(a,lda,n,b,norma)
      doubleprecision a(lda,1),b(1),norma
c
      init = 1325
      norma = 0.0
      do 30 j = 1,n
         do 20 i = 1,n
            init = mod(3125*init,65536)
            a(i,j) = (init - 32768.0)/16384.0
	    norma = max(a(i,j), norma)
   20    continue
   30 continue
      do 35 i = 1,n
          b(i) = 0.0
   35 continue
      do 50 j = 1,n
         do 40 i = 1,n
            b(i) = b(i) + a(i,j)
   40    continue
   50 continue
      return
      end
      subroutine sgefa(a,lda,n,ipvt,info)
      integer lda,n,ipvt(1),info
      doubleprecision a(lda,1)
c
c     sgefa factors a real matrix by gaussian elimination.
c
c     sgefa is usually called by dgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for dgeco) = (1 + 9/n)*(time for sgefa) .
c
c     on entry
c
c        a       real(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgesl or dgedi will divide by zero
c                     if called.  use  rcond  in dgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c
c     internal variables
c
      doubleprecision t
      integer isamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = isamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0d0/a(k,k)
            call sscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call saxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0d0) info = n
      return
      end
      subroutine sgesl(a,lda,n,ipvt,b,job)
      integer lda,n,ipvt(1),job
      doubleprecision a(lda,1),b(1)
c
c     sgesl solves the real system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgeco or sgefa.
c
c     on entry
c
c        a       real(lda, n)
c                the output from dgeco or sgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from dgeco or sgefa.
c
c        b       real(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgeco has set rcond .gt. 0.0
c        or sgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call sgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sdot
c
c     internal variables
c
      doubleprecision sdot,t
      integer k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call saxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call saxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = sdot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + sdot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end
      
      subroutine saxpy(n,da,dx,incx,dy,incy)
      doubleprecision dx(1),dy(1),da
      integer i,incx,incy,ix,iy,m,mp1,n
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return

 20	continue
      do 30 i = 1,n
        dy(i) = dy(i) + da*dx(i)
   30 continue


      return
      end

	doubleprecision function sdot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      doubleprecision dx(1),dy(1),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      sdot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      sdot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c

 20	continue
      do 30 i = 1,n
        dtemp = dtemp + dx(i)*dy(i)
   30 continue


   60 sdot = dtemp
      return
      end
      subroutine  sscal(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      doubleprecision da,dx(1)
      integer i,incx,m,mp1,n,nincx
c
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dx(i) = da*dx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c

 20	continue
      do 30 i = 1,n
        dx(i) = da*dx(i)
   30 continue


      return
      end
      integer function isamax(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c
      doubleprecision dx(1),dmax
      integer i,incx,ix,n
c
      isamax = 0
      if( n .lt. 1 ) return
      isamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = abs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(abs(dx(ix)).le.dmax) go to 5
         isamax = i
         dmax = abs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = abs(dx(1))
      do 30 i = 2,n
         if(abs(dx(i)).le.dmax) go to 30
         isamax = i
         dmax = abs(dx(i))
   30 continue
      return
      end
      doubleprecision FUNCTION EPSLON (X)
      doubleprecision X
C
C     ESTIMATE UNIT ROUNDOFF IN QUANTITIES OF SIZE X.
C
      doubleprecision A,B,C,EPS
C
C     THIS PROGRAM SHOULD FUNCTION PROPERLY ON ALL SYSTEMS
C     SATISFYING THE FOLLOWING TWO ASSUMPTIONS,
C        1.  THE BASE USED IN REPRESENTING FLOATING POINT
C            NUMBERS IS NOT A POWER OF THREE.
C        2.  THE QUANTITY  A  IN STATEMENT 10 IS REPRESENTED TO 
C            THE ACCURACY USED IN FLOATING POINT VARIABLES
C            THAT ARE STORED IN MEMORY.
C     THE STATEMENT NUMBER 10 AND THE GO TO 10 ARE INTENDED TO
C     FORCE OPTIMIZING COMPILERS TO GENERATE CODE SATISFYING 
C     ASSUMPTION 2.
C     UNDER THESE ASSUMPTIONS, IT SHOULD BE TRUE THAT,
C            A  IS NOT EXACTLY EQUAL TO FOUR-THIRDS,
C            B  HAS A 0.0d0 FOR ITS LAST BIT OR DIGIT,
C            C  IS NOT EXACTLY EQUAL TO 1.0d0,
C            EPS  MEASURES THE SEPARATION OF 1.0 FROM
C                 THE NEXT LARGER FLOATING POINT NUMBER.
C     THE DEVELOPERS OF EISPACK WOULD APPRECIATE BEING INFORMED
C     ABOUT ANY SYSTEMS WHERE THESE ASSUMPTIONS DO NOT HOLD.
C
C     *****************************************************************
C     THIS ROUTINE IS 1.0d0 OF THE AUXILIARY ROUTINES USED BY EISPACK III
C     TO AVOID MACHINE DEPENDENCIES.
C     *****************************************************************
C
C     THIS VERSION DATED 4/6/83.
C
      A = dble(4)/dble(3)
   10 B = A - 1.0d0
      C = B + B + B
      EPS = ABS(C-1.0d0)
      IF (EPS .EQ. 0.0d0) GO TO 10
      EPSLON = EPS*ABS(X)
      RETURN
      END
      SUBROUTINE MM (A, LDA, N1, N3, B, LDB, N2, C, LDC)
      doubleprecision A(LDA,*), B(LDB,*), C(LDC,*)
C
C   PURPOSE:
C     MULTIPLY MATRIX B TIMES MATRIX C AND STORE THE RESULT IN MATRIX A.
C
C   PARAMETERS:
C
C     A doubleprecision(LDA,N3), MATRIX OF N1 ROWS AND N3 COLUMNS
C
C     LDA INTEGER, LEADING DIMENSION OF ARRAY A
C
C     N1 INTEGER, NUMBER OF ROWS IN MATRICES A AND B
C
C     N3 INTEGER, NUMBER OF COLUMNS IN MATRICES A AND C
C
C     B doubleprecision(LDB,N2), MATRIX OF N1 ROWS AND N2 COLUMNS
C
C     LDB INTEGER, LEADING DIMENSION OF ARRAY B
C
C     N2 INTEGER, NUMBER OF COLUMNS IN MATRIX B, AND NUMBER OF ROWS IN
C         MATRIX C
C
C     C doubleprecision(LDC,N3), MATRIX OF N2 ROWS AND N3 COLUMNS
C
C     LDC INTEGER, LEADING DIMENSION OF ARRAY C
C
C ----------------------------------------------------------------------
C
      DO 20 J = 1, N3
         DO 10 I = 1, N1
            A(I,J) = 0.0d0
   10    CONTINUE
         CALL SMXPY (N2,A(1,J),N1,LDB,C(1,J),B)
   20 CONTINUE
C
      RETURN
      END
      SUBROUTINE SMXPY (N1, Y, N2, LDM, X, M)
      doubleprecision Y(*), X(*), M(LDM,*)
C
C   PURPOSE:
C     MULTIPLY MATRIX M TIMES VECTOR X AND ADD THE RESULT TO VECTOR Y.
C
C   PARAMETERS:
C
C     N1 INTEGER, NUMBER OF ELEMENTS IN VECTOR Y, AND NUMBER OF ROWS IN
C         MATRIX M
C
C     Y doubleprecision(N1), VECTOR OF LENGTH N1 TO WHICH IS ADDED THE PRODUCT M*X
C
C     N2 INTEGER, NUMBER OF ELEMENTS IN VECTOR X, AND NUMBER OF COLUMNS
C         IN MATRIX M
C
C     LDM INTEGER, LEADING DIMENSION OF ARRAY M
C
C     X doubleprecision(N2), VECTOR OF LENGTH N2
C
C     M doubleprecision(LDM,N2), MATRIX OF N1 ROWS AND N2 COLUMNS
C
C ----------------------------------------------------------------------
C
C   CLEANUP ODD VECTOR
C
      J = MOD(N2,2)
      IF (J .GE. 1) THEN
         DO 10 I = 1, N1
            Y(I) = (Y(I)) + X(J)*M(I,J)
   10    CONTINUE
      ENDIF
C
C   CLEANUP ODD GROUP OF TWO VECTORS
C
      J = MOD(N2,4)
      IF (J .GE. 2) THEN
         DO 20 I = 1, N1
            Y(I) = ( (Y(I))
     $             + X(J-1)*M(I,J-1)) + X(J)*M(I,J)
   20    CONTINUE
      ENDIF
C
C   CLEANUP ODD GROUP OF FOUR VECTORS
C
      J = MOD(N2,8)
      IF (J .GE. 4) THEN
         DO 30 I = 1, N1
            Y(I) = ((( (Y(I))
     $             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))
     $             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)
   30    CONTINUE
      ENDIF
C
C   CLEANUP ODD GROUP OF EIGHT VECTORS
C
      J = MOD(N2,16)
      IF (J .GE. 8) THEN
         DO 40 I = 1, N1
            Y(I) = ((((((( (Y(I))
     $             + X(J-7)*M(I,J-7)) + X(J-6)*M(I,J-6))
     $             + X(J-5)*M(I,J-5)) + X(J-4)*M(I,J-4))
     $             + X(J-3)*M(I,J-3)) + X(J-2)*M(I,J-2))
     $             + X(J-1)*M(I,J-1)) + X(J)  *M(I,J)
   40    CONTINUE
      ENDIF
C
C   MAIN LOOP - GROUPS OF SIXTEEN VECTORS
C
      JMIN = J+16
      DO 60 J = JMIN, N2, 16
         DO 50 I = 1, N1
            Y(I) = ((((((((((((((( (Y(I))
     $             + X(J-15)*M(I,J-15)) + X(J-14)*M(I,J-14))
     $             + X(J-13)*M(I,J-13)) + X(J-12)*M(I,J-12))
     $             + X(J-11)*M(I,J-11)) + X(J-10)*M(I,J-10))
     $             + X(J- 9)*M(I,J- 9)) + X(J- 8)*M(I,J- 8))
     $             + X(J- 7)*M(I,J- 7)) + X(J- 6)*M(I,J- 6))
     $             + X(J- 5)*M(I,J- 5)) + X(J- 4)*M(I,J- 4))
     $             + X(J- 3)*M(I,J- 3)) + X(J- 2)*M(I,J- 2))
     $             + X(J- 1)*M(I,J- 1)) + X(J)   *M(I,J)
   50    CONTINUE
   60 CONTINUE
      RETURN
      END

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
! 

      program verify

      integer i, nerrors
      real*8 r1, r2, r1_expd, r2_expd

      open (unit=8,file='energy32_32_32_150.dat.expd')
      open (unit=9,file='energy32_32_32_150.dat')

      nerrors = 0
      do i = 1, 150
        read(8,*) r1_expd, r2_expd
        read(9,*) r1, r2
        if (abs(r1_expd) .lt. 1.0d-6) then

          if ( abs(r1_expd - r1) .gt. 1.0d-10  ) then
            nerrors = nerrors + 1
          endif    

        else

        if ((abs(r1_expd-r1)/min(abs(r1_expd),abs(r1))).ge.1.0d-6) then
            nerrors = nerrors + 1
          endif    

        endif

        if (abs(r2_expd) .lt. 1.0d-6) then

          if ( abs(r2_expd - r2) .gt. 1.0d-10  ) then
            nerrors = nerrors + 1
          endif    

        else

        if ((abs(r2_expd-r2)/min(abs(r2_expd),abs(r2))).ge.1.0d-6) then
            nerrors = nerrors + 1
          endif    

        endif

      enddo

      if (nerrors .ne. 0) then
        print *, "Test FAILED", nerrors
      else
        print *, "Test PASSED"
      endif

      close (unit=8)
      close (unit=9)

      end

!
!     Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
!
! NVIDIA CORPORATION and its licensors retain all intellectual property
! and proprietary rights in and to this software, related documentation
! and any modifications thereto.  Any use, reproduction, disclosure or
! distribution of this software and related documentation without an express
! license agreement from NVIDIA CORPORATION is strictly prohibited.
!

!
! SEISMIC_CPML Version 1.1.1, November 2009.
!
! Copyright Universite de Pau et des Pays de l'Adour, CNRS and INRIA, France.
! Contributors: Dimitri Komatitsch, dimitri DOT komatitsch aT univ-pau DOT fr
!               and Roland Martin, roland DOT martin aT univ-pau DOT fr
!
! This software is a computer program whose purpose is to solve
! the three-dimensional isotropic elastic wave equation
! using a finite-difference method with classical split Perfectly Matched
! Layer (PML) conditions.
!
! This software is governed by the CeCILL license under French law and
! abiding by the rules of distribution of free software. You can use,
! modify and/or redistribute the software under the terms of the CeCILL
! license as circulated by CEA, CNRS and INRIA at the following URL
! "http://www.cecill.info".
!
! As a counterpart to the access to the source code and rights to copy,
! modify and redistribute granted by the license, users are provided only
! with a limited warranty and the software's author, the holder of the
! economic rights, and the successive licensors have only limited
! liability.
!
! In this respect, the user's attention is drawn to the risks associated
! with loading, using, modifying and/or developing or reproducing the
! software by the user in light of its specific status of free software,
! that may mean that it is complicated to manipulate, and that also
! therefore means that it is reserved for developers and experienced
! professionals having in-depth computer knowledge. Users are therefore
! encouraged to load and test the software's suitability as regards their
! requirements in conditions enabling the security of their systems and/or
! data to be ensured and, more generally, to use and operate it in the
! same conditions as regards security.
!
! The full text of the license is available at the end of this program
! and in file "LICENSE".

program seismic_PML_Collino_3D_iso

  ! IMPORTANT : all our CPML codes work fine in single precision as well (which is significantly faster).
  !             If you want you can thus force automatic conversion to single precision at compile time 
  !             or change all the declarations and constants in the code from double precision to single.

  implicit none

  !
  ! 3D explicit PML velocity-stress FD code based upon INRIA report for the 2D case:
  !
  ! Francis Collino and Chrysoula Tsogka
  ! Application of the PML Absorbing Layer Model to the Linear
  ! Elastodynamic Problem in Anisotropic Heteregeneous Media
  ! INRIA Research Report RR-3471, August 1998
  ! http://hal.inria.fr/docs/00/07/32/19/PDF/RR-3471.pdf
  !
  ! and
  !
  ! @ARTICLE{CoTs01,
  ! author = {F. Collino and C. Tsogka},
  ! title = {Application of the {PML} absorbing layer model to the linear elastodynamic
  !     problem in anisotropic heterogeneous media},
  ! journal = {Geophysics},
  ! year = {2001},
  ! volume = {66},
  ! number = {1},
  ! pages = {294-307}}
  !
  ! PML implemented in the three directions (x, y and z).
  !
  ! Dimitri Komatitsch and Roland Martin, University of Pau, France, April 2007.
  !
  ! The second-order staggered-grid formulation of Madariaga (1976) and Virieux (1986) is used.
  !
  ! Parallel implementation based on OpenMP.
  ! Type for instance "setenv OMP_NUM_THREADS 4" before running in OpenMP if you want 4 tasks.
  !
  ! To display the results as color images in the selected 2D cut plane, use:
  !
  !   " display image*.gif " or " gimp image*.gif "
  !
  ! or
  !
  !   " montage -geometry +0+3 -rotate 90 -tile 1x21 image*Vx*.gif allfiles_Vx.gif "
  !   " montage -geometry +0+3 -rotate 90 -tile 1x21 image*Vy*.gif allfiles_Vy.gif "
  !   then " display allfiles_Vx.gif " or " gimp allfiles_Vx.gif "
  !   then " display allfiles_Vy.gif " or " gimp allfiles_Vy.gif "
  !

  ! total number of grid points in each direction of the grid
  integer :: NX 
  integer :: NY 
  integer :: NZ

  ! size of a grid cell
  double precision, parameter :: h = 10.d0

  ! thickness of the PML layer in grid points
  integer, parameter :: NPOINTS_PML = 10

  ! P-velocity, S-velocity and density
  double precision, parameter :: cp = 3300.d0
  double precision, parameter :: cs = cp / 1.732d0
  double precision, parameter :: rho = 2800.d0
  double precision, parameter :: mu = rho*cs*cs
  double precision, parameter :: lambda = rho*(cp*cp - 2.d0*cs*cs)
  double precision, parameter :: lambda_plus_two_mu = rho*cp*cp

  ! total number of time steps
  integer :: NSTEP 

  ! time step in seconds
  double precision, parameter :: DELTAT = 1.6d-3
  double precision, parameter :: ONE_OVER_DELTAT = 1.d0 / DELTAT

  ! parameters for the source
  double precision, parameter :: f0 = 7.d0
  double precision, parameter :: t0 = 1.20d0 / f0
  double precision, parameter :: factor = 1.d7

  ! source
  integer :: ISOURCE 
  integer :: JSOURCE 
  integer :: KSOURCE 
  double precision :: xsource 
  double precision :: ysource
  double precision :: zsource

  ! angle of source force clockwise with respect to vertical (Y) axis
  double precision, parameter :: ANGLE_FORCE = 135.d0

  ! receivers
  integer :: NREC 
  double precision :: xdeb    
  double precision :: ydeb            
  double precision :: zdeb            
  double precision :: xfin            
  double precision :: yfin            
  double precision :: zfin 

  ! display information on the screen from time to time
  integer :: IT_DISPLAY 

  ! value of PI
  double precision, parameter :: PI = 3.141592653589793238462643d0

  ! conversion from degrees to radians
  double precision, parameter :: DEGREES_TO_RADIANS = PI / 180.d0

  ! zero
  double precision, parameter :: ZERO = 0.d0

  ! large value for maximum
  double precision, parameter :: HUGEVAL = 1.d+30

  ! velocity threshold above which we consider that the code became unstable
  double precision, parameter :: STABILITY_THRESHOLD = 1.d+25

  ! main arrays
  double precision, allocatable, dimension(:,:,:) :: vx_1,vx_2,vx_3,&
       vy_1,vy_2,vy_3,&
       vz_1,vz_2,vz_3,&
       sigmaxx_1,sigmaxx_2,sigmaxx_3,&
       sigmayy_1,sigmayy_2,sigmayy_3,&
       sigmazz_1,sigmazz_2,sigmazz_3,&
       sigmaxy_1,sigmaxy_2,&
       sigmaxz_1,sigmaxz_3,&
       sigmayz_2,sigmayz_3

  double precision, allocatable, dimension(:) :: dx_over_two,dx_half_over_two
  double precision, allocatable, dimension(:) :: dy_over_two,dy_half_over_two
  double precision, allocatable, dimension(:) :: dz_over_two,dz_half_over_two

  ! for the source
  double precision a,t,force_x,force_y,force_z,source_term

  ! for receivers
  double precision xspacerec,yspacerec,zspacerec,distval,dist
  integer, allocatable, dimension(:) :: ix_rec,iy_rec,iz_rec
  double precision, allocatable, dimension(:) :: xrec,yrec,zrec
  double precision, allocatable, dimension(:,:) :: sisvx,sisvy

  ! for evolution of total energy in the medium
  double precision :: epsilon_xx,epsilon_yy,epsilon_zz,epsilon_xy,epsilon_xz,epsilon_yz
  double precision :: sigmaxx_total,sigmayy_total,sigmazz_total
  double precision :: sigmaxy_total,sigmaxz_total,sigmayz_total
  double precision :: total_energy_kinetic,total_energy_potential
  double precision, allocatable, dimension(:) :: total_energy

  integer :: i,j,k,it,irec,iplane

  double precision :: xval,delta,xoriginleft,xoriginright,rcoef,d0,Vsolidnorm,Courant_number,value_dx,value_dy,value_dz,d

  ! timer to count elapsed time
  character(len=8) datein
  character(len=10) timein
  character(len=5)  :: zone
  integer, dimension(8) :: time_values
  integer ihours,iminutes,iseconds,int_tCPU
  double precision :: time_start,time_end,tCPU

  ! names of the time stamp files
  character(len=150) outputname
  character(len=150) energyfile

  ! main I/O file
  integer, parameter :: IOUT = 41

  character(32) :: arg
  integer :: argc

  !---
  !--- program starts here
  !---

  ! Default values
  NX = 101
  NY = 641
  NZ = 128
  NREC = 2
  NSTEP = 2500	
  IT_DISPLAY = 100

  argc = command_argument_count()
  
  if (argc .lt. 6) then
     print *, "ERROR: Note enough arguments."
     STOP
  endif

  energyfile = 'energy' 

  CALL get_command_argument(1, arg)
  arg = TRIM(arg)
  energyfile = TRIM(energyfile)//arg;
  read(arg,'(I4)') NX
  CALL get_command_argument(2, arg)
  arg = TRIM(arg)
  energyfile = TRIM(energyfile)//'_'//arg;
  read(arg,'(I4)') NY
  CALL get_command_argument(3, arg)
  arg = TRIM(arg)
  energyfile = TRIM(energyfile)//'_'//arg;
  read(arg,'(I4)') NZ
  CALL get_command_argument(4, arg)
  arg = TRIM(arg)
  read(arg,'(I4)') NREC
  CALL get_command_argument(5, arg)
  arg = TRIM(arg)
  energyfile = TRIM(energyfile)//'_'//arg
  read(arg,'(I4)') NSTEP
  CALL get_command_argument(6, arg)
  arg = TRIM(arg)
  read(arg,'(I4)') IT_DISPLAY

  energyfile = TRIM(energyfile)//'.dat'
  ISOURCE = NX - 2*NPOINTS_PML - 1
  JSOURCE = 2 * NY / 3 + 1
  KSOURCE = NZ / 2
  xsource = (ISOURCE - 1) * h
  ysource = (JSOURCE - 1) * h
  zsource = (KSOURCE - 1) * h
  xdeb = xsource - 100.d0   ! first receiver x in meters
  ydeb = 2300.d0            ! first receiver y in meters
  zdeb = zsource            ! first receiver y in meters
  xfin = xsource            ! last receiver x in meters
  yfin =  300.d0            ! last receiver y in meters
  zfin =  zsource           ! last receiver y in meters

  allocate (vx_1(NX,NY,NZ),vx_2(NX,NY,NZ),vx_3(NX,NY,NZ),&
       vy_1(NX,NY,NZ),vy_2(NX,NY,NZ),vy_3(NX,NY,NZ),&
       vz_1(NX,NY,NZ),vz_2(NX,NY,NZ),vz_3(NX,NY,NZ),&
       sigmaxx_1(NX,NY,NZ),sigmaxx_2(NX,NY,NZ),sigmaxx_3(NX,NY,NZ),&
       sigmayy_1(NX,NY,NZ),sigmayy_2(NX,NY,NZ),sigmayy_3(NX,NY,NZ),&
       sigmazz_1(NX,NY,NZ),sigmazz_2(NX,NY,NZ),sigmazz_3(NX,NY,NZ),&
       sigmaxy_1(NX,NY,NZ),sigmaxy_2(NX,NY,NZ),&
       sigmaxz_1(NX,NY,NZ),sigmaxz_3(NX,NY,NZ),&
       sigmayz_2(NX,NY,NZ),sigmayz_3(NX,NY,NZ))
  allocate(dx_over_two(NX),dx_half_over_two(NX))
  allocate(dy_over_two(NY),dy_half_over_two(NY))
  allocate(dz_over_two(NZ),dz_half_over_two(NZ))
  allocate(ix_rec(NREC),iy_rec(NREC),iz_rec(NREC))	
  allocate(xrec(NREC),yrec(NREC),zrec(NREC))
  allocate(sisvx(NSTEP,NREC),sisvy(NSTEP,NREC))
  allocate(total_energy(NSTEP))


  !--- define profile of absorption in PML region

  ! thickness of the layer in meters
  delta = NPOINTS_PML * h

  ! reflection coefficient (INRIA report section 6.1) http://hal.inria.fr/docs/00/07/32/19/PDF/RR-3471.pdf
  Rcoef = 0.001d0

  ! compute d0 from INRIA report section 6.1 http://hal.inria.fr/docs/00/07/32/19/PDF/RR-3471.pdf
  d0 = 3.d0 * cp * log(1.d0/Rcoef) / (2.d0 * delta)

  print *,'d0 = ',d0
  print *

  ! origin of the PML layer (position of right edge minus thickness, in meters)
  xoriginleft = delta
  xoriginright = (NX-1)*h - delta

  do i=1,NX

     xval = h*dble(i-1)

     if(xval < xoriginleft) then
        dx_over_two(i) = d0 * ((xoriginleft-xval)/delta)**2
        dx_half_over_two(i) = d0 * ((xoriginleft-xval-h/2.d0)/delta)**2
        ! fix problem with dx_half_over_two() exactly on the edge
     else if(xval >= 0.9999d0*xoriginright) then
        dx_over_two(i) = d0 * ((xval-xoriginright)/delta)**2
        dx_half_over_two(i) = d0 * ((xval+h/2.d0-xoriginright)/delta)**2
     else
        dx_over_two(i) = 0.d0
        dx_half_over_two(i) = 0.d0
     endif

  enddo

  ! divide the whole profile by two once and for all
  dx_over_two(:) = dx_over_two(:) / 2.d0
  dx_half_over_two(:) = dx_half_over_two(:) / 2.d0

  ! origin of the PML layer (position of right edge minus thickness, in meters)
  xoriginleft = delta
  xoriginright = (NY-1)*h - delta

  do j=1,NY

     xval = h*dble(j-1)

     if(xval < xoriginleft) then
        dy_over_two(j) = d0 * ((xoriginleft-xval)/delta)**2
        dy_half_over_two(j) = d0 * ((xoriginleft-xval-h/2.d0)/delta)**2
        ! fix problem with dy_half_over_two() exactly on the edge
     else if(xval >= 0.9999d0*xoriginright) then
        dy_over_two(j) = d0 * ((xval-xoriginright)/delta)**2
        dy_half_over_two(j) = d0 * ((xval+h/2.d0-xoriginright)/delta)**2
     else
        dy_over_two(j) = 0.d0
        dy_half_over_two(j) = 0.d0
     endif

  enddo

  ! divide the whole profile by two once and for all
  dy_over_two(:) = dy_over_two(:) / 2.d0
  dy_half_over_two(:) = dy_half_over_two(:) / 2.d0

  ! origin of the PML layer (position of right edge minus thickness, in meters)
  xoriginleft = delta
  xoriginright = (NZ-1)*h - delta

  do k=1,NZ

     xval = h*dble(k-1)

     if(xval < xoriginleft) then
        dz_over_two(k) = d0 * ((xoriginleft-xval)/delta)**2
        dz_half_over_two(k) = d0 * ((xoriginleft-xval-h/2.d0)/delta)**2
        ! fix problem with dy_half_over_two() exactly on the edge
     else if(xval >= 0.9999d0*xoriginright) then
        dz_over_two(k) = d0 * ((xval-xoriginright)/delta)**2
        dz_half_over_two(k) = d0 * ((xval+h/2.d0-xoriginright)/delta)**2
     else
        dz_over_two(k) = 0.d0
        dz_half_over_two(k) = 0.d0
     endif

  enddo

  ! divide the whole profile by two once and for all
  dz_over_two(:) = dz_over_two(:) / 2.d0
  dz_half_over_two(:) = dz_half_over_two(:) / 2.d0

  ! print position of the source
  print *
  print *,'Position of the source:'
  print *
  print *,'x = ',xsource
  print *,'y = ',ysource
  print *,'z = ',zsource
  print *

  ! define location of receivers
  print *
  print *,'There are ',nrec,' receivers'
  print *
  xspacerec = (xfin-xdeb) / dble(NREC-1)
  yspacerec = (yfin-ydeb) / dble(NREC-1)
  zspacerec = (zfin-zdeb) / dble(NREC-1)
  do irec=1,nrec
     xrec(irec) = xdeb + dble(irec-1)*xspacerec
     yrec(irec) = ydeb + dble(irec-1)*yspacerec
     zrec(irec) = zdeb + dble(irec-1)*zspacerec
  enddo

  ! find closest grid point for each receiver
  do irec=1,nrec
     dist = HUGEVAL
     do k = 1,NZ
        do j = 1,NY
           do i = 1,NX
              distval = sqrt((h*dble(i-1) - xrec(irec))**2 + (h*dble(j-1) - yrec(irec))**2 + (h*dble(k-1) - zrec(irec))**2)
              if(distval < dist) then
                 dist = distval
                 ix_rec(irec) = i
                 iy_rec(irec) = j
                 iz_rec(irec) = k
              endif
           enddo
        enddo
     enddo
     print *,'receiver ',irec,' x_target,y_target,z_target = ',xrec(irec),yrec(irec),zrec(irec)
     print *,'closest grid point found at distance ',dist,' in i,j,k = ',ix_rec(irec),iy_rec(irec),iz_rec(irec)
     print *
  enddo

  ! check the Courant stability condition for the explicit time scheme
  ! R. Courant et K. O. Friedrichs et H. Lewy (1928)
  Courant_number = cp * DELTAT / h
  print *,'Courant number is ',Courant_number
  print *
  if(Courant_number > 1.d0/sqrt(3.d0)) stop 'time step is too large, simulation will be unstable'

  ! suppress old files (can be commented out if "call system" is missing in your compiler)
  ! call system('rm -f Vx_*.dat Vy_*.dat Vz_*.dat image*.pnm image*.gif timestamp*')

  ! initialize arrays
  !---
!!$acc data &
!!$acc  copyout(sisvx, sisvy), &
!!$acc  create( vx_1,vx_2,vx_3,&
!!$acc          vy_1,vy_2,vy_3,&
!!$acc          vz_1,vz_2,vz_3,&
!!$acc          sigmaxx_1,sigmaxx_2,sigmaxx_3,&
!!$acc          sigmayy_1,sigmayy_2,sigmayy_3,&
!!$acc          sigmazz_1,sigmazz_2,sigmazz_3,&
!!$acc          sigmaxy_1,sigmaxy_2,&
!!$acc          sigmaxz_1,sigmaxz_3,&
!!$acc          sigmayz_2,sigmayz_3), &
!!$acc  copyin(dz_half_over_two,dx_over_two,dy_half_over_two, &
!!$acc         dx_half_over_two,dy_over_two,dz_over_two)

!$omp target data map(from:  sisvx, sisvy) &
!$omp             map(alloc: vx_1,vx_2,vx_3, &
!$omp                 vy_1,vy_2,vy_3, &
!$omp                 vz_1,vz_2,vz_3, &
!$omp                 sigmaxx_1,sigmaxx_2,sigmaxx_3, &
!$omp                 sigmayy_1,sigmayy_2,sigmayy_3, &
!$omp                 sigmazz_1,sigmazz_2,sigmazz_3, &
!$omp                 sigmaxy_1,sigmaxy_2, &
!$omp                 sigmaxz_1,sigmaxz_3, &
!$omp                 sigmayz_2,sigmayz_3) &
!$omp             map(to: dz_half_over_two,dx_over_two,dy_half_over_two, &
!$omp                 dx_half_over_two,dy_over_two,dz_over_two)

!!$acc kernels
!$omp target teams loop collapse(3)
  do k=1, NZ
     do j=1, NY
        do i=1, NX
           vx_1(i,j,k) = 0.d0
           vy_1(i,j,k) = 0.d0
           vz_1(i,j,k) = 0.d0
           vx_2(i,j,k) = 0.d0
           vy_2(i,j,k) = 0.d0
           vz_2(i,j,k) = 0.d0
           vx_3(i,j,k) = 0.d0
           vy_3(i,j,k) = 0.d0
           vz_3(i,j,k) = 0.d0
           sigmaxx_1(i,j,k) = 0.d0
           sigmayy_1(i,j,k) = 0.d0
           sigmazz_1(i,j,k) = 0.d0
           sigmaxy_1(i,j,k) = 0.d0
           sigmaxz_1(i,j,k) = 0.d0
           sigmaxx_2(i,j,k) = 0.d0
           sigmayy_2(i,j,k) = 0.d0
           sigmazz_2(i,j,k) = 0.d0
           sigmaxy_2(i,j,k) = 0.d0
           sigmayz_2(i,j,k) = 0.d0
           sigmaxx_3(i,j,k) = 0.d0
           sigmayy_3(i,j,k) = 0.d0
           sigmazz_3(i,j,k) = 0.d0
           sigmaxz_3(i,j,k) = 0.d0
           sigmayz_3(i,j,k) = 0.d0
        enddo
     enddo
  enddo

!$omp target teams loop collapse(2)
  do i=1,NSTEP
     do j=1, NREC
        ! initialize seismograms
        sisvx(i,j) = 0.d0
        sisvy(i,j) = 0.d0
     enddo
  enddo
!!$acc end kernels

  ! initialize total energy
  total_energy(:) = 0.d0

  call date_and_time(datein,timein,zone,time_values)
  ! time_values(3): day of the month
  ! time_values(5): hour of the day
  ! time_values(6): minutes of the hour
  ! time_values(7): seconds of the minute
  ! time_values(8): milliseconds of the second
  ! this fails if we cross the end of the month
  time_start = 86400.d0*time_values(3) + 3600.d0*time_values(5) + &
       60.d0*time_values(6) + time_values(7) + time_values(8) / 1000.d0

  !---
  !---  beginning of time loop

  
  do it = 1,NSTEP

!     print *,'it = ',it

     !----------------------
     ! compute stress sigma
     !----------------------

     !!$acc kernels
!$omp target teams loop collapse(3)
     do k=2,NZ
        do j = 2,NY
           do i = 1,NX-1

              value_dx = (vx_1(i+1,j,k) - vx_1(i,j,k)) / h &
                   + (vx_2(i+1,j,k) - vx_2(i,j,k)) / h &
                   + (vx_3(i+1,j,k) - vx_3(i,j,k)) / h

              value_dy = (vy_1(i,j,k) - vy_1(i,j-1,k)) / h &
                   + (vy_2(i,j,k) - vy_2(i,j-1,k)) / h &
                   + (vy_3(i,j,k) - vy_3(i,j-1,k)) / h

              value_dz = (vz_1(i,j,k) - vz_1(i,j,k-1)) / h &
                   + (vz_2(i,j,k) - vz_2(i,j,k-1)) / h &
                   + (vz_3(i,j,k) - vz_3(i,j,k-1)) / h

              d = dx_half_over_two(i)

              sigmaxx_1(i,j,k) = ( sigmaxx_1(i,j,k)*(ONE_OVER_DELTAT - d) + lambda_plus_two_mu * value_dx ) / (ONE_OVER_DELTAT + d)

              sigmayy_1(i,j,k) = ( sigmayy_1(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dx ) / (ONE_OVER_DELTAT + d)

              sigmazz_1(i,j,k) = ( sigmazz_1(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dx ) / (ONE_OVER_DELTAT + d)

              d = dy_over_two(j)

              sigmaxx_2(i,j,k) = ( sigmaxx_2(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dy ) / (ONE_OVER_DELTAT + d)

              sigmayy_2(i,j,k) = ( sigmayy_2(i,j,k)*(ONE_OVER_DELTAT - d) + lambda_plus_two_mu * value_dy ) / (ONE_OVER_DELTAT + d)

              sigmazz_2(i,j,k) = ( sigmazz_2(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dy ) / (ONE_OVER_DELTAT + d)

              d = dz_over_two(k)

              sigmaxx_3(i,j,k) = ( sigmaxx_3(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dz ) / (ONE_OVER_DELTAT + d)

              sigmayy_3(i,j,k) = ( sigmayy_3(i,j,k)*(ONE_OVER_DELTAT - d) + lambda * value_dz ) / (ONE_OVER_DELTAT + d)

              sigmazz_3(i,j,k) = ( sigmazz_3(i,j,k)*(ONE_OVER_DELTAT - d) + lambda_plus_two_mu * value_dz ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

!$omp target teams loop collapse(3)
     do k=1,NZ
        do j = 1,NY-1
           do i = 2,NX

              value_dx = (vy_1(i,j,k) - vy_1(i-1,j,k)) / h &
                   + (vy_2(i,j,k) - vy_2(i-1,j,k)) / h &
                   + (vy_3(i,j,k) - vy_3(i-1,j,k)) / h

              value_dy = (vx_1(i,j+1,k) - vx_1(i,j,k)) / h &
                   + (vx_2(i,j+1,k) - vx_2(i,j,k)) / h &
                   + (vx_3(i,j+1,k) - vx_3(i,j,k)) / h

              d = dx_over_two(i)

              sigmaxy_1(i,j,k) = ( sigmaxy_1(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dx ) / (ONE_OVER_DELTAT + d)

              d = dy_half_over_two(j)

              sigmaxy_2(i,j,k) = ( sigmaxy_2(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dy ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

!$omp target teams loop collapse(3)
     do k=1,NZ-1
        do j = 1,NY
           do i = 2,NX

              value_dx = (vz_1(i,j,k) - vz_1(i-1,j,k)) / h &
                   + (vz_2(i,j,k) - vz_2(i-1,j,k)) / h &
                   + (vz_3(i,j,k) - vz_3(i-1,j,k)) / h

              value_dz = (vx_1(i,j,k+1) - vx_1(i,j,k)) / h &
                   + (vx_2(i,j,k+1) - vx_2(i,j,k)) / h &
                   + (vx_3(i,j,k+1) - vx_3(i,j,k)) / h

              d = dx_over_two(i)

              sigmaxz_1(i,j,k) = ( sigmaxz_1(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dx ) / (ONE_OVER_DELTAT + d)

              d = dz_half_over_two(k)

              sigmaxz_3(i,j,k) = ( sigmaxz_3(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dz ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

!$omp target teams loop collapse(3)
     do k=1,NZ-1
        do j = 1,NY-1
           do i = 1,NX

              value_dy = (vz_1(i,j+1,k) - vz_1(i,j,k)) / h &
                   + (vz_2(i,j+1,k) - vz_2(i,j,k)) / h &
                   + (vz_3(i,j+1,k) - vz_3(i,j,k)) / h

              value_dz = (vy_1(i,j,k+1) - vy_1(i,j,k)) / h &
                   + (vy_2(i,j,k+1) - vy_2(i,j,k)) / h &
                   + (vy_3(i,j,k+1) - vy_3(i,j,k)) / h

              d = dy_half_over_two(j)

              sigmayz_2(i,j,k) = ( sigmayz_2(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dy ) / (ONE_OVER_DELTAT + d)

              d = dz_half_over_two(k)

              sigmayz_3(i,j,k) = ( sigmayz_3(i,j,k)*(ONE_OVER_DELTAT - d) + mu * value_dz ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

     !------------------
     ! compute velocity
     !------------------

!$omp target teams loop collapse(3)
     do k = 2,NZ
        do j = 2,NY
           do i = 2,NX

              value_dx = (sigmaxx_1(i,j,k) - sigmaxx_1(i-1,j,k)) / h &
                   + (sigmaxx_2(i,j,k) - sigmaxx_2(i-1,j,k)) / h &
                   + (sigmaxx_3(i,j,k) - sigmaxx_3(i-1,j,k)) / h

              value_dy = (sigmaxy_1(i,j,k) - sigmaxy_1(i,j-1,k)) / h &
                   + (sigmaxy_2(i,j,k) - sigmaxy_2(i,j-1,k)) / h

              value_dz = (sigmaxz_1(i,j,k) - sigmaxz_1(i,j,k-1)) / h &
                   + (sigmaxz_3(i,j,k) - sigmaxz_3(i,j,k-1)) / h

              d = dx_over_two(i)

              vx_1(i,j,k) = ( vx_1(i,j,k)*(ONE_OVER_DELTAT - d) + value_dx / rho ) / (ONE_OVER_DELTAT + d)

              d = dy_over_two(j)

              vx_2(i,j,k) = ( vx_2(i,j,k)*(ONE_OVER_DELTAT - d) + value_dy / rho ) / (ONE_OVER_DELTAT + d)

              d = dz_over_two(k)

              vx_3(i,j,k) = ( vx_3(i,j,k)*(ONE_OVER_DELTAT - d) + value_dz / rho ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

!$omp target teams loop collapse(3)
     do k = 2,NZ
        do j = 1,NY-1
           do i = 1,NX-1

              value_dx = (sigmaxy_1(i+1,j,k) - sigmaxy_1(i,j,k)) / h &
                   + (sigmaxy_2(i+1,j,k) - sigmaxy_2(i,j,k)) / h

              value_dy = (sigmayy_1(i,j+1,k) - sigmayy_1(i,j,k)) / h &
                   + (sigmayy_2(i,j+1,k) - sigmayy_2(i,j,k)) / h &
                   + (sigmayy_3(i,j+1,k) - sigmayy_3(i,j,k)) / h

              value_dz = (sigmayz_2(i,j,k) - sigmayz_2(i,j,k-1)) / h &
                   + (sigmayz_3(i,j,k) - sigmayz_3(i,j,k-1)) / h

              d = dx_half_over_two(i)

              vy_1(i,j,k) = ( vy_1(i,j,k)*(ONE_OVER_DELTAT - d) + value_dx / rho ) / (ONE_OVER_DELTAT + d)

              d = dy_half_over_two(j)

              vy_2(i,j,k) = ( vy_2(i,j,k)*(ONE_OVER_DELTAT - d) + value_dy / rho ) / (ONE_OVER_DELTAT + d)

              d = dz_over_two(k)

              vy_3(i,j,k) = ( vy_3(i,j,k)*(ONE_OVER_DELTAT - d) + value_dz / rho ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

!$omp target teams loop collapse(3)
     do k = 1,NZ-1
        do j = 2,NY
           do i = 1,NX-1

              value_dx = (sigmaxz_1(i+1,j,k) - sigmaxz_1(i,j,k)) / h &
                   + (sigmaxz_3(i+1,j,k) - sigmaxz_3(i,j,k)) / h

              value_dy = (sigmayz_2(i,j,k) - sigmayz_2(i,j-1,k)) / h &
                   + (sigmayz_3(i,j,k) - sigmayz_3(i,j-1,k)) / h

              value_dz = (sigmazz_1(i,j,k+1) - sigmazz_1(i,j,k)) / h &
                   + (sigmazz_2(i,j,k+1) - sigmazz_2(i,j,k)) / h &
                   + (sigmazz_3(i,j,k+1) - sigmazz_3(i,j,k)) / h

              d = dx_half_over_two(i)

              vz_1(i,j,k) = ( vz_1(i,j,k)*(ONE_OVER_DELTAT - d) + value_dx / rho ) / (ONE_OVER_DELTAT + d)

              d = dy_over_two(j)

              vz_2(i,j,k) = ( vz_2(i,j,k)*(ONE_OVER_DELTAT - d) + value_dy / rho ) / (ONE_OVER_DELTAT + d)

              d = dz_half_over_two(k)

              vz_3(i,j,k) = ( vz_3(i,j,k)*(ONE_OVER_DELTAT - d) + value_dz / rho ) / (ONE_OVER_DELTAT + d)

           enddo
        enddo
     enddo

     !!$acc end kernels


     ! add the source (force vector located at a given grid point)
     a = pi*pi*f0*f0
     t = dble(it-1)*DELTAT

     ! Gaussian
     ! source_term = factor * exp(-a*(t-t0)**2)

     ! first derivative of a Gaussian
     source_term = - factor * 2.d0*a*(t-t0)*exp(-a*(t-t0)**2)

     ! Ricker source time function (second derivative of a Gaussian)
     ! source_term = factor * (1.d0 - 2.d0*a*(t-t0)**2)*exp(-a*(t-t0)**2)

     force_x = sin(ANGLE_FORCE * DEGREES_TO_RADIANS) * source_term
     force_y = cos(ANGLE_FORCE * DEGREES_TO_RADIANS) * source_term
     force_z = 0.d0

     ! define location of the source
     i = ISOURCE
     j = JSOURCE
     k = NZ / 2

     ! add the source to one of the two components of the split field

!!$acc parallel
!$omp target teams loop
     do irec=1,1
     vx_1(i,j,k) = vx_1(i,j,k) + force_x * DELTAT / rho
     vy_1(i,j,k) = vy_1(i,j,k) + force_y * DELTAT / rho
     enddo
!!$acc end parallel

     ! implement Dirichlet boundary conditions on the six edges of the grid

     ! xmin
!!$acc kernels
!$omp target teams loop collapse(2)
     do j=1,NY
        do k=1,NZ
           vx_1(1,j,k) = 0.d0
           vy_1(1,j,k) = 0.d0
           vz_1(1,j,k) = 0.d0
           
           vx_2(1,j,k) = 0.d0
           vy_2(1,j,k) = 0.d0
           vz_2(1,j,k) = 0.d0
           
           vx_3(1,j,k) = 0.d0
           vy_3(1,j,k) = 0.d0
           vz_3(1,j,k) = 0.d0

           vx_1(NX,j,k) = 0.d0
           vy_1(NX,j,k) = 0.d0
           vz_1(NX,j,k) = 0.d0
           
           vx_2(NX,j,k) = 0.d0
           vy_2(NX,j,k) = 0.d0
           vz_2(NX,j,k) = 0.d0
           
           vx_3(NX,j,k) = 0.d0
           vy_3(NX,j,k) = 0.d0
           vz_3(NX,j,k) = 0.d0
        enddo
     enddo

 
!$omp target teams loop collapse(2)
     do i=1,NX
        do k=1,NZ
           ! ymin
           vx_1(i,1,k) = 0.d0
           vy_1(i,1,k) = 0.d0
           vz_1(i,1,k) = 0.d0
          
           vx_2(i,1,k) = 0.d0
           vy_2(i,1,k) = 0.d0
           vz_2(i,1,k) = 0.d0
           
           vx_3(i,1,k) = 0.d0
           vy_3(i,1,k) = 0.d0
           vz_3(i,1,k) = 0.d0
           
           ! ymax
           vx_1(i,NY,k) = 0.d0
           vy_1(i,NY,k) = 0.d0
           vz_1(i,NY,k) = 0.d0
           
           vx_2(i,NY,k) = 0.d0
           vy_2(i,NY,k) = 0.d0
           vz_2(i,NY,k) = 0.d0
           
           vx_3(i,NY,k) = 0.d0
           vy_3(i,NY,k) = 0.d0
           vz_3(i,NY,k) = 0.d0
        enddo
     enddo
 
!$omp target teams loop collapse(2)
     do i=1,NX
        do j=1,NY
           ! zmin
           vx_1(i,j,1) = 0.d0
           vy_1(i,j,1) = 0.d0
           vz_1(i,j,1) = 0.d0
     
           vx_2(i,j,1) = 0.d0
           vy_2(i,j,1) = 0.d0
           vz_2(i,j,1) = 0.d0
           
           vx_3(i,j,1) = 0.d0
           vy_3(i,j,1) = 0.d0
           vz_3(i,j,1) = 0.d0
           
           ! zmax
           vx_1(i,j,NZ) = 0.d0
           vy_1(i,j,NZ) = 0.d0
           vz_1(i,j,NZ) = 0.d0
           
           vx_2(i,j,NZ) = 0.d0
           vy_2(i,j,NZ) = 0.d0
           vz_2(i,j,NZ) = 0.d0
           
           vx_3(i,j,NZ) = 0.d0
           vy_3(i,j,NZ) = 0.d0
           vz_3(i,j,NZ) = 0.d0
        enddo
     enddo

     ! store seismograms
!$omp target teams loop
     do irec = 1,NREC
        sisvx(it,irec) = vx_1(ix_rec(irec),iy_rec(irec),iz_rec(irec)) + &
             vx_2(ix_rec(irec),iy_rec(irec),iz_rec(irec)) + vx_3(ix_rec(irec),iy_rec(irec),iz_rec(irec))
        sisvy(it,irec) = vy_1(ix_rec(irec),iy_rec(irec),iz_rec(irec)) + &
             vy_2(ix_rec(irec),iy_rec(irec),iz_rec(irec)) + vy_3(ix_rec(irec),iy_rec(irec),iz_rec(irec))
     enddo
!!$acc end kernels

     ! compute total energy in the medium (without the PML layers)

     total_energy_kinetic = ZERO
     total_energy_potential = ZERO


     !!$acc kernels
!$omp target teams loop collapse(3)
     do k = NPOINTS_PML+1, NZ-NPOINTS_PML
        do j = NPOINTS_PML+1, NY-NPOINTS_PML
           do i = NPOINTS_PML+1, NX-NPOINTS_PML

              ! compute kinetic energy first, defined as 1/2 rho ||v||^2
              ! in principle we should use rho_half_x_half_y instead of rho for vy
              ! in order to interpolate density at the right location in the staggered grid cell
              ! but in a homogeneous medium we can safely ignore it
              total_energy_kinetic = total_energy_kinetic + 0.5d0 * rho*( &
                   (vx_1(i,j,k) + vx_2(i,j,k) + vx_3(i,j,k))**2 + &
                   (vy_1(i,j,k) + vy_2(i,j,k) + vy_3(i,j,k))**2 + &
                   (vz_1(i,j,k) + vz_2(i,j,k) + vz_3(i,j,k))**2)

              ! add potential energy, defined as 1/2 epsilon_ij sigma_ij
              ! in principle we should interpolate the medium parameters at the right location
              ! in the staggered grid cell but in a homogeneous medium we can safely ignore it

              ! compute total field from split components
              sigmaxx_total = sigmaxx_1(i,j,k) + sigmaxx_2(i,j,k) + sigmaxx_3(i,j,k)
              sigmayy_total = sigmayy_1(i,j,k) + sigmayy_2(i,j,k) + sigmayy_3(i,j,k)
              sigmazz_total = sigmazz_1(i,j,k) + sigmazz_2(i,j,k) + sigmazz_3(i,j,k)
              sigmaxy_total = sigmaxy_1(i,j,k) + sigmaxy_2(i,j,k)
              sigmaxz_total = sigmaxz_1(i,j,k) + sigmaxz_3(i,j,k)
              sigmayz_total = sigmayz_2(i,j,k) + sigmayz_3(i,j,k)

              epsilon_xx = ((lambda + 2.d0*mu) * sigmaxx_total - lambda * sigmayy_total &
	             -lambda*sigmazz_total) / (4.d0 * mu * (lambda + mu))
              epsilon_yy = ((lambda + 2.d0*mu) * sigmayy_total - lambda * sigmaxx_total &
	              -lambda*sigmazz_total) / (4.d0 * mu * (lambda + mu))
              epsilon_zz = ((lambda + 2.d0*mu) * sigmazz_total - lambda * sigmaxx_total &
	              -lambda*sigmayy_total) / (4.d0 * mu * (lambda + mu))
              epsilon_xy = sigmaxy_total / (2.d0 * mu)
              epsilon_xz = sigmaxz_total / (2.d0 * mu)
              epsilon_yz = sigmayz_total / (2.d0 * mu)

              total_energy_potential = total_energy_potential + &
                   0.5d0 * (epsilon_xx * sigmaxx_total + epsilon_yy * sigmayy_total + &
                   epsilon_yy * sigmayy_total+ 2.d0 * epsilon_xy * sigmaxy_total + &
                   2.d0*epsilon_xz * sigmaxz_total+2.d0*epsilon_yz * sigmayz_total)

           enddo
        enddo
     enddo
     !!$acc end kernels

     total_energy(it) = total_energy_kinetic + total_energy_potential

     ! output information
     if(mod(it,IT_DISPLAY) == 0 .or. it == 5) then

        !$acc update host(vx_1,vx_2,vx_3,vy_1,vy_2,vy_3,vz_1,vz_2,vz_3,sisvx,sisvy)

        Vsolidnorm = maxval(sqrt((vx_1 + vx_2 + vx_3)**2 + (vy_1 + vy_2 + vy_3)**2+(vz_1 + vz_2 + vz_3)**2))

        print *,'Time step # ',it
        print *,'Time: ',sngl((it-1)*DELTAT),' seconds'
        print *,'Max norm velocity vector V (m/s) = ',Vsolidnorm
        print *,'Total energy = ',total_energy(it)
        ! check stability of the code, exit if unstable
        if(Vsolidnorm > STABILITY_THRESHOLD) stop 'code became unstable and blew up'
        iplane=1

        ! count elapsed wall-clock time
        call date_and_time(datein,timein,zone,time_values)
        ! time_values(3): day of the month
        ! time_values(5): hour of the day
        ! time_values(6): minutes of the hour
        ! time_values(7): seconds of the minute
        ! time_values(8): milliseconds of the second
        ! this fails if we cross the end of the month
        time_end = 86400.d0*time_values(3) + 3600.d0*time_values(5) + &
             60.d0*time_values(6) + time_values(7) + time_values(8) / 1000.d0

        ! elapsed time since beginning of the simulation
        tCPU = time_end - time_start
        int_tCPU = int(tCPU)
        ihours = int_tCPU / 3600
        iminutes = (int_tCPU - 3600*ihours) / 60
        iseconds = int_tCPU - 3600*ihours - 60*iminutes
        write(*,*) 'Elapsed time in seconds = ',tCPU
        write(*,"(' Elapsed time in hh:mm:ss = ',i4,' h ',i2.2,' m ',i2.2,' s')") ihours,iminutes,iseconds
        write(*,*) 'Mean elapsed time per time step in seconds = ',tCPU/dble(it)
        write(*,*)

        ! write time stamp file to give information about progression of simulation
        write(outputname,"('timestamp',i6.6)") it
        open(unit=IOUT,file=outputname,status='unknown')
        write(IOUT,*) 'Time step # ',it
        write(IOUT,*) 'Time: ',sngl((it-1)*DELTAT),' seconds'
        write(IOUT,*) 'Max norm velocity vector V (m/s) = ',Vsolidnorm
        write(IOUT,*) 'Total energy = ',total_energy(it)
        write(IOUT,*) 'Elapsed time in seconds = ',tCPU
        write(IOUT,"(' Elapsed time in hh:mm:ss = ',i4,' h ',i2.2,' m ',i2.2,' s')") ihours,iminutes,iseconds
        write(IOUT,*) 'Mean elapsed time per time step in seconds = ',tCPU/dble(it)
        close(IOUT)

        ! save seismograms
        print *,'saving seismograms'
        print *
        call write_seismograms(sisvx,sisvy,NSTEP,NREC,DELTAT)

        call create_color_image(vx_1(:,:,NZ/2) + vx_2(:,:,NZ/2) + vx_3(:,:,NZ/2),NX,NY,it,ISOURCE,JSOURCE,ix_rec,iy_rec,nrec, &
             NPOINTS_PML,.true.,.true.,.true.,.true.,1)

        call create_color_image(vy_1(:,:,NZ/2) + vy_2(:,:,NZ/2) +vy_3(:,:,NZ/2),NX,NY,it,ISOURCE,JSOURCE,ix_rec,iy_rec,nrec, &
             NPOINTS_PML,.true.,.true.,.true.,.true.,2)

     endif

  enddo   ! end of time loop

!!$acc end data
!$omp end target data

  ! save seismograms
  call write_seismograms(sisvx,sisvy,NSTEP,NREC,DELTAT)

  ! save total energy
  open(unit=20,file=energyfile,status='unknown')
  do it = 1,NSTEP
     write(20,'(2G20.10)') sngl(dble(it-1)*DELTAT),total_energy(it)
  enddo
  close(20)


  ! create script for Gnuplot for total energy
  open(unit=20,file='plot_energy',status='unknown')
  write(20,*) '# set term x11'
  write(20,*) 'set term postscript landscape monochrome dashed "Helvetica" 22'
  write(20,*)
  write(20,*) 'set xlabel "Time (s)"'
  write(20,*) 'set ylabel "Total energy"'
  write(20,*)
  write(20,*) 'set output "collino3D_total_energy_semilog.eps"'
  write(20,*) 'set logscale y'
  write(20,*) 'plot "energy.dat" t ''Total energy'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)
  close(20)

  ! create script for Gnuplot
  open(unit=20,file='plotgnu',status='unknown')
  write(20,*) 'set term x11'
  write(20,*) '# set term postscript landscape monochrome dashed "Helvetica" 22'
  write(20,*)
  write(20,*) 'set xlabel "Time (s)"'
  write(20,*) 'set ylabel "Amplitude (m / s)"'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vx_receiver_001.eps"'
  write(20,*) 'plot "Vx_file_001.dat" t ''Vx C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vy_receiver_001.eps"'
  write(20,*) 'plot "Vy_file_001.dat" t ''Vy C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vz_receiver_001.eps"'
  write(20,*) 'plot "Vz_file_001.dat" t ''Vz C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vx_receiver_002.eps"'
  write(20,*) 'plot "Vx_file_002.dat" t ''Vx C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vy_receiver_002.eps"'
  write(20,*) 'plot "Vy_file_002.dat" t ''Vy C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  write(20,*) 'set output "v_sigma_Vz_receiver_002.eps"'
  write(20,*) 'plot "Vz_file_002.dat" t ''Vz C-PML'' w l lc 1'
  write(20,*) 'pause -1 "Hit any key..."'
  write(20,*)

  close(20)

  print *
  print *,'End of the simulation'
  print *

  deallocate (vx_1,vx_2,vx_3,&
       vy_1,vy_2,vy_3,&
       vz_1,vz_2,vz_3,&
       sigmaxx_1,sigmaxx_2,sigmaxx_3,&
       sigmayy_1,sigmayy_2,sigmayy_3,&
       sigmazz_1,sigmazz_2,sigmazz_3,&
       sigmaxy_1,sigmaxy_2,&
       sigmaxz_1,sigmaxz_3,&
       sigmayz_2,sigmayz_3)
  deallocate(dx_over_two,dx_half_over_two)
  deallocate(dy_over_two,dy_half_over_two)
  deallocate(dz_over_two,dz_half_over_two)
  deallocate(ix_rec,iy_rec,iz_rec)	
  deallocate(xrec,yrec,zrec)
  deallocate(sisvx,sisvy)
  deallocate(total_energy)

end program seismic_PML_Collino_3D_iso

!----
!----  save the seismograms in ASCII text format
!----

subroutine write_seismograms(sisvx,sisvy,nt,nrec,DELTAT)

  implicit none

  integer nt,nrec
  double precision DELTAT

  double precision sisvx(nt,nrec)
  double precision sisvy(nt,nrec)

  integer irec,it

  character(len=100) file_name

  ! X component
  do irec=1,nrec
     write(file_name,"('Vx_file_',i3.3,'.dat')") irec
     open(unit=11,file=file_name,status='unknown')
     do it=1,nt
        write(11,*) sngl(dble(it-1)*DELTAT),' ',sngl(sisvx(it,irec))
     enddo
     close(11)
  enddo

  ! Y component
  do irec=1,nrec
     write(file_name,"('Vy_file_',i3.3,'.dat')") irec
     open(unit=11,file=file_name,status='unknown')
     do it=1,nt
        write(11,*) sngl(dble(it-1)*DELTAT),' ',sngl(sisvy(it,irec))
     enddo
     close(11)
  enddo

end subroutine write_seismograms

!----
!----  routine to create a color image of a given vector component
!----  the image is created in PNM format and then converted to GIF
!----

subroutine create_color_image(image_data_2D,NX,NY,it,ISOURCE,JSOURCE,ix_rec,iy_rec,nrec, &
     NPOINTS_PML,USE_PML_XMIN,USE_PML_XMAX,USE_PML_YMIN,USE_PML_YMAX,field_number)

  implicit none

  ! non linear display to enhance small amplitudes for graphics
  double precision, parameter :: POWER_DISPLAY = 0.30d0

  ! amplitude threshold above which we draw the color point
  double precision, parameter :: cutvect = 0.01d0

  ! use black or white background for points that are below the threshold
  logical, parameter :: WHITE_BACKGROUND = .true.

  ! size of cross and square in pixels drawn to represent the source and the receivers
  integer, parameter :: width_cross = 5, thickness_cross = 1, size_square = 3

  integer NX,NY,it,field_number,ISOURCE,JSOURCE,NPOINTS_PML,nrec
  logical USE_PML_XMIN,USE_PML_XMAX,USE_PML_YMIN,USE_PML_YMAX

  double precision, dimension(NX,NY) :: image_data_2D

  integer, dimension(nrec) :: ix_rec,iy_rec

  integer :: ix,iy,irec

  character(len=100) :: file_name,system_command

  integer :: R, G, B

  double precision :: normalized_value,max_amplitude

  ! open image file and create system command to convert image to more convenient format
  ! use the "convert" command from ImageMagick http://www.imagemagick.org
  if(field_number == 1) then
     write(file_name,"('image',i6.6,'_Vx.pnm')") it
     write(system_command,"('convert image',i6.6,'_Vx.pnm image',i6.6,'_Vx.gif ; rm image',i6.6,'_Vx.pnm')") it,it,it
  else if(field_number == 2) then
     write(file_name,"('image',i6.6,'_Vy.pnm')") it
     write(system_command,"('convert image',i6.6,'_Vy.pnm image',i6.6,'_Vy.gif ; rm image',i6.6,'_Vy.pnm')") it,it,it
  endif

  open(unit=27, file=file_name, status='unknown')

  write(27,"('P3')") ! write image in PNM P3 format

  write(27,*) NX,NY ! write image size
  write(27,*) '255' ! maximum value of each pixel color

  ! compute maximum amplitude
  max_amplitude = maxval(abs(image_data_2D))

  ! image starts in upper-left corner in PNM format
  do iy=NY,1,-1
     do ix=1,NX

        ! define data as vector component normalized to [-1:1] and rounded to nearest integer
        ! keeping in mind that amplitude can be negative
        normalized_value = image_data_2D(ix,iy) / max_amplitude

        ! suppress values that are outside [-1:+1] to avoid small edge effects
        if(normalized_value < -1.d0) normalized_value = -1.d0
        if(normalized_value > 1.d0) normalized_value = 1.d0

        ! draw an orange cross to represent the source
        if((ix >= ISOURCE - width_cross .and. ix <= ISOURCE + width_cross .and. &
             iy >= JSOURCE - thickness_cross .and. iy <= JSOURCE + thickness_cross) .or. &
             (ix >= ISOURCE - thickness_cross .and. ix <= ISOURCE + thickness_cross .and. &
             iy >= JSOURCE - width_cross .and. iy <= JSOURCE + width_cross)) then
           R = 255
           G = 157
           B = 0

           ! display two-pixel-thick black frame around the image
        else if(ix <= 2 .or. ix >= NX-1 .or. iy <= 2 .or. iy >= NY-1) then
           R = 0
           G = 0
           B = 0

           ! display edges of the PML layers
        else if((USE_PML_XMIN .and. ix == NPOINTS_PML) .or. &
             (USE_PML_XMAX .and. ix == NX - NPOINTS_PML) .or. &
             (USE_PML_YMIN .and. iy == NPOINTS_PML) .or. &
             (USE_PML_YMAX .and. iy == NY - NPOINTS_PML)) then
           R = 255
           G = 150
           B = 0

           ! suppress all the values that are below the threshold
        else if(abs(image_data_2D(ix,iy)) <= max_amplitude * cutvect) then

           ! use a black or white background for points that are below the threshold
           if(WHITE_BACKGROUND) then
              R = 255
              G = 255
              B = 255
           else
              R = 0
              G = 0
              B = 0
           endif

           ! represent regular image points using red if value is positive, blue if negative
        else if(normalized_value >= 0.d0) then
           R = nint(255.d0*normalized_value**POWER_DISPLAY)
           G = 0
           B = 0
        else
           R = 0
           G = 0
           B = nint(255.d0*abs(normalized_value)**POWER_DISPLAY)
        endif

        ! draw a green square to represent the receivers
        do irec = 1,nrec
           if((ix >= ix_rec(irec) - size_square .and. ix <= ix_rec(irec) + size_square .and. &
                iy >= iy_rec(irec) - size_square .and. iy <= iy_rec(irec) + size_square) .or. &
                (ix >= ix_rec(irec) - size_square .and. ix <= ix_rec(irec) + size_square .and. &
                iy >= iy_rec(irec) - size_square .and. iy <= iy_rec(irec) + size_square)) then
              ! use dark green color
              R = 30
              G = 180
              B = 60
           endif
        enddo

        ! write color pixel
        write(27,"(i3,' ',i3,' ',i3)") R,G,B

     enddo
  enddo

  ! close file
  close(27)

  ! call the system to convert image to GIF (can be commented out if "call system" is missing in your compiler)
  ! call system(system_command)

end subroutine create_color_image

!
! CeCILL FREE SOFTWARE LICENSE AGREEMENT
!
!     Notice
!
! This Agreement is a Free Software license agreement that is the result
! of discussions between its authors in order to ensure compliance with
! the two main principles guiding its drafting:
!
!     * firstly, compliance with the principles governing the distribution
!       of Free Software: access to source code, broad rights granted to
!       users,
!     * secondly, the election of a governing law, French law, with which
!       it is conformant, both as regards the law of torts and
!       intellectual property law, and the protection that it offers to
!       both authors and holders of the economic rights over software.
!
! The authors of the CeCILL (for Ce[a] C[nrs] I[nria] L[ogiciel] L[ibre])
! license are:
!
! Commissariat a l'Energie Atomique - CEA, a public scientific, technical
! and industrial research establishment, having its principal place of
! business at 25 rue Leblanc, immeuble Le Ponant D, 75015 Paris, France.
!
! Centre National de la Recherche Scientifique - CNRS, a public scientific
! and technological establishment, having its principal place of business
! at 3 rue Michel-Ange, 75794 Paris cedex 16, France.
!
! Institut National de Recherche en Informatique et en Automatique -
! INRIA, a public scientific and technological establishment, having its
! principal place of business at Domaine de Voluceau, Rocquencourt, BP
! 105, 78153 Le Chesnay cedex, France.
!
!     Preamble
!
! The purpose of this Free Software license agreement is to grant users
! the right to modify and redistribute the software governed by this
! license within the framework of an open source distribution model.
!
! The exercising of these rights is conditional upon certain obligations
! for users so as to preserve this status for all subsequent redistributions.
!
! In consideration of access to the source code and the rights to copy,
! modify and redistribute granted by the license, users are provided only
! with a limited warranty and the software's author, the holder of the
! economic rights, and the successive licensors only have limited liability.
!
! In this respect, the risks associated with loading, using, modifying
! and/or developing or reproducing the software by the user are brought to
! the user's attention, given its Free Software status, which may make it
! complicated to use, with the result that its use is reserved for
! developers and experienced professionals having in-depth computer
! knowledge. Users are therefore encouraged to load and test the
! suitability of the software as regards their requirements in conditions
! enabling the security of their systems and/or data to be ensured and,
! more generally, to use and operate it in the same conditions of
! security. This Agreement may be freely reproduced and published,
! provided it is not altered, and that no provisions are either added or
! removed herefrom.
!
! This Agreement may apply to any or all software for which the holder of
! the economic rights decides to submit the use thereof to its provisions.
!
!     Article 1 - DEFINITIONS
!
! For the purpose of this Agreement, when the following expressions
! commence with a capital letter, they shall have the following meaning:
!
! Agreement: means this license agreement, and its possible subsequent
! versions and annexes.
!
! Software: means the software in its Object Code and/or Source Code form
! and, where applicable, its documentation, "as is" when the Licensee
! accepts the Agreement.
!
! Initial Software: means the Software in its Source Code and possibly its
! Object Code form and, where applicable, its documentation, "as is" when
! it is first distributed under the terms and conditions of the Agreement.
!
! Modified Software: means the Software modified by at least one
! Contribution.
!
! Source Code: means all the Software's instructions and program lines to
! which access is required so as to modify the Software.
!
! Object Code: means the binary files originating from the compilation of
! the Source Code.
!
! Holder: means the holder(s) of the economic rights over the Initial
! Software.
!
! Licensee: means the Software user(s) having accepted the Agreement.
!
! Contributor: means a Licensee having made at least one Contribution.
!
! Licensor: means the Holder, or any other individual or legal entity, who
! distributes the Software under the Agreement.
!
! Contribution: means any or all modifications, corrections, translations,
! adaptations and/or new functions integrated into the Software by any or
! all Contributors, as well as any or all Internal Modules.
!
! Module: means a set of sources files including their documentation that
! enables supplementary functions or services in addition to those offered
! by the Software.
!
! External Module: means any or all Modules, not derived from the
! Software, so that this Module and the Software run in separate address
! spaces, with one calling the other when they are run.
!
! Internal Module: means any or all Module, connected to the Software so
! that they both execute in the same address space.
!
! GNU GPL: means the GNU General Public License version 2 or any
! subsequent version, as published by the Free Software Foundation Inc.
!
! Parties: mean both the Licensee and the Licensor.
!
! These expressions may be used both in singular and plural form.
!
!     Article 2 - PURPOSE
!
! The purpose of the Agreement is the grant by the Licensor to the
! Licensee of a non-exclusive, transferable and worldwide license for the
! Software as set forth in Article 5 hereinafter for the whole term of the
! protection granted by the rights over said Software.
!
!     Article 3 - ACCEPTANCE
!
! 3.1 The Licensee shall be deemed as having accepted the terms and
! conditions of this Agreement upon the occurrence of the first of the
! following events:
!
!     * (i) loading the Software by any or all means, notably, by
!       downloading from a remote server, or by loading from a physical
!       medium;
!     * (ii) the first time the Licensee exercises any of the rights
!       granted hereunder.
!
! 3.2 One copy of the Agreement, containing a notice relating to the
! characteristics of the Software, to the limited warranty, and to the
! fact that its use is restricted to experienced users has been provided
! to the Licensee prior to its acceptance as set forth in Article 3.1
! hereinabove, and the Licensee hereby acknowledges that it has read and
! understood it.
!
!     Article 4 - EFFECTIVE DATE AND TERM
!
!       4.1 EFFECTIVE DATE
!
! The Agreement shall become effective on the date when it is accepted by
! the Licensee as set forth in Article 3.1.
!
!       4.2 TERM
!
! The Agreement shall remain in force for the entire legal term of
! protection of the economic rights over the Software.
!
!     Article 5 - SCOPE OF RIGHTS GRANTED
!
! The Licensor hereby grants to the Licensee, who accepts, the following
! rights over the Software for any or all use, and for the term of the
! Agreement, on the basis of the terms and conditions set forth hereinafter.
!
! Besides, if the Licensor owns or comes to own one or more patents
! protecting all or part of the functions of the Software or of its
! components, the Licensor undertakes not to enforce the rights granted by
! these patents against successive Licensees using, exploiting or
! modifying the Software. If these patents are transferred, the Licensor
! undertakes to have the transferees subscribe to the obligations set
! forth in this paragraph.
!
!       5.1 RIGHT OF USE
!
! The Licensee is authorized to use the Software, without any limitation
! as to its fields of application, with it being hereinafter specified
! that this comprises:
!
!    1. permanent or temporary reproduction of all or part of the Software
!       by any or all means and in any or all form.
!
!    2. loading, displaying, running, or storing the Software on any or
!       all medium.
!
!    3. entitlement to observe, study or test its operation so as to
!       determine the ideas and principles behind any or all constituent
!       elements of said Software. This shall apply when the Licensee
!       carries out any or all loading, displaying, running, transmission
!       or storage operation as regards the Software, that it is entitled
!       to carry out hereunder.
!
!       5.2 ENTITLEMENT TO MAKE CONTRIBUTIONS
!
! The right to make Contributions includes the right to translate, adapt,
! arrange, or make any or all modifications to the Software, and the right
! to reproduce the resulting software.
!
! The Licensee is authorized to make any or all Contributions to the
! Software provided that it includes an explicit notice that it is the
! author of said Contribution and indicates the date of the creation thereof.
!
!       5.3 RIGHT OF DISTRIBUTION
!
! In particular, the right of distribution includes the right to publish,
! transmit and communicate the Software to the general public on any or
! all medium, and by any or all means, and the right to market, either in
! consideration of a fee, or free of charge, one or more copies of the
! Software by any means.
!
! The Licensee is further authorized to distribute copies of the modified
! or unmodified Software to third parties according to the terms and
! conditions set forth hereinafter.
!
!         5.3.1 DISTRIBUTION OF SOFTWARE WITHOUT MODIFICATION
!
! The Licensee is authorized to distribute true copies of the Software in
! Source Code or Object Code form, provided that said distribution
! complies with all the provisions of the Agreement and is accompanied by:
!
!    1. a copy of the Agreement,
!
!    2. a notice relating to the limitation of both the Licensor's
!       warranty and liability as set forth in Articles 8 and 9,
!
! and that, in the event that only the Object Code of the Software is
! redistributed, the Licensee allows future Licensees unhindered access to
! the full Source Code of the Software by indicating how to access it, it
! being understood that the additional cost of acquiring the Source Code
! shall not exceed the cost of transferring the data.
!
!         5.3.2 DISTRIBUTION OF MODIFIED SOFTWARE
!
! When the Licensee makes a Contribution to the Software, the terms and
! conditions for the distribution of the resulting Modified Software
! become subject to all the provisions of this Agreement.
!
! The Licensee is authorized to distribute the Modified Software, in
! source code or object code form, provided that said distribution
! complies with all the provisions of the Agreement and is accompanied by:
!
!    1. a copy of the Agreement,
!
!    2. a notice relating to the limitation of both the Licensor's
!       warranty and liability as set forth in Articles 8 and 9,
!
! and that, in the event that only the object code of the Modified
! Software is redistributed, the Licensee allows future Licensees
! unhindered access to the full source code of the Modified Software by
! indicating how to access it, it being understood that the additional
! cost of acquiring the source code shall not exceed the cost of
! transferring the data.
!
!         5.3.3 DISTRIBUTION OF EXTERNAL MODULES
!
! When the Licensee has developed an External Module, the terms and
! conditions of this Agreement do not apply to said External Module, that
! may be distributed under a separate license agreement.
!
!         5.3.4 COMPATIBILITY WITH THE GNU GPL
!
! The Licensee can include a code that is subject to the provisions of one
! of the versions of the GNU GPL in the Modified or unmodified Software,
! and distribute that entire code under the terms of the same version of
! the GNU GPL.
!
! The Licensee can include the Modified or unmodified Software in a code
! that is subject to the provisions of one of the versions of the GNU GPL,
! and distribute that entire code under the terms of the same version of
! the GNU GPL.
!
!     Article 6 - INTELLECTUAL PROPERTY
!
!       6.1 OVER THE INITIAL SOFTWARE
!
! The Holder owns the economic rights over the Initial Software. Any or
! all use of the Initial Software is subject to compliance with the terms
! and conditions under which the Holder has elected to distribute its work
! and no one shall be entitled to modify the terms and conditions for the
! distribution of said Initial Software.
!
! The Holder undertakes that the Initial Software will remain ruled at
! least by this Agreement, for the duration set forth in Article 4.2.
!
!       6.2 OVER THE CONTRIBUTIONS
!
! The Licensee who develops a Contribution is the owner of the
! intellectual property rights over this Contribution as defined by
! applicable law.
!
!       6.3 OVER THE EXTERNAL MODULES
!
! The Licensee who develops an External Module is the owner of the
! intellectual property rights over this External Module as defined by
! applicable law and is free to choose the type of agreement that shall
! govern its distribution.
!
!       6.4 JOINT PROVISIONS
!
! The Licensee expressly undertakes:
!
!    1. not to remove, or modify, in any manner, the intellectual property
!       notices attached to the Software;
!
!    2. to reproduce said notices, in an identical manner, in the copies
!       of the Software modified or not.
!
! The Licensee undertakes not to directly or indirectly infringe the
! intellectual property rights of the Holder and/or Contributors on the
! Software and to take, where applicable, vis-a-vis its staff, any and all
! measures required to ensure respect of said intellectual property rights
! of the Holder and/or Contributors.
!
!     Article 7 - RELATED SERVICES
!
! 7.1 Under no circumstances shall the Agreement oblige the Licensor to
! provide technical assistance or maintenance services for the Software.
!
! However, the Licensor is entitled to offer this type of services. The
! terms and conditions of such technical assistance, and/or such
! maintenance, shall be set forth in a separate instrument. Only the
! Licensor offering said maintenance and/or technical assistance services
! shall incur liability therefor.
!
! 7.2 Similarly, any Licensor is entitled to offer to its licensees, under
! its sole responsibility, a warranty, that shall only be binding upon
! itself, for the redistribution of the Software and/or the Modified
! Software, under terms and conditions that it is free to decide. Said
! warranty, and the financial terms and conditions of its application,
! shall be subject of a separate instrument executed between the Licensor
! and the Licensee.
!
!     Article 8 - LIABILITY
!
! 8.1 Subject to the provisions of Article 8.2, the Licensee shall be
! entitled to claim compensation for any direct loss it may have suffered
! from the Software as a result of a fault on the part of the relevant
! Licensor, subject to providing evidence thereof.
!
! 8.2 The Licensor's liability is limited to the commitments made under
! this Agreement and shall not be incurred as a result of in particular:
! (i) loss due the Licensee's total or partial failure to fulfill its
! obligations, (ii) direct or consequential loss that is suffered by the
! Licensee due to the use or performance of the Software, and (iii) more
! generally, any consequential loss. In particular the Parties expressly
! agree that any or all pecuniary or business loss (i.e. loss of data,
! loss of profits, operating loss, loss of customers or orders,
! opportunity cost, any disturbance to business activities) or any or all
! legal proceedings instituted against the Licensee by a third party,
! shall constitute consequential loss and shall not provide entitlement to
! any or all compensation from the Licensor.
!
!     Article 9 - WARRANTY
!
! 9.1 The Licensee acknowledges that the scientific and technical
! state-of-the-art when the Software was distributed did not enable all
! possible uses to be tested and verified, nor for the presence of
! possible defects to be detected. In this respect, the Licensee's
! attention has been drawn to the risks associated with loading, using,
! modifying and/or developing and reproducing the Software which are
! reserved for experienced users.
!
! The Licensee shall be responsible for verifying, by any or all means,
! the suitability of the product for its requirements, its good working
! order, and for ensuring that it shall not cause damage to either persons
! or properties.
!
! 9.2 The Licensor hereby represents, in good faith, that it is entitled
! to grant all the rights over the Software (including in particular the
! rights set forth in Article 5).
!
! 9.3 The Licensee acknowledges that the Software is supplied "as is" by
! the Licensor without any other express or tacit warranty, other than
! that provided for in Article 9.2 and, in particular, without any warranty
! as to its commercial value, its secured, safe, innovative or relevant
! nature.
!
! Specifically, the Licensor does not warrant that the Software is free
! from any error, that it will operate without interruption, that it will
! be compatible with the Licensee's own equipment and software
! configuration, nor that it will meet the Licensee's requirements.
!
! 9.4 The Licensor does not either expressly or tacitly warrant that the
! Software does not infringe any third party intellectual property right
! relating to a patent, software or any other property right. Therefore,
! the Licensor disclaims any and all liability towards the Licensee
! arising out of any or all proceedings for infringement that may be
! instituted in respect of the use, modification and redistribution of the
! Software. Nevertheless, should such proceedings be instituted against
! the Licensee, the Licensor shall provide it with technical and legal
! assistance for its defense. Such technical and legal assistance shall be
! decided on a case-by-case basis between the relevant Licensor and the
! Licensee pursuant to a memorandum of understanding. The Licensor
! disclaims any and all liability as regards the Licensee's use of the
! name of the Software. No warranty is given as regards the existence of
! prior rights over the name of the Software or as regards the existence
! of a trademark.
!
!     Article 10 - TERMINATION
!
! 10.1 In the event of a breach by the Licensee of its obligations
! hereunder, the Licensor may automatically terminate this Agreement
! thirty (30) days after notice has been sent to the Licensee and has
! remained ineffective.
!
! 10.2 A Licensee whose Agreement is terminated shall no longer be
! authorized to use, modify or distribute the Software. However, any
! licenses that it may have granted prior to termination of the Agreement
! shall remain valid subject to their having been granted in compliance
! with the terms and conditions hereof.
!
!     Article 11 - MISCELLANEOUS
!
!       11.1 EXCUSABLE EVENTS
!
! Neither Party shall be liable for any or all delay, or failure to
! perform the Agreement, that may be attributable to an event of force
! majeure, an act of God or an outside cause, such as defective
! functioning or interruptions of the electricity or telecommunications
! networks, network paralysis following a virus attack, intervention by
! government authorities, natural disasters, water damage, earthquakes,
! fire, explosions, strikes and labor unrest, war, etc.
!
! 11.2 Any failure by either Party, on one or more occasions, to invoke
! one or more of the provisions hereof, shall under no circumstances be
! interpreted as being a waiver by the interested Party of its right to
! invoke said provision(s) subsequently.
!
! 11.3 The Agreement cancels and replaces any or all previous agreements,
! whether written or oral, between the Parties and having the same
! purpose, and constitutes the entirety of the agreement between said
! Parties concerning said purpose. No supplement or modification to the
! terms and conditions hereof shall be effective as between the Parties
! unless it is made in writing and signed by their duly authorized
! representatives.
!
! 11.4 In the event that one or more of the provisions hereof were to
! conflict with a current or future applicable act or legislative text,
! said act or legislative text shall prevail, and the Parties shall make
! the necessary amendments so as to comply with said act or legislative
! text. All other provisions shall remain effective. Similarly, invalidity
! of a provision of the Agreement, for any reason whatsoever, shall not
! cause the Agreement as a whole to be invalid.
!
!       11.5 LANGUAGE
!
! The Agreement is drafted in both French and English and both versions
! are deemed authentic.
!
!     Article 12 - NEW VERSIONS OF THE AGREEMENT
!
! 12.1 Any person is authorized to duplicate and distribute copies of this
! Agreement.
!
! 12.2 So as to ensure coherence, the wording of this Agreement is
! protected and may only be modified by the authors of the License, who
! reserve the right to periodically publish updates or new versions of the
! Agreement, each with a separate number. These subsequent versions may
! address new issues encountered by Free Software.
!
! 12.3 Any Software distributed under a given version of the Agreement may
! only be subsequently distributed under the same version of the Agreement
! or a subsequent version, subject to the provisions of Article 5.3.4.
!
!     Article 13 - GOVERNING LAW AND JURISDICTION
!
! 13.1 The Agreement is governed by French law. The Parties agree to
! endeavor to seek an amicable solution to any disagreements or disputes
! that may arise during the performance of the Agreement.
!
! 13.2 Failing an amicable solution within two (2) months as from their
! occurrence, and unless emergency proceedings are necessary, the
! disagreements or disputes shall be referred to the Paris Courts having
! jurisdiction, by the more diligent Party.
!
! Version 2.0 dated 2006-09-05.
!

program main
#ifdef _CUDA  
  use cudafor
#endif
  implicit none
  integer, parameter :: n=8
  real :: a(n), b(n)
#ifdef _CUDA
  attributes(managed) :: a, b
#endif
  integer :: i

  !$cuf kernel do <<<*,*>>> 
  do i = 1, n
     a(i) = i+1
  enddo

  !$cuf kernel do <<<*,*>>>
  do i = 1, n
     b(i) = a(i)+1
  enddo

#ifdef _CUDA
  i = cudaDeviceSynchronize()
  print *, 'GPU version'
#endif
  
  print *, a
  print *, b
end program main
